angular.module('jobmapp.generics.directives')
.directive('distance', function () {
  var directionsDisplay;
  var directionsService;
  var mapx;
  var init = function() {
    mapx = new google.maps.Map(document.getElementById("small-map"));
    directionsService = new google.maps.DirectionsService();
    directionsDisplay = new google.maps.DirectionsRenderer();
  }
  var calcRoute = function(ori,dest,cb) {
    // reset map:
    if (directionsDisplay != null) { 
      directionsDisplay.setMap(null);
      directionsDisplay.setMap(mapx); // map should be already initialized.    
    }
    var request = {
        origin:ori,
        destination:dest,
        travelMode: google.maps.DirectionsTravelMode.DRIVING
    };
    directionsService.route(request, function(response, status) {
        if (status == google.maps.DirectionsStatus.OK) {
            directionsDisplay.setDirections(response);
            cb(null, response.routes[0].legs[0].distance.value / 1000);
        }
        else {
            cb("error");
        }
     });
  };
  return{
      restrict:"E",
      scope: {
          ori: '@',
          dest: '@',
          dist: '='
      },
      template: "{{dist}}",
      link: function(scope, elm, attrs) {
        var ori = attrs.ori;
        var dest = attrs.dest;
        init();
        scope.$watch('ori', function(newValue, oldValue) {
          ori = newValue;
          calcRoute(ori,dest, function (err, dist) {
              if (!err) {
                scope.dist=dist;
              }else{
                  console.log(err);
              }
          });
        });
        scope.$watch('dest', function(newValue, oldValue) {
          dest = newValue;
          calcRoute(ori,dest, function (err, dist) {
              if (!err) {
                scope.dist=dist;
              }else{
                  console.log(err);
              }
          });
        });

      }
  };
});