angular.module('jobmapp.generics.directives')
  .controller('SelectCurrencyCtrl', [
    '$scope',
    '$ionicPopover',
    'Currency',
    'User',
    function($scope, $ionicPopover, Currency, User) {
      $scope.currencies = Currency.all();

      var template = [
        '<ion-popover-view class="currency-list" style="width: 121px; height: 166px;">',
          '<ion-content scroll="true" style="margin: 0;">',
            '<div class="list">',
              '<ion-radio ng-change="closePopover(currency)" ng-model="currencyField" ng-value="currency" ng-repeat="currency in currencies">{{currency | jmCurrencySymbol}}</ion-radio>',
            '</div>',
          '</ion-content>',
        '</ion-popover-view>'
      ].join('');

      $scope.openCurrencies = function($event){
        // $scope.currencyField = "POP";
        $scope.popover = $ionicPopover.fromTemplate(template, {
          // set which scope shall be the $parent scope
          scope: $scope
        });
        $scope.popover.show($event);
      }

      $scope.closePopover = function(currency) {
        $scope.currencyField = currency;
        $scope.popover.hide();
        // Let's remember the user's choice for next time
        // Save it. And as it is not the most important update,
        // we do not care about the response.
        if($scope.$parent.currentUser){
          $scope.$parent.currentUser.currency = currency;
          User.update({user: {currency: currency}});
        }
      };

      //Cleanup the popover when we're done with it!
      $scope.$on('$destroy', function() {
        if($scope.popover) {
          $scope.popover.remove();
        }
      });
    }
  ])

  .directive('jmSelectCurrency', function() {
    return {
      restrict: 'E',
      replace: true,
      template: '<div class="currency" ng-click="openCurrencies($event)">{{currencyField | jmCurrencySymbol}} <i class="icon jm-arrow-down"></i></div>',
      controller: 'SelectCurrencyCtrl',
      link: function(scope, element, attrs){
        // Display the currency as given as model. If that does not exist, use the default (for that user).
        scope.currencyField = scope.currencyField || scope.$parent.defaultCurrency();
      },
      // We use an isolated scope so that we can access the attributes.
      // This means that we have to user the $parent scope if we want
      // to access sth from the normal scope. See explanation here:
      // http://stackoverflow.com/questions/17900201/how-to-access-parent-scope-from-within-a-custom-directive-with-own-scope-in-an
      scope: {
        currencyField: "=",
      },
      // This makes the $paren scope accessible although we use a isolated scope.
      translude: true
    };
  })
;
