angular.module('jobmapp.generics.filters')
.filter('diff', [
  function() {
    var dmp = new diff_match_patch();
    return function(string1, string2) {
      var diff = dmp.diff_main(string1, string2);
      dmp.diff_cleanupSemantic(diff);
      return dmp.diff_prettyHtml(diff);
    };
  }
])
.filter('jmPriceCurrency', [
  'Currency',
  function(Currency) {
    return function(price, currency) {
      return price.toFixed(2) + ' ' + Currency.getSymbol(currency);
    }
  }
])
.filter('jmCurrencySymbol', [
  'Currency',
  function(Currency) {
    return function(currency) {
      return Currency.getSymbol(currency);
    }
  }
])

// .filter('categoryFilter', [
//   function() {
//     return function(input, fl) {
//       return input.filter(function(elm) {
//         if (fl.indexOf(elm.category_id) > -1) {
//           return elm;
//         }
//       })
//     };
//   }
// ])

// .filter('distanceFilter', [
//   function() {
//     return function(input, data) {
//       console.log("input", input, data);
//       return input.filter(function(elm) {
//         console.log("filter", (elm.distance/1000), data.filterDistance)
//         if ( (!data.filterOnDistance) || (!elm.distance) || (elm.distance/1000) < data.filterDistance) {
//           return elm;
//         }
//       })
//     };
//   }
// ])

.filter('jobFilter', [
  function() {
    return function(input, filterdata) {
      return input.filter(function(elm) {
        var distanceCheck = true;
        var categoryCheck = true;
        if ( (!filterdata.anyDistance) && (elm.distance) && (elm.distance/1000) > filterdata.maxDistance && filterdata.maxDistance != 0) {
          distanceCheck = false;
        }
        if ((!filterdata.anyCategory) && filterdata.categories && filterdata.categories.indexOf(elm.category_id) == -1) {
          categoryCheck = false;
        }
        if (distanceCheck && categoryCheck) return elm;
      })
    };
  }
])

.filter('privateChatFilter', [
  function () {
    return function (messages, options) {
        var out = [];
        angular.forEach(messages, function (message) {
            if (message.from_user && (options.toId == message.from_user.id || (options.currentUserId == message.from_user.id && options.toId == message.id) || options.toId === undefined)) {
                console.log("from id", message.from_user.id);
                out.push(message);
            }
        });
        console.log("out", out);
        return out;
    };
  }
]);
;
