angular.module('jobmapp.generics.resources')
.factory('JobberPage', [
  '$resource',
  '$q',
  'env',
  function($resource, $q, env){
    var transformResponse = function(jobberPage) {
      if(jobberPage.user.photo_file_name == null){
        jobberPage.user.imagePathThumb = 'img/user_dark.png';
      }else{
        jobberPage.user.imagePath = env.apiEndPoint + '/uploads/users/' + jobberPage.user.photo_file_name;
        jobberPage.user.imagePathThumb = env.apiEndPoint + '/uploads/users/thumb_' + jobberPage.user.photo_file_name;
      }
      return jobberPage;
    }

    return $resource(env.apiEndPoint + '/jobber-pages/:id.json' , {id: '@jobber_page.id'}, {
      update: {
        method: 'PUT'
      },
      query: {
        method: 'GET',
        transformResponse: function(data) {
          var data = JSON.parse(data);
          if (data.length) {
            data = _.map(data, transformResponse);
          }
          return data;
        },
        isArray: true

      }
    })
  }
]);
