angular.module('jobmapp.generics.resources')
.factory('Message', [
  '$resource',
  'env',
  'MessageService',
  function($resource, env, MessageService){

    return $resource(env.apiEndPoint + '/messages/:id.json' , {id: '@id'}, {
      save: {
        method: 'POST',
        transformResponse: function(data){
          var message = JSON.parse(data);
          return MessageService.transformResponse(message);
        },
        isArray: false
      },
      update: {
        method: 'PUT'
      },
      query:  {
        method: 'GET',
        isArray: true
      },
      get: {
        method:'GET',
        isArray: false
      }
    })
  }
]);
