angular.module('jobmapp.generics.resources')
.factory('Notification', [
  '$resource',
  'env',
  function($resource, env){
    var transformMessageResponse = function(message) {

      if (message.from_user) {
        if (message.from_user.photo_file_name == null){
          message.from_user.imagePathThumb = 'img/user_dark.png';
        } else {
          message.from_user.imagePathThumb = env.apiEndPoint + '/uploads/users/thumb_' + message.from_user.photo_file_name;
        }
      }

      if (message.kind == "job_update") {
        message.body = JSON.parse(message.body);
      }

      message.time = moment(message.created_at).calendar();

      return message;
    }
    return $resource(env.apiEndPoint + '/me/notifications/:id.json' , {id: '@id'}, {
      query:  {
        method: 'GET',
        transformResponse: function (data) {
          data = JSON.parse(data);
          if (data.length) {
            data = _.map(data, transformMessageResponse);
          }
          return data;
        },
        isArray: true
      }
    })
  }
]);
