angular.module('jobmapp.generics.resources')
.factory('Search', [
  '$resource',
  '$q',
  'env',
  // 'gettextCatalog',
  'ServiceExtentions',
  'UserExtentions',
  function($resource, $q, env, ServiceExtentions, UserExtentions){
    return $resource(env.apiEndPoint + '/search/:terms.json', {terms: '@terms'}, {
      search: {
        method: 'GET',
        transformResponse: function (data) {
          data = JSON.parse(data);
          return data.map(function(record){
            if (record["resource_type"] == "Service") {
              record = ServiceExtentions.transformResponse(record);
              return record;
            } else if (record["resource_type"] == "User") {
              record = UserExtentions.transformResponse(record);
              return record;
            }
          })
        },
        isArray: true
      }
    })
  }
]);
