angular.module('jobmapp.generics.resources')
.factory('Service', [
  '$resource',
  '$q',
  'env',
  'ServiceExtentions',
  function($resource, $q, env, ServiceExtentions){

    return $resource(env.apiEndPoint + '/services/:id.json' , {id: '@service.id'}, {
      get: {
        method: 'GET',
        transformResponse: function (data) {
          data = JSON.parse(data);
          return ServiceExtentions.transformResponse(data);
        },
        isArray: false
      },
      save: {
        method: 'POST',
        transformRequest: ServiceExtentions.transformRequest
      },
      update: {
        method: 'PUT',
        transformRequest: ServiceExtentions.transformRequest
      },
      delete: {
        method: 'DELETE'
      }
    })
  }
]);
