angular.module('jobmapp.generics.resources')
.factory('User', [
  '$resource',
  '$q',
  'env',
  // 'gettextCatalog',
  'ServiceExtentions',
  'UserExtentions',
  function($resource, $q, env, ServiceExtentions, UserExtentions){
    // loginErrorHandler = function(error) {
    //   var alertPopup = $ionicPopup.alert({
    //     title: gettextCatalog.getString('Login denegado'),
    //     template: gettextCatalog.getString('Login no ha sido posible. Comprueba usuario y contraseña y conexión internet.')
    //   });
    //   return $q.reject(error);
    // };

    return $resource(env.apiEndPoint + '/me.json' , {}, {
      update: {
        method: 'PUT'
      },
      get: {
        method: 'GET',
        params: {},
        transformResponse: function (data) {
          data = JSON.parse(data);
          return UserExtentions.transformResponse(data);
        },
        isArray: false
      },
      getOther: {
        method: 'GET',
        url: env.apiEndPoint + '/users/:id.json',
        params: {id: '@id'},
        transformResponse: function (data) {
          data = JSON.parse(data);
          return UserExtentions.transformResponse(data);
        },
        isArray: false
      },
      login: {
        method: 'POST',
        url: env.apiEndPoint + '/users/sign_in.json',
        //params: {user: '@user'},
        transformResponse: function (data) {
          if (data) {
            data = JSON.parse(data);
            return UserExtentions.transformResponse(data);
          }
        },
        isArray: false
      },
      fbLogin: {
        method: 'POST',
        url: env.apiEndPoint + '/auth/facebook/external-login.json',
//        params: {token: '@token', uid: '@uid'},
        transformResponse: function (data) {
          data = JSON.parse(data);
          return UserExtentions.transformResponse(data);
        },
        isArray: false
      },
      fbConnect: {
        method: 'POST',
        url: env.apiEndPoint + '/auth/facebook/connect.json',
//        params: {token: '@token', uid: '@uid'},
        isArray: false
      },
      save: {
        method: 'POST',
        url: env.apiEndPoint + '/users.json',
        transformResponse: function (data) {
          data = JSON.parse(data);
          return UserExtentions.transformResponse(data);
        }
      },
      resetPassword: {
        method: 'POST',
        url: env.apiEndPoint + '/users/password.json'
      },
      changePassword: {
        method: 'PUT',
        url: env.apiEndPoint + '/me.json'
      },
      logout: {
        method: 'DELETE',
        url: env.apiEndPoint + '/me/logout.json'
      },
      removeDevice: {
        method: 'PUT',
        url: env.apiEndPoint + '/me/remove-device.json'
      },
      putInternalReview: {
        params: {id: '@id'},
        method: 'PUT',
        url: env.apiEndPoint + '/users/:id/internal-review.json'
      },
      getPaymentMethods: {
        method: 'GET',
        url: env.apiEndPoint + '/me/payment-methods.json',
      },
      invoices: {
        method: 'GET',
        url: env.apiEndPoint + '/me/invoices.json',
        isArray: true
      },
      getDefaultInvoiceAddress: {
        method: 'GET',
        url: env.apiEndPoint + '/me/invoice-addresses/default.json',
      },
      getLastJobs: {
        params: {category_id: '@categoryId'},
        method: 'GET',
        url: env.apiEndPoint + '/me/last-jobs/:categoryId.json',
      },
      getPhone: {
        method: 'GET',
        url: env.apiEndPoint + '/users/:uuid/phone.json',
        params: {id: '@uuid'}
      },

    })
  }
]);
