angular.module('jobmapp.generics.services')
.service('DeviceType', [
  '$window',
  function($window){
    // Default settings:
    var defaults = {
      isApp: false, // Are we in jobmapp.app?
      isWeb: false, // Are we in jobmapp.web?
      hasCordova: false // In app and on device having cordova?
    }

    var state = defaults;

    var reset = function(){
      state = defaults;
    }

    var init = function(){
      reset();
      if ($window.ionic) {
        state.isWeb = false;
        state.isApp = true;
        if (ionic.Platform.isAndroid() || ionic.Platform.isIOS()) {
          state.hasCordova = true;
        }
      } else {
        state.isWeb = true;
        state.isApp = false;
        state.hasCordova = false;
      };
      return this;
    };

    var getIsApp = function(){
      return state.isApp;
    };
    var getIsWeb = function(){
      return state.isWeb;
    };
    var getHasCordova = function(){
      return state.hasCordova;
    };

    return {
      init: init,
      isApp: getIsApp,
      isWeb: getIsWeb,
      hasCordova: getHasCordova
    };
  }
]);
