angular.module('jobmapp.generics.services')
.factory('FormProcess', [
  function(){
    return function(options){
      // This is a Class forms
      // Acepted 2 params:
      // steps: is the number of steps and forms
      // options:

      var model = {};         //Representation of model data;
      this.currentStep = -1;   //Current view form
      this.lastStep = -1;      //Last view form
      this.formVisited = -1;   //Max. step visited
      this.numberOfSteps = options.steps; //Number of steps
      this.goToStep = function(toForm) { //function for step by step on the form
        //form already seen
        if (toForm != this.currentStep) {
          if (toForm > this.formVisited) {
            this.formVisited = toForm;
          }
          this.lastStep = this.currentStep;
          this.currentStep = toForm;
        }
      };
      this.model = model;
      this.next = function() {
        this.goToStep(this.currentStep+1);
      };
      this.previous = function() {
        this.goToStep(this.currentStep-1);
      };
      this.helpers = { //This is an object to a support data
        isBusiness: false,
        isPerson: true,
        isAutonomous: false,
        isPublic: true,
      };
      var serverErrors = {};
      this.serverErrors = serverErrors;
      var clearServerError = function(fieldString){
        serverErrors[fieldString] = null;
      };
      this.clearServerError = clearServerError;

      angular.forEach(options.watchList, function(resourceConf){
        model[resourceConf.instanceName] = resourceConf.instance;
        angular.forEach(resourceConf.fields, function(field){
          var watchedModel = resourceConf.instance[field];
          var fieldString = options.processName + ".model." + resourceConf.instanceName + "." + field;
          options.scope.$watch(fieldString, function(newVal, oldVal) {
            if (newVal != oldVal) {
              var change = {};
              change[resourceConf.instanceName] = {};
              change[resourceConf.instanceName].id = resourceConf.instance.id;
              change[resourceConf.instanceName][field] = newVal;
              resourceConf.resource.update(change).$promise.then(function(response){
                clearServerError(fieldString);
              }, function(response){
                serverErrors[fieldString] = response.statusText;
              });
            }
          })
        })
      });
    };
  }
]);
