// NOTE: this service send event to google analytics
// Accept differents params separated for commas (,):

// If for a **event** default accept:
// - category: string (required)
// - action: string (required)
// - label: string (optional)
// - value: number Int (optional)

// If for a **event** default accept:
// - network: facebook, twitter, linkedin,...(required)
// - action: like, follow, tweet,... (required)
// - target: url shared (optional)

//EX:
// var analitycsOptions =  {
//   action:'payment service',
//   category:'service booking',
//   label: 'ammount: 5, type-service: delivery'
// }
// googleAnalytics.event(analitycsOptions);
//
//
// https://developers.google.com/analytics/devguides/collection/analyticsjs/events?hl=es

angular.module('jobmapp.generics.services')
.service('googleAnalytics', [
  '$rootScope',
  function ($rootScope) {
    this.event = function(options) {
      var obj = {};
      var mixp = {};
      obj.hitType = 'event';

      if(options.action) {
        obj.eventAction   = options.action;
      };
      if(options.category) {
        obj.eventCategory = options.category;
        mixp['category']  = options.category;
      }
      if(options.label) {
        obj.eventLabel = options.label;
        var labels = options.label.split(', ')
        angular.forEach(labels, function(label) {
          var k = label.split(':')[0]
          var v = label.split(':')[1]
          mixp[k] = v
        })
      }
      if(options.value) {
        obj.eventValue  = options.value;
        mixp['value']   = options.value;
      }
      if (options.nonInteraction) {
        obj.nonInteraction = options.nonInteraction;
      }
      if (typeof ga != 'undefined') {
        ga('send', obj);
      }
      if (typeof mixpanel != 'undefined') {
        // if exist mixpanel options, merge into mixp object
        if (options.mixpanel) {
          mixp = {};
          mixp = options.mixpanel;
        }
        var trackEvent = true;
        if ($rootScope.currentUser) {
          // if has current User , check if user to be part of jobMapp
          var jobmappTeam = {2:true, 6:true, 54:true, 90:true, 3031:true};
          if ( jobmappTeam[$rootScope.currentUser.id] ) {
            var trackEvent = false;
          }
        }
        if (trackEvent) {
          mixpanel.track(options.action, mixp);
        }
      }
    }

    this.socialEvent = function(options) {
      var obj = {}
      obj.hitType = 'social'

      if(options.network)
        obj.socialNetwork = options.network

      if(options.action)
        obj.socialAction   = options.action

      if(options.target)
        obj.socialTarget = options.target

      if (typeof ga != 'undefined') {
        ga('send', obj);
      }
    }

    this.trackPageView = function(url) {
      if (typeof ga != 'undefined') {
        ga('send', 'pageview', {
          page: url
        });
      } else {
        console.log("error analytics load");
      };
    }
  }
]);
