angular.module('jobmapp.generics.services')
  .factory('jobCategories', [
    'gettext',
    'gettextCatalog',
    function(gettext, gettextCatalog) {

      var jobCategories = [{
          id: 1,
          name: gettext('Servicio Doméstico'),
          name_url: "servicios-domésticos",
          parent_id: null,
          show: true,
          icon: '01home.svg',
          fbText: gettext('%name% no tiene tiempo para las tareas en su hogar. Lo hace jobMapp!'),
          fbImage: 'https://jobmapp.com/facebook/job-sharing/01home.jpg',
          example: gettext('Ejemplo: Arreglar los bajos de un pantalón como en la foto. Puedo entregar el pantalón o mejor, si lo pueden recojer de mi oficina pago 5 EUR más.'),
          iconClass: 'icon jm-home',
          iconPin: 'img/categories/pins/homePin.png',
          level: 1
        }, {
          id: 2,
          name: gettext('Jardín'),
          name_url: "jardín",
          parent_id: null,
          show: true,
          icon: '02garden.svg',
          fbText: gettext('¿Tu jardín parece la selva del Amazonas y tus niños se pueden esconder detrás de la mala hierba? %name% lo ha solucionado con jobMapp!'),
          fbImage: 'https://jobmapp.com/facebook/job-sharing/02garden.jpg',
          example: gettext('Ejemplo: Poda del arbol en la foto. Hay que traer el material (sierra, escalera) y recojer los residuos.'),
          iconClass: 'icon jm-garden',
          iconPin: 'img/categories/pins/gardenPin.png',
          level: 1
        }, {
          id: 3,
          name: gettext('Reparación y Obras'),
          name_url: "reparación-y-obras",
          parent_id: null,
          show: true,
          icon: '03handyman.svg',
          fbText: gettext('Los arreglos en casa tienen su truquillo. Por eso %name% lo deja a jobMapp!'),
          fbImage: 'https://jobmapp.com/facebook/job-sharing/03handyman.jpg',
          example: gettext('Ejemplo: Quiero darle una capa de pintura a las persianas de mi casa. Adjunto foto. El precio no incluye la pintura.'),
          iconClass: 'icon jm-handyman',
          iconPin: 'img/categories/pins/handymanPin.png',
          level: 1
        }, {
          id: 4,
          name: gettext('Transporte'),
          name_url: 'transporte',
          parent_id: null,
          show: true,
          icon: '04transport.svg',
          fbText: gettext('Para qué preocuparse de transportes? %name% lo encarga a un jobber!'),
          fbImage: 'https://jobmapp.com/facebook/job-sharing/04transport.jpg',
          example: gettext('Ejemplo: Estoy de mudanza. Busco a una persona con furgoneta que me ayude a bajar y subir los muebles y transportarlos desde Palma hacia Inca. Tiempo total estimado 5h.'),
          iconClass: 'icon jm-transport',
          iconPin: 'img/categories/pins/transportPin.png',
          level: 1
        }, {
          id: 5,
          name: gettext('Coche, Bici'),
          name_url: 'coche-bici',
          parent_id: null,
          show: true,
          icon: '05car.svg',
          fbText: gettext('%name% ya no se pasa su fin de semana arreglando su coche, bici o moto. Lo hace jobMapp para el.'),
          fbImage: 'https://jobmapp.com/facebook/job-sharing/05car.jpg',
          example: gettext('Ejemplo: ¿Alguien que me arregle una bici vieja (foto)? La rueda creo que está pinchada y los frenos necesitan que los revisen. La llevo a cualquier sitio en Palma para el arreglo.'),
          iconClass: 'icon jm-car',
          iconPin: 'img/categories/pins/carPin.png',
          level: 1
        }, {
          id: 6,
          name: gettext('Niños y Mascotas'),
          name_url: 'niños-y-mascotas',
          parent_id: null,
          show: true,
          icon: '06children.svg',
          fbText: gettext('Cuidar los niños o dar un paseo con el perro. Cosas que %name% confia a jobMapp!'),
          fbImage: 'https://jobmapp.com/facebook/job-sharing/06children.jpg',
          example: gettext('Ejemplo: Busco alguien que le gusten los animales para pasear a mi perro la próxima semana, 1h diaria de lunes a viernes. Es un golden retriever (foto).'),
          iconClass: 'icon jm-children',
          iconPin: 'img/categories/pins/childrenPin.png',
          level: 1
        }, {
          id: 7,
          name: gettext('Expertos'),
          name_url: 'expertos',
          parent_id: null,
          show: true,
          icon: '07expert.svg',
          fbText: gettext('¿Todavía sigues con el agujero en tus vaqueros preferidos y tu logo de la tarjeta de visita parece del año 90? ¡jobMapp te echa una mano!'),
          fbImage: 'https://jobmapp.com/facebook/job-sharing/07expert.jpg',
          example: gettext('Ejemplo: Busco diseñador gráfico que diseñe un logo para mi empresa. Preferiblemente con experiencia previa. Sólo gente seria.'),
          iconClass: 'icon jm-expert',
          iconPin: 'img/categories/pins/expertPin.png',
          level: 1
        }, {
          id: 8,
          name: gettext('Promoción & Gastronomía'),
          parent_id: null,
          show: false,
          icon: '07expert.svg'
        }, {
          id: 9,
          name: gettext('Informática'),
          name_url: 'informática',
          parent_id: null,
          show: true,
          icon: '09it.svg',
          fbText: gettext('El windows cascado o el Mac de huelga? %name% lo soluciona con un jobber!'),
          fbImage: 'https://jobmapp.com/facebook/job-sharing/09it.jpg',
          example: gettext('Ejemplo: Ya no se me enciende el ordenador. Busco un informático que me mire si se pueden recuperar las fotos y documentos.'),
          iconClass: 'icon jm-it',
          iconPin: 'img/categories/pins/itPin.png',
          level: 1
        }, {
          id: 17,
          name: "Limpieza de casa / oficina",
          parent_id: 1,
          level: 2
        }, {
          id: 171,
          name: "Limpieza de una casa",
          parent_id: 1,
          level: 2
        }, {
          id: 172,
          name: "Limpieza de una oficina",
          parent_id: 1,
          level: 2
        }, {
          id: 102,
          name: "Empleadas de Hogar",
          parent_id: 1,
          level: 2
        }, {
          id: 199,
          name: "Otros",
          parent_id: 1,
          level: 2
        },
        {
          id: 201,
          name: 'Mantenimiento de jardines',
          parent_id: 2,
          level: 2
        }, {
          id: 202,
          name: 'Diseño de jardines',
          parent_id: 2,
          level: 2
        }, {
          id: 203,
          name: 'Plantación',
          parent_id: 2,
          level: 2
        }, {
          id: 204,
          name: 'Mantenimiento piscina',
          parent_id: 2,
          level: 2
        }, {
          id: 299,
          name: 'Otros',
          parent_id: 2,
          level: 2
        },
        {
          id: 301,
          name: gettext('Aire acondicionado'),
          show: true,
          parent_id: 3,
          level: 2
        },
        {
          id: 302,
          name: gettext('Albañil'),
          show: true,
          parent_id: 3,
          level: 2
        },
        {
          id: 303,
          name: gettext('Alicatado y ensolado'),
          show: true,
          parent_id: 3,
          level: 2
        },
        {
          id: 304,
          name: gettext('Calefacción'),
          show: true,
          parent_id: 3,
          level: 2
        },
        {
          id: 305,
          name: gettext('Carpintero'),
          show: true,
          parent_id: 3,
          level: 2
        },
        {
          id: 306,
          name: gettext('Cristalero'),
          show: true,
          parent_id: 3,
          level: 2
        },
        {
          id: 308,
          name: gettext('Electricista'),
          show: true,
          parent_id: 3,
          level: 2
        },
        {
          id: 309,
          name: gettext('Electrodomésticos'),
          name_url: 'electrodomésticos',
          show: true,
          parent_id: 3,
          level: 2,
          description: '¿Averías en tu nevera, lavavajillas o secadora? Busca en nuestras categorías y encuentra profesionales y técnicos en reparación de electrodomésticos dispuestos a ayudarte cuanto antes.'
        },
        {
          id: 310,
          name: gettext('Fontanería'),
          name_url: 'fontanería',
          show: true,
          parent_id: 3,
          level: 2
        },
        {
          id: 311,
          name: gettext('Montaje muebles'),
          show: true,
          parent_id: 3,
          level: 2
        },
        {
          id: 312,
          name: gettext('Pintor'),
          show: true,
          parent_id: 3,
          level: 2
        },
        {
          id: 313,
          name: gettext('Ventanas y persianas'),
          show: true,
          parent_id: 3,
          level: 2
        },        //
        // {
        //   id: 30901,
        //   name: 'Reparación nevera',
        //   parent_id: 309,
        //   level: 3
        // }, {
        //   id: 30902,
        //   name: 'Reparación lavavajillas',
        //   parent_id: 309,
        //   level: 3
        // }, {
        //   id: 30903,
        //   name: 'Reparación lavadora',
        //   parent_id: 309,
        //   level: 3
        // }, {
        //   id: 30904,
        //   name: 'Reparación secadora',
        //   parent_id: 309,
        //   level: 3
        // }, {
        //   id: 30905,
        //   name: 'Reparación horno',
        //   parent_id: 309,
        //   level: 3
        // }, {
        //   id: 30906,
        //   name: 'Reparación vitrocerámica',
        //   parent_id: 309,
        //   level: 3
        // }, {
        //   id: 30907,
        //   name: 'Reparación termo',
        //   parent_id: 309,
        //   level: 3
        // }, {
        //   id: 30921,
        //   name: 'Instalación nevera',
        //   parent_id: 309,
        //   level: 3
        // }, {
        //   id: 30922,
        //   name: 'Instalación lavavajillas',
        //   parent_id: 309,
        //   level: 3
        // }, {
        //   id: 30923,
        //   name: 'Instalación lavadora',
        //   parent_id: 309,
        //   level: 3
        // }, {
        //   id: 30924,
        //   name: 'Instalación secadora',
        //   parent_id: 309,
        //   level: 3
        // }, {
        //   id: 30925,
        //   name: 'Instalación horno',
        //   parent_id: 309,
        //   level: 3
        // }, {
        //   id: 30926,
        //   name: 'Instalación vitrocerámica',
        //   parent_id: 309,
        //   level: 3
        // }, {
        //   id: 30927,
        //   name: 'Instalación termo',
        //   parent_id: 309,
        //   level: 3
        // },
        {
          id: 401,
          name: gettext('Mensajería'),
          name_url: 'mensajeria',
          iconClass: 'icon jm-scooter',
          show: true,
          parent_id: 4,
          level: 2
        },
        {
          id: 403,
          name: gettext('Mudanzas'),
          name_url: 'mudanzas',
          iconClas: 'icon jm-truck',
          show: true,
          parent_id: 4,
          level: 2
        },
        {
          id: 404,
          name: gettext('Transporte en furgoneta'),
          name_url: 'transporte-en-furgoneta',
          show: true,
          parent_id: 4,
          level: 2,
          description: 'Vas a comprar un sofá nuevo, pero vives en un 4º piso sin ascensor…¿y ahora qué? Contacta con nuestras empresas de transporte en furgoneta o jobbers particulares para que te ayuden a subirlo. ¡Y si lo que necesitas es transportar un mueble, mobiliario de oficina o hacer una minimudanza también!'
        },
        {
          id: 405,
          name: gettext('Eliminación chatarra'),
          name_url: 'eliminacion-chatarra',
          show: true,
          parent_id: 4,
          level: 2,
          description: '¿Tienes muchos trastos para tirar y no sabes qué hacer con ellos o no tienes tiempo? Busca entre nuestros jobbers a un chatarrero a domicilio quién lo haga por ti y no te preocupes más. Recogida de electrodomésticos, chatarra de acero, recogida de trastos… todo lo que necesites.'
        },
        {
          id: 406,
          name: gettext('Chófer'),
          name_url: 'chófer',
          iconClass: 'icon jm-auto',
          show: true,
          parent_id: 4,
          level: 2,
          description: 'Llegas a tu casa un viernes después de un largo día de trabajo y te das cuenta de que te has dejado en la oficina algo muy importante. Tienes que recoger la ropa de la lavandería pero no tienes tiempo y la necesitas urgente. O acaba de llegar un pedido a tu casa que tu pareja estaba esperando y quieres hacérselo llegar cuanto antes… ¡Encarga a un jobber que lo haga por ti y disfruta de tu tiempo libre!'
        }
      ]

      var CategoriesDictionary = {
        'default': 'default',
        'hogar': 'Servicio Doméstico',
        'servicios-domesticos': 'Servicio Doméstico',
        'servicios domesticos': 'Servicio Doméstico',
        'servicios-domésticos': 'Servicio Doméstico',
        'servicios domésticos': 'Servicio Doméstico',
        'jardín': 'Jardín',
        'jardin': 'Jardín',
        'transporte': 'Transporte',
        'informática': 'Informática',
        'informatica': 'Informática',
        'niños mascotas': 'Niños y Mascotas',
        'niños y mascotas': 'Niños y Mascotas',
        'niños-y-mascotas': 'Niños y Mascotas',
        'ninos mascotas': 'Niños y Mascotas',
        'coche y bici': 'Coche, Bici',
        'coche, bici': 'Coche, Bici',
        'coche bici': 'Coche, Bici',
        'coche,bici': 'Coche, Bici',
        'coche-bici': 'Coche, Bici',
        'bricolaje': 'Reparación y Obras',
        'bricolage': 'Reparación y Obras',
        'reparación-y-obras': 'Reparación y Obras',
        'espertos': 'Expertos',
        'expertos': 'Expertos',
        'Mensajería': 'Mensajeria',
        'Mensajeria': 'Mensajeria'
      }

      var keywords = {
        0: [
          'mudanzas',
          'reformas',
          'jardines',
          'canguro',
          'taller',
          'limpieza',
          'transportes',
          'diseñador gráfico',
          'diseño web',
          'fotógrafo',
          'iphone'
        ],
        1: [
          'empresas de limpieza',
          'limpieza',
          'empresa de limpieza',
          'limpieza a domicilio',
          // 'limpieza de alfombras',
          'limpieza a domicilio',
          'empleada hogar',
          'limpieza por horas',
          'limpieza cristales',
          'limpieza industrial',
          'empleada hogar internas',
          'limpiar casa'
        ],
        2: [
          'jardineros',
          'mantenimiento de jardines',
          // 'venta de plantas',
          // 'empresa de jardinería',
          'limpieza de jardines',
          // 'tala de árboles',
          // 'podar',
          'jardinero',
          // 'cortar césped',
          'jardinería',
          'césped'
        ],
        3: [
          // 'reformas',
          'reformas integrales',
          'pintor',
          'electricista',
          'cerrajero',
          'cerrajeros',
          'albañil',
          'obras',
          'fontanero',
          // 'muebles a medida',
          'carpintero',
          'reformar',
          'instalaciones de fontanería',
          'fachadas',
          // 'fontanería 24h',
          'pintar',
          'manualidades',
          // 'mesa a medida',
          'madera',
          'manitas',
          'a mano',
          'pintura'
        ],
        309: [
          'servicio técnico nevera',
          'servicio técnico frigorífico',
          'servicio técnico lavavajillas',
          'servicio técnico lavadora',
          'servicio técnico secadora',
          'servicio técnico horno',
          'servicio técnico vitrocerámica',
          'servicio técnico lg',
          'servicio técnico bosch',
          'servicio técnico frigor',
          'servicio técnico phillips',
          'servicio técnico siemens'
        ],
        4: [
          'mudanzas',
          // 'transfer',
          // 'courier',
          'conductor',
          // 'agencias de transporte',
          // 'guardamuebles',
          'transportistas',
          'transporte urgente',
          'chofer',
          // 'presupuesto mudanza',
          // 'transportar cajas',
          // 'llevarme a',
          'transportista',
          // 'cajas',
          'camión',
          'mudanza',
          'mensajeria'
        ],
        401: [
          'courier',
          'conductor',
          'transporte urgente',
          'transportar cajas',
          'mensajeria',
          'mensajeria urgente',
          'paquetería'
        ],
        5: [
          'taller',
          'lavado de coches',
          'taller de coches',
          'limpieza interior de coches',
          'reparación coche',
          'reparación bicicleta',
          'mecánico',
          'coche',
          'bici',
          'bicicleta',
          'moto',
          'avería'
        ],
        6: [
          'canguro en casa',
          'tus clases particulares',
          'canguro',
          'profesores particulares',
          // 'residencia canina',
          'niñera',
          'clases particulares de inglés',
          'clases de apoyo selectividad',
          // 'kanguro',
          'cuidar personas mayores',
          'pasear perros',
          'niños',
          'mascotas',
          'cuidador',
          'perros',
          'gatos',
          'cuidar'
        ],
        7: [
          'diseñador gráfico',
          'diseñadores gráficos',
          // 'agencias de traducción',
          'fotógrafo',
          'arquitecto',
          'proyectos',
          'asesor'
        ],
        9: [
          'diseño web',
          'crear página web',
          'desarrollo web',
          'soporte informatico',
          // 'reparar pantalla',
          // 'limpiar ordenador',
          // 'crear una app',
          // 'restaurar iphone',
          'formatear disco duro',
          'iphone',
          'informático',
          'reparación ordenador',
          'mac',
          'windows',
          'reparar'
        ]
      }


      // if hightlight attribute is undefined set it to "highlight: false":
      jobCategories = _.map(jobCategories, function(jobCategory) {
        if (typeof(jobCategory.highlight) == 'undefined') jobCategory.highlight = false;
        return jobCategory;
      })

      return {
        main: function() {
          var jobMainCategories = jobCategories.filter(function(cat) {
            return cat.parent_id == null;
          });
          return jobMainCategories;
        },
        mainShown: function() {
          var jobMainCategories = jobCategories.filter(function(cat) {
            return (cat.parent_id == null && cat.show);
          });
          return jobMainCategories;
        },
        main_filter: function() {
          var jobMainCategoriesFilter = _.chain(jobCategories).filter(function(cat) {
            return cat.parent_id == null;
          }).map(function(el) {
            el.active = true;
            return _.pick(el, ['id', 'name', 'show', 'active']);
          }).value();
          return jobMainCategoriesFilter;
        },
        subCat: function(cat_id) {
          var jobSubCategories = jobCategories.filter(function(cat) {
            return cat.parent_id == cat_id;
          });
          return jobSubCategories;
        },
        get: function(cat_id) {
          // Simple index lookup, but only deliver first result, no check on index error (>1 results)
          var jobCategory = jobCategories.filter(function(cat) {
            return cat.id == cat_id;
          });
          return jobCategory[0];
        },
        getFbText: function(cat_id, name) {
          var jobCategory = jobCategories.filter(function(cat) {
            return cat.id == cat_id;
          });
          var fbText = jobCategory[0].fbText;
          fbText = fbText.replace('%name%', name);
          return fbText;
        },
        getFbImage: function(cat_id) {
          var jobCategory = jobCategories.filter(function(cat) {
            return cat.id == cat_id;
          });
          return jobCategory[0].fbImage;
        },
        getCategories: function() {
          categories = [];
          angular.forEach(jobCategories, function(category) {
            if (category.show) {
              categories.push(category);
            }
          });
          return categories;
        },
        getLevelCategories: function(level) {
          var categories = [];
          angular.forEach(jobCategories, function(category) {
            if (category.level == level) {
              categories.push(category);
            }
          })
          return categories;
        },
        isCategory: function(word) {
          var cat = null;
          if (CategoriesDictionary[word]) {
            word = CategoriesDictionary[word];
          }
          angular.forEach(jobCategories, function(category) {
            if (category.name == word) {
              cat = category;
            }
          })
          return cat;
        },
        getCategoryById: function(id) {
          cat = null;
          angular.forEach(jobCategories, function(category) {
            if (category.id == id) {
              cat = category;
            }
          })
          return cat;
        },
        isKeyword: function(word) {
          id = null;
          angular.forEach(keywords, function(keywordCategory, key) {
            angular.forEach(keywordCategory, function(keyword) {
              if (keyword == word) {
                id = key;
              }
            })
          })
          return id;
        },
        asMenuList: function(){
          var self = this;
          var menuList = [];
          angular.forEach(self.mainShown(), function(mainCat){
            mainCat.selectOptionLabel = gettextCatalog.getString(mainCat.name)
            menuList.push(mainCat);
            var subCats = self.subCat(mainCat.id);
            if (subCats.length > 0){
              angular.forEach(subCats, function(subCat){
                if (subCat.show) {
                  subCat.selectOptionLabel = "- " + gettextCatalog.getString(subCat.name),
                  menuList.push(subCat)
                }
              })
            }
          })
          return menuList;
        }
      }
    }
  ]);
