angular.module('jobmapp.generics.services')
.factory('MessageService', [
  'env',
  function(env){
    var kinds = {
      from_job_creator: 0,
      from_jobber: 1,
      from_admin: 2,
      job_update: 3
    }
    return {
      kind: kinds,
      transformResponse: function(message){
        console.log("transform Called", message.kind);
        if (message.kind == kinds.from_job_creator || message.kind == kinds.from_jobber || message.kind == kinds.from_admin) {
          if (message.from_user.image_name) {
            message.from_user.thumbPath = env.apiEndPoint + "/uploads/users/thumb_" + message.from_user.image_name;
          } else {
            message.from_user.thumbPath = "img/user_dark.png";
          }
        } else if (message.kind == kinds.job_update) {
          message.body = JSON.parse(message.body);
        }
        return message;
      }
    }
}
]);
