angular.module('jobmapp.generics.services')
  .factory('partnerServices', [
    'gettextCatalog', 'env', 'GeoLocation',
    function(gettextCatalog, env, GeoLocation) {
      var serviceIdEcoscooting = {};
      serviceIdEcoscooting['production'] = 2993;
      serviceIdEcoscooting['staging'] = 18;
      serviceIdEcoscooting['local'] = 8;
      serviceIdEcoscooting['localRemote'] = 8;

      var serviceIdEcoscootingBcn = {};
      serviceIdEcoscootingBcn['production'] = 3328;
      serviceIdEcoscootingBcn['staging'] = 18;
      serviceIdEcoscootingBcn['local'] = 11;
      serviceIdEcoscootingBcn['localRemote'] = 11;

      var serviceIdRetroscooting = {};
      serviceIdRetroscooting['production'] = 3173;
      serviceIdRetroscooting['staging'] = 18;
      serviceIdRetroscooting['local'] = 9;
      serviceIdRetroscooting['localRemote'] = 9;

      var serviceIdMoveMadrid = {};
      serviceIdMoveMadrid['production'] = 3460;
      serviceIdMoveMadrid['staging'] = 18;
      serviceIdMoveMadrid['local'] = 10;
      serviceIdMoveMadrid['localRemote'] = 10;

      var serviceIdMoveMallorca = {};
      serviceIdMoveMallorca['production'] = 3461;
      serviceIdMoveMallorca['staging'] = 18;
      serviceIdMoveMallorca['local'] = 12;
      serviceIdMoveMallorca['localRemote'] = 12;

      var serviceIdMoveBarcelona = {};
      serviceIdMoveBarcelona['production'] = 3462;
      serviceIdMoveBarcelona['staging'] = 18;
      serviceIdMoveBarcelona['local'] = 13;
      serviceIdMoveBarcelona['localRemote'] = 13;

      var partnerServices = [
        {
          id: null,
          categoryId: 1,
          key: "cleaning",
          position: null,
          distance: null,
          postcodes: null,
          actionSheetText: gettextCatalog.getString("Limpieza casa/oficina"),
          specialForm: 'cleaning'
        },
        {
          id: serviceIdEcoscooting[env.name],
          categoryId: 401,
          key: "ecoscooting-madrid",
          position: [40.441, -3.697],
          radius: 10000,
          postcodes: ['28001', '28002', '28003', '28004', '28005', '28006', '28007', '28008', '28009', '28010', '28011', '28012', '28013', '28014', '28015', '28016', '28019', '28020', '28028', '28029', '28036', '28039', '28045', '28046', '28026', '28053', '28038', '28030', '28017', '28027', '28043', '28033', '28035', '28040', '28047'],
          actionSheetText: gettextCatalog.getString("Mensajería Madrid 5€"),
          specialForm: 'ecoscooter',
          kmlUrl: env.apiEndPoint + '/kml/eco-scooting-mad-two-zones_5.kml',
          schedules: {
            days: {
              1: true, //Monday
              2: true, //Tuesday
              3: true, //Wednesday
              4: true, //Thursday
              5: true, //Friday
              6: true, //Saturday
              0: false //Sunday
            },
            hours: {
              10: true,
              11: true,
              12: true,
              13: true,
              14: true,
              15: true,
              16: true,
              17: true,
              18: true,
              19: true,
              20: true
            }
          },
          howItWorks: {
              serviceHours: 'Recogemos en menos de 1 hora y entregamos al momento, de lunes a sábado de 10 a 21h.'
          },
          seo_text: '<h3>¿Por qué usar nuestro servicio de mensajería en Madrid?</h3> <ol> <li> <h4>Protegemos el medio ambiente.</h4> <p>Nuestra empresa de transporte trabaja dentro de la zona M-30 únicamente con una flota de motos eléctricas. Las motos son silenciosas y no contaminan el centro de la ciudad. Fuera de la M-30 trabajamos con algunas motos de gasolina, solo en envíos especiales, para poder asegurar la disponibilidad a larga distancia. La flota es moderna, todas las motos tienen menos de un año y con un mantenimiento permanente.</p> </li> <li> <h4>Tenemos las cajas más grandes</h4> <p>Para el servicio de paquetería nuestras motos tienen cajas de reparto de 50 x 50 x 50 cm. Son las cajas más grandes en el mercado español para paquetería y mensajería. Pueden transportar fácilmente hasta 5 kg.</p> </li> <li> <h4>Repartidores y mensajeros profesionales</h4> <p>Los mensajeros en Madrid son empleados de nuestro partner de mensajería. Así aseguramos la calidad del servicio. Cumplimos los plazos de entrega y aseguramos un transporte seguro y confidencial. Realizamos también reparto de comida. Disponemos de bolsas térmicas y garantizamos el reparto en el menor tiempo posible.</p> </li> <li> <h4>Rapidez del servicio</h4> <p>Somos especialistas en transportes locales y mensajería urbana. ¡Los servicios de jobMapp siempre son Express! Cualquier envío urgente se recoge en un plazo máximo de una hora y se entrega enseguida. Trabajamos de punto a punto, los documentos o paquetes no pasan por un centro de reparto.</p> </li> <li> <h4>Facilidad para clientes frecuentes</h4> <p>Una vez registrado en nuestro servicio puedes guardar tus datos de facturación, las direcciones de recogida y entrega y los datos de pago. Así tanto clientes frecuentes como empresas tienen acceso a un servicio muy fácil de contratar.</p> </li> <li> <h4>Precios competitivos.</h4> <p>Todos los envíos dentro de la zona M-30 tienen un precio único de 5 €, e incluye todo lo que pueda caber en nuestras cajas :-) En algunos códigos postales fuera de la M-30 el precio del envío es de 8 €. Todo los precios incluyen IVA.</p></li></ul>',
          faq: [{
            title: '¿Cómo funciona?',
            description: '<p>Indícanos dirección de origen, destino y preferencia de horario de entrega. Asignaremos un transportista en la zona para tu envío que acudirá inmediatamente. Solo se cobrará el servicio una vez realizada la entrega.</p>'
          }, {
            title: '¿Qué puedo enviar?',
            description: '<p>Todo paquete que pese menos de 5 kg con unas dimensiones máximas de 50 x 50 x 50 cm. El contenido debe ser legal y sin peligro.</p>'
          }, {
            title: '¿Puedo encargar un envío desde mi teléfono?',
            description: '<p>Sí. Puedes descargarte nuestra aplicación de jobMapp y al encargar un job de transporte elegir la opción de “Mensajería Madrid 5 €”</p>'
          }, {
            title: '¿A qué hora está disponible?',
            description: '<p>La recogida y entrega se realizan en los siguientes horarios: 10:00h a 21.00h de lunes a sábado.</p>'
          }, {
            title: '¿Puedo elegir el destino que quiera?',
            description: '<p>Tanto la recogida como la entrega se hacen en los siguientes códigos postales: <b>28001, 28002, 28003, 28004, 28005, 28006, 28007, 28008, 28009, 28010, 28011, 28012, 28013, 28014, 28015, 28016, 28019, 28020, 28028, 28029, 28036, 28039, 28045, 28046, 28026, 28053, 28038, 28030, 28017, 28027, 28043, 28033, 28035, 28040, 28047</b></p>'
          }],
          city: {
            short_name: 'Madrid',
            long_name: 'Madrid',
            encode_name: 'madrid'
          },
          landing_page: env.apiEndPoint + '/servicios/mensajeria-en-madrid'
        },
        {
          id: serviceIdEcoscootingBcn[env.name],
          categoryId: 401,
          key: "ecoscooting-bcn",
          position: [41.383, 2.183],
          radius: 10000,
          postcodes: ['08001', '08002', '08003', '08004', '08005', '08006', '08007', '08008', '08009', '08011', '08012', '08013', '08014', '08015', '08016', '08017', '08018', '08019', '08020', '08021', '08022', '08023', '08024', '08025', '08026', '08027', '08028', '08029', '08030', '08031', '08032', '08033', '08034', '08035', '08036', '08037', '08038', '08039', '08041', '08042'],
          actionSheetText: gettextCatalog.getString("Mensajería Barcelona 5€"),
          specialForm: 'ecoscooter',
          kmlUrl: env.apiEndPoint + '/kml/ecoscooting-bcn.kml',
          schedules: {
            days: {
              1: true, //Monday
              2: true, //Tuesday
              3: true, //Wednesday
              4: true, //Thursday
              5: true, //Friday
              6: true, //Saturday
              0: false //Sunday
            },
            hours: {
              10: true,
              11: true,
              12: true,
              13: true,
              14: true,
              15: true,
              16: true,
              17: true,
              18: true,
              19: true,
              20: true
            }
          },
          howItWorks: {
            serviceHours: 'Recogemos en menos de 1 hora y entregamos al momento, de lunes a sábado de 10 a 21h.'
          },
          seo_text: '<h3>¿Por qué usar nuestro servicio de mensajería en Barcelona?</h3> <ol> <li> <h4>Los envíos más rápidos</h4> <p>Nos especializamos en envíos locales y mensajería urbana. Encargas tu recogida desde la web en 2 minutos, y si la pides ‘lo antes posible’, al momento un repartidor se dirigirá a donde tú hayas indicado. Una vez recogido el paquete se entrega directamente, sin intermediarios y sin pasar por una oficina.</p> </li> <li> <h4>Personal cualificado</h4> <p>Los mensajeros en Barcelona son personal seleccionado por nuestro partner de mensajería. De esta manera nos comprometemos a ofrecer un servicio de calidad.Tus paquetes pasarán el menor tiempo posible de camino a su destino. Disponemos también de bolsas térmicas por lo que trabajamos con restaurantes y pastelerías con la mayor garantía.</p> </li> <li> <h4>Económicos</h4> <p>Precio único de 5 € IVA incluido por recogida y entrega. No importa si son 1 o 3 paquetes, solo cobramos por envío.</p> </li> <li> <h4>Nuestras motos son eco-friendly</h4> <p>En Barcelona trabajamos únicamente con una flota de motos eléctricas Nuestra empresa de transporte trabaja en Barcelona únicamente con una flota de motos eléctricas, de esta manera no contaminamos la ciudad ni hacemos ruido. Todas las motos tienen menos de un año y son revisadas continuamente.</p> </li> <li> <h4>Las cajas más grandes</h4> <p>Enviamos en moto más que nadie. Nuestras cajas de reparto son de 50 x 50 x 50cm, son las más grandes para paquetería y mensajería en España y podemos transportar hasta 5kg de carga sin ningún problema.</p> </li> <li> <h4>Cada envío más fácil que el anterior.</h4> <p>Si realizas envíos a menudo puedes guardar tus datos de pago, facturación y las dirección de recogida y entrega. De esta manera solo tendrás que elegir la hora, el día y especificar las características del paquete.</p> </li> </ol>',
          faq: [{
            title: '¿Cómo funciona?',
            description: '<p>Indícanos dirección de origen, destino y preferencia de horario de entrega. Asignaremos un transportista en la zona para tu envío que acudirá inmediatamente. Solo se cobrará el servicio una vez realizada la entrega.</p>'
          }, {
            title: '¿Qué puedo enviar?',
            description: '<p>Todo paquete que pese menos de 5 kg con unas dimensiones máximas de 50 cm x 50 cm x 50 cm. El contenido debe ser legal y sin peligro.</p>'
          }, {
            title: '¿Puedo encargar un envío desde mi teléfono?',
            description: '<p>Sí. Puedes descargarte nuestra aplicación de jobMapp y al encargar un job de transporte elegir la opción de “Mensajería Barcelona 5 €”</p>'
          }, {
            title: '¿A qué hora está disponible?',
            description: '<p>La recogida y entrega se realizan en los siguientes horarios: 10:00h a 21:00h de lunes a sábado.</p>'
          }, {
            title: '¿Puedo elegir el destino que quiera?',
            description: '<p>Tanto la recogida como la entrega se hacen en los siguientes códigos postales: <b>08001, 08002, 08003, 08004, 08005, 08006, 08007, 08008, 08009, 08020, 08021, 08022, 08023, 08024, 08025, 08026, 08027, 08028, 08029, 08030, 08031, 08032, 08033, 08034, 08035, 08036, 08037, 08038, 08039, 08041, 08042</b></p>'
          }],
          city: {
            short_name: 'Barcelona',
            long_name: 'Barcelona',
            encode_name: 'barcelona'
          },
          landing_page: env.apiEndPoint + '/servicios/mensajeria-en-barcelona'
        },
        {
          id: serviceIdRetroscooting[env.name],
          categoryId: 401,
          key: "mensajeria-palma",
          position: [39.567, 2.650],
          radius: 10000,
          postcodes: ['07001', '07002', '07003', '07004', '07005', '07006', '07007', '07008', '07009', '07010', '07011', '07012', '07013', '07014', '07015'],
          actionSheetText: gettextCatalog.getString("Mensajería Palma 5€"),
          specialForm: 'ecoscooter',
          kmlUrl: env.apiEndPoint + '/kml/palma-retro-scooting.kml',
          schedules: {
            days: {
              1: true, //Monday
              2: true, //Tuesday
              3: true, //Wednesday
              4: true, //Thursday
              5: true, //Friday
              6: false, //Saturday
              0: false //Sunday
            },
            hours: {
              10: true,
              11: true,
              12: true,
              13: true,
              14: true,
              15: true,
              16: true,
              17: true
            }
          },
          howItWorks: {
            serviceHours: 'Recogemos en menos de 1 hora y entregamos al momento, de lunes a sábado de 10 a 18h.'
          },
          faq: [{
            title: '¿Cómo funciona?',
            description: '<p>Indícanos dirección de origen, destino y preferencia de horario de entrega. Asignaremos un mensajero en la zona para tu envío que acudirá inmediatamente. Solo se cobrará el servicio una vez realizada la entrega.</p>'
          }, {
            title: '¿Qué puedo enviar?',
            description: '<p>Todo paquete que pese menos de 5 kg con unas dimensiones máximas de 50 x 50 x 50 cm. El contenido debe ser legal y sin peligro.</p>'
          }, {
            title: '¿Puedo encargar un envío desde mi teléfono?',
            description: '<p>Sí. Puedes descargarte nuestra aplicación de jobMapp y al encargar un job de transporte elegir la opción de “Mensajería Palma 5 €”</p>'
          }, {
            title: '¿A qué hora está disponible?',
            description: '<p>La recogida y entrega se realizan en los siguientes horarios: 10:00h a 18:00h de lunes a viernes.</p>'
          }, {
            title: '¿Puedo elegir el destino que quiera?',
            description: '<p>Tanto la recogida como la entrega se hacen en los siguientes códigos postales:<br> <b>07001, 07002, 07003, 07004, 07005, 07006, 07007, 07008, 07009, 07010, 07011, 07012, 07013, 07014, 07015</b></p>'
          }],
          seo_text: '<h3>¿Por qué usar nuestro servicio de mensajería en Palma de Mallorca?</h3> <ol> <li> <h4>Precio competitivo</h4> <p>Solo cobramos 5 € por envío IVA incluido. Da igual el origen y el destino, la hora, cuantos paquetes sean y el tamaño (mientras quepa en una moto de forma segura).</p> </li> <li> <h4>Somos los más rápidos</h4> <p>¡Nuestros servicios son más Express que nunca! Repartimos en moto por lo que nos movemos muy rápido por el centro de Palma. Los atascos no pueden con nosotros ;-)</p> </li> <li> <h4>Repartidores profesionales</h4> <p>Nuestros mensajeros son elegidos personalmente por jobMapp. De esta manera nos comprometemos y garantizamos un servicio de calidad, rápido y fiable. Repartimos de punto a punto, por lo que tus paquetes serán entregados en mano al destinatario por la misma persona que los ha recogido.</p> </li> <li> <h4>Todas las facilidades</h4> <p>Si realizas envíos con frecuencia puedes guardar tus datos de pago y las dirección de recogida y de entrega, que irán asociados a tu cuenta de usuario de jobMapp. Por supuesto estos datos están protegidos con toda la seguridad posible.</p></li></ol>',
          city: {
            short_name: 'Palma',
            long_name: 'Palma de Mallorca',
            encode_name: 'palma-de-mallorca'
          },
          kmlUrl: env.apiEndPoint + '/kml/palma-retro-scooting.kml',
          landing_page: env.apiEndPoint + '/servicios/mensajeria-en-palma-de-mallorca'
        },
        {
          id: serviceIdMoveMadrid[env.name],
          categoryId: 403,
          key: "mudanzas-madrid",
          position: [40.441, -3.697],
          radius: 10000,
          zoom: 11,
          faq: [{
            title: '¿Cómo funciona?',
            description: '<p>Indícanos dirección de origen, destino y preferencia de horario de entrega. Asignaremos un mensajero en la zona para tu envío que acudirá inmediatamente. Solo se cobrará el servicio una vez realizada la entrega.</p>'
          }, {
            title: '¿Qué puedo enviar?',
            description: '<p>Todo paquete que pese menos de 5 kg con unas dimensiones máximas de 50 x 50 x 50 cm. El contenido debe ser legal y sin peligro.<p>'
          }, {
            title: '¿Puedo encargar un envío desde mi teléfono?',
            description: '<p>Sí. Puedes descargarte nuestra aplicación de jobMapp y al encargar un job de transporte elegir la opción de “Mensajería Palma 5 €”</p>'
          }, {
            title: '¿A qué hora está disponible?',
            description: '<p>La recogida y entrega se realizan en los siguientes horarios: 10:00h a 18:00h de lunes a sábado.</p>'
          }, {
            title: '¿Puedo elegir el destino que quiera?',
            description: '<p>Tanto la recogida como la entrega se hacen en los siguientes códigos postales:<br> <b>28001, 28002, 28003, 28004, 28005, 28006, 28007, 28008, 28009, 28010, 28011, 28012, 28013, 28014, 28015, 28016, 28019, 28020, 28028, 28029, 28036, 28039, 28045, 28046</b></p>'
          }, ],
          seo_text: '<h3>jobMapp Mudanzas en Madrid</h3> <p>No hay nada más desconcertante que tener que hacer una mudanza y no saber cuanto cuesta una mudanza ni que empresas de mudanzas ofrecen el mejor precio. Si estás buscando una empresa de mudanza en Madrid y no sabes cuál escoger no te compliques, aquí encontrarás las mudanzas más económicas. Trabajamos con diferentes empresas de mudanzas para que no tengas que buscar mudanzas baratas en Madrid, ¡ya te las ofrecemos nosotros! Explícanos con detalle cómo será tu mudanza. Dinos si es una mudanza grande o pequeña (necesitaremos saber los metros cuadrados de tu casa), si hay ascensor, facilidad de acceso, etc. Haremos un cálculo aproximado para darte un presupuesto de tu mudanza. En solo 3 minutos tendrás el precio de tu mudanza y podrás encargarla al momento.</p>',
          city: {
            short_name: 'Madrid',
            long_name: 'Madrid',
            encode_name: 'madrid'
          },
          kmlUrl: env.apiEndPoint + '/kml/mooving-mad-two-zones_5.kml',
          postcodes: [
            '28001', '28002', '28003', '28004', '28005', '28006', '28007', '28008', '28009', '28010', '28011', '28012', '28013', '28014', '28015', '28016', '28019', '28020', '28028', '28029', '28036', '28039', '28045', '28046'
          ],
          landing_page: env.apiEndPoint + '/servicios/mudanzas-en-madrid'
        },
        {
          id: serviceIdMoveMallorca[env.name],
          categoryId: 403,
          key: "mudanzas-mallorca",
          position: [39.602290, 2.986387],
          radius: 10000,
          zoom: 9,
          faq: [{
            title: '¿Cómo funciona?',
            description: '<p>Indícanos dirección de origen, destino y preferencia de horario de entrega. Asignaremos un mensajero en la zona para tu envío que acudirá inmediatamente. Solo se cobrará el servicio una vez realizada la entrega.</p>'
          }, {
            title: '¿Qué puedo enviar?',
            description: '<p>Todo paquete que pese menos de 5 kg con unas dimensiones máximas de 50 x 50 x 50 cm. El contenido debe ser legal y sin peligro.<p>'
          }, {
            title: '¿Puedo encargar un envío desde mi teléfono?',
            description: '<p>Sí. Puedes descargarte nuestra aplicación de jobMapp y al encargar un job de transporte elegir la opción de “Mensajería Palma 5 €”</p>'
          }, {
            title: '¿A qué hora está disponible?',
            description: '<p>La recogida y entrega se realizan en los siguientes horarios: 10:00h a 18:00h de lunes a sábado.</p>'
          }, {
            title: '¿Puedo elegir el destino que quiera?',
            description: '<p>Tanto la recogida como la entrega se hacen en los siguientes códigos postales:<br> <b>07001, 07002, 07003, 07004, 07005, 07006, 07007, 07008, 07009, 07010, 07011, 07012, 07013, 07014, 07015</b></p>'
          }, ],
          seo_text: '<h3>jobMapp Mudanzas en Mallorca</h3> <p>No hay nada más desconcertante que tener que hacer una mudanza y no saber cuanto cuesta una mudanza ni que empresas de mudanzas ofrecen el mejor precio. Si estás buscando una empresa de mudanza en Mallorca y no sabes cuál escoger no te compliques, aquí encontrarás las mudanzas más económicas. Trabajamos con diferentes empresas de mudanzas para que no tengas que buscar mudanzas baratas en Mallorca, ¡ya te las ofrecemos nosotros! Explícanos con detalle cómo será tu mudanza. Dinos si es una mudanza grande o pequeña (necesitaremos saber los metros cuadrados de tu casa), si hay ascensor, facilidad de acceso, etc. Haremos un cálculo aproximado para darte un presupuesto de tu mudanza. En solo 3 minutos tendrás el precio de tu mudanza y podrás encargarla al momento.</p>',
          city: {
            short_name: 'Mallorca',
            long_name: 'Mallorca',
            encode_name: 'mallorca'
          },
          kmlUrl: env.apiEndPoint + '/kml/mooving-mallorca_2.kml',
          postcodes: [
            '07001', '07002', '07003', '07004', '07005', '07006', '07007', '07008', '07009', '07010', '07011', '07012', '07013', '07014', '07015', '07100', '07101', '07108', '07109', '07110', '07120', '07121', '07122', '07140', '07141', '07142', '07143', '07144', '07150', '07157', '07159', '07160', '07170', '07179', '07180', '07181', '07183', '07184', '07190', '07191', '07192', '07193', '07194', '07195', '07196', '07198', '07199', '07200', '07208', '07209', '07210', '07220', '07230', '07240', '07250', '07260', '07300', '07310', '07311', '07312', '07313', '07314', '07315', '07316', '07320', '07330', '07340', '07349', '07350', '07360', '07369', '07400', '07420', '07430', '07440', '07450', '07458', '07459', '07460', '07469', '07470', '07500', '07509', '07510', '07511', '07518', '07519', '07520', '07529', '07530', '07540', '07550', '07559', '07560', '07570', '07579', '07580', '07589', '07590', '07600', '07609', '07610', '07611', '07620', '07629', '07630', '07638', '07639', '07640', '07650', '07659', '07660', '07669', '07670', '07680', '07687', '07688', '07689', '07690', '07691'
          ],
          landing_page: env.apiEndPoint + '/servicios/mudanzas-en-mallorca'
        },
        {
          id: serviceIdMoveBarcelona[env.name],
          categoryId: 403,
          key: "mudanzas-barcelona",
          position: [41.383, 2.183],
          radius: 10000,
          zoom: 11,
          faq: [{
            title: '¿Cómo funciona?',
            description: '<p>Indícanos dirección de origen, destino y preferencia de horario de entrega. Asignaremos un mensajero en la zona para tu envío que acudirá inmediatamente. Solo se cobrará el servicio una vez realizada la entrega.</p>'
          }, {
            title: '¿Qué puedo enviar?',
            description: '<p>Todo paquete que pese menos de 5 kg con unas dimensiones máximas de 50 x 50 x 50 cm. El contenido debe ser legal y sin peligro.<p>'
          }, {
            title: '¿Puedo encargar un envío desde mi teléfono?',
            description: '<p>Sí. Puedes descargarte nuestra aplicación de jobMapp y al encargar un job de transporte elegir la opción de “Mensajería Palma 5 €”</p>'
          }, {
            title: '¿A qué hora está disponible?',
            description: '<p>La recogida y entrega se realizan en los siguientes horarios: 10:00h a 18:00h de lunes a sábado.</p>'
          }, {
            title: '¿Puedo elegir el destino que quiera?',
            description: '<p>Tanto la recogida como la entrega se hacen en los siguientes códigos postales:<br> <b>08001, 08002, 08003, 08004, 08005, 08006, 08007, 08008, 08009, 08011, 08012, 08013, 08014, 08015, 08016, 08017, 08018, 08019, 08020, 08021, 08022, 08023, 08024, 08025, 08026, 08027, 08028, 08029, 08030, 08031, 08032, 08033, 08034, 08035, 08036, 08037, 08038, 08039, 08041, 08042</b></p>'
          }, ],
          seo_text: '<h3>jobMapp Mudanzas en Barcelona</h3> <p>No hay nada más desconcertante que tener que hacer una mudanza y no saber cuanto cuesta una mudanza ni que empresas de mudanzas ofrecen el mejor precio. Si estás buscando una empresa de mudanza en Barcelona y no sabes cuál escoger no te compliques, aquí encontrarás las mudanzas más económicas. Trabajamos con diferentes empresas de mudanzas para que no tengas que buscar mudanzas baratas en Barcelona, ¡ya te las ofrecemos nosotros! Explícanos con detalle cómo será tu mudanza. Dinos si es una mudanza grande o pequeña (necesitaremos saber los metros cuadrados de tu casa), si hay ascensor, facilidad de acceso, etc. Haremos un cálculo aproximado para darte un presupuesto de tu mudanza. En solo 3 minutos tendrás el precio de tu mudanza y podrás encargarla al momento.</p>',
          city: {
            short_name: 'Barcelona',
            long_name: 'Barcelona',
            encode_name: 'barcelona'
          },
          kmlUrl: env.apiEndPoint + '/kml/ecoscooting-bcn.kml',
          postcodes: [
              '08001', '08002', '08003', '08004', '08005', '08006', '08007', '08008', '08009', '08011', '08012', '08013', '08014', '08015', '08016', '08017', '08018', '08019', '08020', '08021', '08022', '08023', '08024', '08025', '08026', '08027', '08028', '08029', '08030', '08031', '08032', '08033', '08034', '08035', '08036', '08037', '08038', '08039', '08041', '08042'
          ],
          landing_page: env.apiEndPoint + '/servicios/mudanzas-en-barcelona'
        }
        // ,
        // {
        //   id: serviceIdEcoscooting[env.name],
        //   categoryId: 4,
        //   key: "mudanzas-madrid",
        //   position: [40.441, -3.697],
        //   radius: 10000,
        //   postcodes: ['28001', '28002', '28003', '28004', '28005', '28006', '28007', '28008', '28009', '28010',
        //                     '28011', '28012', '28013', '28014', '28015', '28016', '28019', '28020', '28028', '28029',
        //                     '28036', '28039', '28045', '28046'],
        //   actionSheetText: gettextCatalog.getString("Mudanzas Madrid"),
        //   specialForm: 'movers'
        // },

        // {
        //   id: serviceIdEcoscooting[env.name],
        //   categoryId: 4,
        //   key: "transporte-furgo-madrid",
        //   position: [40.441, -3.697],
        //   radius: 100,
        //   postcodes: ['28001', '28002', '28003', '28004', '28005', '28006', '28007', '28008', '28009', '28010',
        //                     '28011', '28012', '28013', '28014', '28015', '28016', '28019', '28020', '28028', '28029',
        //                     '28036', '28039', '28045', '28046'],
        //   actionSheetText: gettextCatalog.getString("Transporte en furgo Madrid"),
        //   specialForm: 'van-transport'
        // }

      ];

      var IDpartners = {}
      angular.forEach(partnerServices, function(partner) {
        IDpartners[partner.id] =true;
      })


      return {
        available: function(categoryId) {
          var availbePartnerServices = partnerServices.filter(function(serv) {
            // if service has position and distance, check if in boundaries
            if (serv.position && serv.radius) {
              result = (serv.categoryId == categoryId) && (GeoLocation.distanceToCurrent(serv.position) <= serv.radius);
            } else {
              result = (serv.categoryId == categoryId)
            }
            return result;
          });
          return availbePartnerServices;
        },
        allInCat: function(categoryId) {
          var allPartnerServices = partnerServices.filter(function(serv) {
            return (serv.categoryId == categoryId);
          });
          return allPartnerServices;
        },
        all: function() {
          return partnerServices;
        },
        get: function(serviceId) {
          // Simple index lookup, but only deliver first result, no check on index error (>1 results)
          var partnerService = partnerServices.filter(function(serv) {
            return serv.id == serviceId;
          });
          return partnerService[0];
        },
        serviceIdEcoscooting: function() {
          return serviceIdEcoscooting[env.name];
        },
        serviceIdEcoscootingBcn: function() {
          return serviceIdEcoscootingBcn[env.name];
        },
        serviceIdRetroscooting: function() {
          return serviceIdRetroscooting[env.name];
        },
        serviceIdMoveMadrid: function() {
          return serviceIdMoveMadrid[env.name];
        },
        serviceIdMoveMallorca: function() {
          return serviceIdMoveMallorca[env.name];
        },
        serviceIdMoveBarcelona: function() {
          return serviceIdMoveBarcelona[env.name];
        },
        isPartner: function(idPartner) {
          if (IDpartners[idPartner]) {
            return true;
          } else {
            return false
          }
        },
        getRelationPartners: function(serviceId, categoryId) {
          var relationCategory = [];
          var allOfCategory = this.allInCat(categoryId);
          angular.forEach(allOfCategory, function(partner) {
            if (partner.id != serviceId) {
                relationCategory.push(partner);
            }
          })
          return relationCategory;
        }
      }
    }
  ]);
