angular.module('jobmapp.generics.services')
.factory('ServiceExtentions', [
  'env',
  function(env){
    return {
      transformRequest: function (service, headers) {
        if (service.description) {
          _(['es', 'en']).forEach(function (lang) {
            if (service.description[lang] || service.description[lang] == '') {
              sevice.description[lang] = null;
            }
          }).values()
        };
        console.log( angular.toJson(service) );
        return angular.toJson(service);
      },
      transformResponse: function (service) {
        // Input type="number" fields need to be populated with floats. So make sure, that the prices are floats.
        if (service.price) {
          service.price = parseFloat(service.price);
        };
        if (service.hourly_rate) {
          service.hourly_rate = parseFloat(service.hourly_rate);
        };
        if (service.call_out_price) {
          service.call_out_price = parseFloat(service.call_out_price);
        };
        service.photoServerPathByName = {};
        service.photoThumbServerPathByName = {};

        service.photoPaths = _.map(service.photo_file_names, function(fileName){
          var path = env.apiEndPoint + "/uploads/services/final/" + fileName;
          var thumbPath = env.apiEndPoint + "/uploads/services/final/thumb_" + fileName;
          service.photoServerPathByName[fileName] = path;
          service.photoThumbServerPathByName[fileName] = thumbPath;
          return path;
        })
        if (service.jobber_page.user.photo_file_name) {
          service.jobber_page.user.photoPath = env.apiEndPoint + "/uploads/users/" + service.jobber_page.user.photo_file_name
        } else {
          service.jobber_page.user.photoPath = '/img/user_dark.png'
        }
        if (!service.title) {
          if (service.description != null ) {
            if (service.description.es.length > 80) {
              service.title = service.description.es.slice(0,80) + '...';
            } else if (service.description.es.length > 40) {
              service.title = service.description.es.slice(0,40) + '...';
            } else {
              service.title = service.description.es;
            }
          }

        }


        return service;
      }

    }
  }
]);
