angular.module('jobmapp.generics.services')
.service('Session', [
  function() {
    var self = this;
    self.options = {};

    self.init = function(options){
      angular.extend(self.options, options);
    }

    self.authentication_token = null;
    self.uuid = null;

    this.create = function (authentication_token, uuid, userRole) {
      self.authentication_token = authentication_token;
      self.uuid = uuid;
      self.userRole = userRole;

      if (self.options.afterCreateHook) {
        self.options.afterCreateHook.call(self);
      }
    };

    this.destroy = function () {

      // Then destroy device tokens on mobile
      window.localStorage.removeItem("apns_device_token");
      window.localStorage.removeItem("gcm_device_token");

      // Then delete user from device
      this.authentication_token = null;
      this.uuid = null;
      this.userRole = null;
      window.localStorage.removeItem("uuid");
      window.localStorage.removeItem("token");
      window.localStorage.removeItem("role");

      // TODO: check if the following code line is right. looks wrong to me (WL)
      window.localStorage['fbtoken'] = "";
      if (self.options.afterDestroyHook) {
        self.options.afterDestroyHook.call(self);
      }
    };
    return this;
  }
]);
