angular.module('starter.controllers', [])


// ============================ Functional Controlers ============================

.controller('ShowLocationCtrl', function($scope, $stateParams, $state, Job, JobMap) {
  $scope.kind  = $stateParams.kind;
  switch($scope.kind) {
    case 'job':
      $scope.latitude   = $stateParams.objectWithPosition.position[0];
      $scope.longitude  = $stateParams.objectWithPosition.position[1];
      break;
    case 'jobber':
      $scope.latitude   = $stateParams.objectWithPosition.jobber_page.fixed_position[0];
      $scope.longitude  = $stateParams.objectWithPosition.jobber_page.fixed_position[1];
      break;
    default:
      break;
  }  
  
})

.controller('HelpMenueController', function($scope, $rootScope, $timeout, $ionicPopover, $cordovaInAppBrowser, $ionicModal, $ionicSlideBoxDelegate) {
  // // .fromTemplate() method
  // $scope.popover = $ionicPopover.fromTemplate(template, {
  //   scope: $scope
  // });

  // .fromTemplateUrl() method
  $ionicPopover.fromTemplateUrl('templates/popover-helpmenue.html', {
    scope: $scope
  }).then(function(popover) {
    $scope.popover = popover;
  });


  $scope.openPopover = function($event) {
    $scope.popover.show($event);
  };
  $scope.closePopover = function($event) {
    $scope.popover.hide($event);
    console.log("popOver Scopedestroy");
  };
  

  var options = {
    location: 'no',
    toolbar: 'yes',
    //closebuttoncaption: 'DONE?',
    //hardwareback: 'yes'
  };

  $scope.openBrowser = function(url, location) {
    if (location && location == 'location') {
      options.location = 'yes'
    } else {
      options.location = 'no';
    }
    if (location && location == 'system') {
      target = '_system'
    } else {
      target = '_blank';
    }

    $cordovaInAppBrowser.open(url, target, options)
      .then(function(event) {
        console.log("in App browser success");
      })
      .catch(function(event) {
        console.log("in APp browser error");
      });
  }

  $rootScope.showIntro = function () {
    window.localStorage.setItem("introSeen", true);
    $ionicModal.fromTemplateUrl('templates/modal-intro.html', {
      scope: $scope,
      animation: 'slide-in-up'
    }).then(function(modal) {
      $scope.modalIntro = modal;
      $scope.$on('$stateChangeStart', function(event, toState, toParams, fromState, fromParams) {
        $scope.modalIntro.hide();
      });
      $scope.modalIntro.show();
      $ionicSlideBoxDelegate.enableSlide(false);
      if (window.cordova && window.cordova.plugins.Keyboard) {
        $timeout(function () {
          cordova.plugins.Keyboard.close();
          window.cordova.plugins.Keyboard.close();
        }, 1);
      }
    });
  }
})


.controller('HelpModalController', function($scope, $ionicModal, $timeout) {
  $ionicModal.fromTemplateUrl('templates/modal-help.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modal = modal;
  });
  $scope.openModal = function() {
    $scope.modal.show();
    if (window.cordova && window.cordova.plugins.Keyboard) {
      $timeout(function () {
        cordova.plugins.Keyboard.close();
        window.cordova.plugins.Keyboard.close();
      }, 1);
    }
  };
  $scope.closeModal = function() {
    $scope.modal.hide();
    $scope.modal.remove();
  };
  //Cleanup the modal when we're done with it!
  $scope.$on('$destroy', function() {
    $scope.modal.remove();
  });
  // Execute action on hide modal
  $scope.$on('modal.hidden', function() {
    // Execute action
  });
  // Execute action on remove modal
  $scope.$on('modal.removed', function() {
    // Execute action
  });

  $scope.priceHelp = function () {
    $scope.openModal();
  }


})



.controller('IntroController', function($scope, $rootScope, AUTH_EVENTS, $ionicModal, $timeout, $ionicSlideBoxDelegate, User, gettextCatalog, $state) {
  $scope.sliderPages = false;
  $scope.jobberSelect = false;
  $scope.bossSelect = false;
  $scope.modal = null;

  $scope.next = function(select) {
    if(select == 'jobber'){
      $scope.jobberSelect = true;
      $scope.bossSelect = false;
      // BranchIo.userCompletedAction("is_jobber", null);
    }
    if (select == 'boss') {
      $scope.bossSelect = true;
      $scope.jobberSelect = false;
      // BranchIo.userCompletedAction("is_boss", null);
    }
    $ionicSlideBoxDelegate.next();
  };
  $scope.previous = function() {
    if ($ionicSlideBoxDelegate.currentIndex() == $scope.slideJobber || $ionicSlideBoxDelegate.currentIndex() == $scope.slideCreator) {
      $ionicSlideBoxDelegate.slide(1);
    } else {
      $ionicSlideBoxDelegate.previous();      
    }
  };
  $scope.slideChanged = function(index) {
    $scope.slideIndex = index;
    if($scope.slideIndex != '1') {
      $ionicSlideBoxDelegate.enableSlide(true);
      $scope.sliderPages = true;
    } else {
      $ionicSlideBoxDelegate.enableSlide(false);
      $scope.sliderPages = false;
    }
    if ($scope.slideIndex == '5') {
      $scope.sliderPages = false;
    }
  };
  $scope.startApp = function() {
    $scope.introIsShow = false;
    $scope.jobberSelect = false;
    $scope.bossSelect = false;
    $scope.sliderPages = false;
    $scope.$parent.modalIntro.hide();
    $ionicSlideBoxDelegate.slide(0,0);
  };
  $scope.goToJobber = function() {
    $state.go('tab.account');
    $scope.startApp();
  };
  $scope.goToBoss = function() {
    $state.go('tab.createjob');
    $scope.startApp();
  };
  $scope.changeLanguage = function(language) {
    if (language == 'english') {
      $scope.$parent.setLanguage('en');
    } else if (language == 'spanish') {
      $scope.$parent.setLanguage('es');
    }
  };
  
  $scope.$on('modal.show', function($event) {});
  //Cleanup the modal when we're done with it!
  $scope.$on('$destroy', function($event) {});
  // Execute action on hide modal
  $scope.$on('modal.hidden', function($event) {});
})

.controller('FilterController', function($scope, $ionicPopover, $rootScope, jobCategories) {
  // // .fromTemplate() method
  // $scope.popover = $ionicPopover.fromTemplate(template, {
  //   scope: $scope
  // });

  $scope.distanceArray = [
    {label: "10 km", value: 10}, 
    {label: "20 km", value: 20}, 
    {label: "30 km", value: 30}, 
    {label: "40 km", value: 40}, 
    {label: "50 km", value: 50}, 
    {label: "75 km", value: 75}, 
    {label: "100 km", value: 100}, 
    {label: "150 km", value: 150}, 
    {label: "500 km", value: 500}, 
    {label: "∞", value: 50000}
  ];
  
  $scope.slider = {};
  $scope.slider.rangeValue = 8;
  $scope.filterdata = {};

  var filterStorage = window.localStorage.getItem('filterdata');
  $scope.jobCategories = jobCategories.main_filter(); 
  $scope.filterdata.categories = [];
  if (filterStorage && filterStorage != 'undefined') {
    $scope.filterdata.maxDistance = parseInt(JSON.parse(filterStorage).maxDistance);
    console.log("$scope.filterdata.maxDistance", $scope.filterdata.maxDistance);
    $scope.slider.rangeValue = _.findIndex($scope.distanceArray, {value: $scope.filterdata.maxDistance});    
    $scope.filterdata.anyDistance = JSON.parse(filterStorage).anyDistance;
    $scope.filterdata.categories = JSON.parse(filterStorage).categories;
    $scope.filterdata.anyCategory = JSON.parse(filterStorage).anyCategory;
    $scope.jobCategories = _.map($scope.jobCategories, function(cat) {
      if ($scope.filterdata.categories.indexOf(cat.id) > -1) cat.active = true;
      else cat.active = false;
      return cat;
    });
    console.log("filter data", $scope.filterdata, $scope.slider.rangeValue);
  } else {
    $scope.jobCategories = _.map($scope.jobCategories, function(cat) {
      if (cat.show) cat.active = true;
      return cat;    
    });
    $scope.filterdata.anyCategory = true;
    $scope.filterdata.anyDistance = false;
    $scope.filterdata.maxDistance = 500;
  }

  // .fromTemplateUrl() method
  $ionicPopover.fromTemplateUrl('templates/popover-filter.html', {
    scope: $scope
  }).then(function(popover) {
    $scope.popover = popover;
  });


  $scope.openFilterPopover = function($event) {
    $scope.filterdata.anyDistance = $scope.filterdata.anyDistance || null;
    $scope.filterdata.anyCategory = $scope.filterdata.anyCategory || null;
    $scope.popover.show($event);
  };

  $scope.closeFilterPopover = function() {
    $scope.popover.hide();
  };

  $scope.resetFilters = function () {
    $scope.filterdata.anyDistance = true;
    $scope.filterdata.anyCategory = true;
    $scope.jobCategories = _.map($scope.jobCategories, function(cat) {
      cat.active = true;
      return cat;
    });
    $scope.filterdata.maxDistance = 150;
    //$scope.closeFilterPopover();
  }

  //Cleanup the popover when we're done with it!
  $scope.$on('$destroy', function() {
    $scope.popover.remove();
  });
  // Execute action on hide popover
  $scope.$on('popover.hidden', function() {
    $scope.filterdata.categories = [];
    _.each($scope.jobCategories, function(elm) {
      if (elm.active == true && elm.show == true) $scope.filterdata.categories.push(elm.id);
    })
    $rootScope.$broadcast('filter_changed');
    });
  // Execute action on remove popover
  $scope.$on('popover.removed', function() {
    // Execute action
  });

  var filterChanged = function(newVal, oldVal) {
    if (newVal != oldVal) {
      $scope.filterdata.categories = [];
      _.each($scope.jobCategories, function(elm) {
        if (elm.active == true && elm.show == true) {
          $scope.filterdata.categories.push(elm.id);
        }
      })
      // hack
      if ($scope.filterdata.categories.length < 8) {
        $scope.filterdata.anyCategory = false;
      } else {
        $scope.filterdata.anyCategory = true;
      }
      window.localStorage.setItem('filterdata', JSON.stringify($scope.filterdata));
      $rootScope.$broadcast('filter_changed');
    }
  }

  var distanceChanged = function(newVal, oldVal) {
    if (newVal != oldVal) {
      $scope.filterdata.maxDistance = $scope.distanceArray[newVal].value;
      console.log("newVal", newVal);
      if ($scope.filterdata.maxDistance == 50000) $scope.filterdata.anyDistance = true;
      else $scope.filterdata.anyDistance = false;
      window.localStorage.setItem('filterdata', JSON.stringify($scope.filterdata));
      $rootScope.$broadcast('filter_changed');      
    }
  }

  $scope.$watch('jobCategories[0].active', filterChanged) 
  $scope.$watch('jobCategories[1].active', filterChanged) 
  $scope.$watch('jobCategories[2].active', filterChanged) 
  $scope.$watch('jobCategories[3].active', filterChanged) 
  $scope.$watch('jobCategories[4].active', filterChanged) 
  $scope.$watch('jobCategories[5].active', filterChanged) 
  $scope.$watch('jobCategories[6].active', filterChanged) 
  $scope.$watch('jobCategories[7].active', filterChanged) 
  $scope.$watch('jobCategories[8].active', filterChanged) 
  $scope.$watch('jobCategories[9].active', filterChanged) 
  $scope.$watch('slider.rangeValue',distanceChanged)

  var options = {
    location: 'no',
    toolbar: 'yes',
    //closebuttoncaption: 'DONE?',
    //hardwareback: 'yes'
  };

})

;
