angular.module('starter.controllers')

// ============================ General App Controller ============================
// Account Tab and Login Controller plus all related controllers

.controller('AccountCtrl', function($scope, $rootScope, $timeout, $state, $stateParams, $ionicModal, $ionicLoading, User, env, Session, FacebookFriends, FacebookStories, Sharing, gettextCatalog, JobMap, Camera, jobCategories, googleAnalytics) {
  $scope.skipJobberpage = false;
  $scope.state = $state.current.name;
  $scope.profileMap = new JobMap();
  $scope.canvas = $state.current.data.map_canvas;
  $scope.business_position = [];
  $scope.jobCategories = jobCategories;

  $scope.refreshMap = function() {
    if ($rootScope.currentUser && $rootScope.currentUser.jobber_page && $rootScope.currentUser.jobber_page.fixed_position) {
      $scope.business_position = $rootScope.currentUser.jobber_page.fixed_position;
      $scope.fix = true;
    }
    $timeout(function(){
      if ($scope.fix) {
        $scope.profileMap.initMap($scope, $state.current.data.map_canvas, $scope.business_position, true)
        $scope.profileMap.addMarkersToMap($scope.business_position, ["Business"], "img/map_pin.png");
        $scope.profileMap.SetCenter($scope.business_position);
      }
    }, 1000);
  }

  $scope.doRefresh = function() {
    User.get().$promise.then(function (user) {
      $scope.setCurrentUser(user);
      $scope.user = $rootScope.currentUser;
      $scope.credits = 0;
      if ($scope.user.jobber_page && $scope.user.jobber_page.fixed_position) {
        $scope.user.jobberPageFixLocationStyle = {
          'background-image': 'url(\'https://maps.googleapis.com/maps/api/staticmap?center=' + user.jobber_page.fixed_position[0] + ',' + user.jobber_page.fixed_position[1] + '&zoom=17&size=640x640&maptype=roadmap\')'
        };
      }

      if ($rootScope.currentUser) {
        FacebookStories.fbLoginStatus()
          .then(function(res){
            // success
            $scope.fbLoginStatus = res;
          });
        // Deactivated: get Facebook Friends
        // console.log("current user:", $rootScope.currentUser);
        // $scope.initFacebookFriends();
      };

    })
    .finally(function() {
     // Stop the ion-refresher from spinning
     $scope.$broadcast('scroll.refreshComplete');
    });
  }

  $scope.$on("$ionicView.enter", function() {
    $scope.doRefresh();
  });

  if (Session.authentication_token) {
    $scope.doRefresh();
  }

  $scope.showFileUpload = false;
  $scope.referringUser = $stateParams.referringUser;
  // if (!$scope.referringUser && !$rootScope.currentUser) BranchIo.getReferringParams().then(function (res) {
  //   if (res && res.referringUser) $scope.referringUser = res.referringUser;
  // });

  // CURRENTLY DEACTIVATED - Facebook Friends
  // $scope.initFacebookFriends = function(){
  //   FacebookStories.fbLoginStatus()
  //     .then(function(res){
  //       // success
  //       $scope.fbLoginStatus = res;
  //       if ($scope.fbLoginStatus == 'connected') {
  //         console.log("FacebookFriends.init call");
  //         FacebookFriends.init().then(function() {
  //           $scope.friends = FacebookFriends.list;
  //           $scope.numberFriends = FacebookFriends.totalCount;
  //           $scope.friendsOnJobMapp = FacebookFriends.onJobMapp;
  //           User.update({
  //             user: {
  //               friendsOnJobMapp: $scope.friendsOnJobMapp,
  //               fb_friends_total: $scope.numberFriends
  //             }}).$promise
  //           // get likesAppPage after get friends, if you do it in parallel only one delivers result
  //           FacebookStories.likesAppPage().then(function (res) {
  //             $scope.likesAppPage = res;
  //             if ($scope.likesAppPage == true) BranchIo.userCompletedAction("fb_likesAppPage", null);
  //           });
  //         });
  //       }
  //     }, function(res){
  //       // fail
  //       //$scope.fbLoginStatus = res;
  //     })

  // }


  var shareObject = {};

  shareObject.shareMessage  = gettextCatalog.getString("Te podría interesar esta app - ¡Jobs para todos!");
  shareObject.shareSubject  = "jobMapp";
  shareObject.shareImage    = "https://jobmapp.com/assets/jobmapp_fb_sillin_calle-746cafaf626531effc36099346b1b997.jpg";
  shareObject.shareLink     = "https://jobmapp.com";

  $scope.shareAction = function() {
    // if ($rootScope.currentUser) {
    //   BranchIo.getShortUrl({
    //     referringUser:
    //     {uuid: $rootScope.currentUser.uuid,
    //      name: $rootScope.currentUser.name,
    //      picture: $rootScope.currentUser.bigImagePath()
    //     }}, "app", "sharing")
    //     .then(function(url) {
    //     shareObject.shareLink = url;
    //     Sharing.shareAction(shareObject, gettextCatalog.getString("Invita tus amigos con..."));
    //   });
    // } else {
      Sharing.shareAction(shareObject, gettextCatalog.getString("Invita tus amigos con..."));
    // }
  };

  $scope.uploadPhoto = function(pictureType, inputName) {
    var restUrl = "/me/photo-upload.json";
    if (pictureType == 'header') restUrl = "/me/header-upload.json";
    var options = {};
    if ($scope.onDevice || inputName) {
      $scope.showSpinnerx = true;
      Camera.uploadPhoto(options, restUrl, inputName)
        .then(function(fileName) {
          // Success! Image data is here
          if (pictureType == 'profile') {
            $rootScope.currentUser.photo_file_names.push(fileName);
            $rootScope.currentUser.photoPaths.push(env.apiEndPoint + "/uploads/users/" + fileName);
          } else if (pictureType == 'header') {
            $rootScope.currentUser.header_file_names.push(fileName);
            $rootScope.currentUser.headerPhotoPaths.push(env.apiEndPoint + "/uploads/user-headers/" + fileName);
          }
        }, function(err) {
          console.log("upload Photo Error", err);
        })
        .finally(function(){
          $scope.showSpinnerx = false;
        });
      $scope.showFileUpload = false;
    } else {
      if (pictureType == 'profile') {
        $scope.showFileUpload = true;
      } else {
        $scope.showFileUploadHeader = true;
      }
    }
  }

  $scope.goToChildState = function(childState, params) {
    if ($rootScope.currentUser) {
      $state.go('.jobberpage' + childState, params);
    }
  }

  $scope.setSkipJobberPage = function() {
    $scope.skipJobberpage = true;
  }

  $scope.hintToShow = function() {
    if ($scope.skipJobberpage) return 'later';
    if (!$rootScope.currentUser) return 'login';
    if (!$rootScope.currentUser.is_jobber) return 'no-jobber';
    if (!$rootScope.currentUser.public) return 'go-public';
    if (!$rootScope.currentUser.jobber_page || $rootScope.currentUser.jobber_page.fixed_position == null) return 'go-map';
    if (!$rootScope.currentUser.photo_file_names || $rootScope.currentUser.photo_file_names == 0) return 'foto';
    if (!$rootScope.currentUser.description || $rootScope.currentUser.description.length == 0) return 'description';
    if (!$rootScope.currentUser.jobber_page || !$rootScope.currentUser.jobber_page.services || $rootScope.currentUser.jobber_page.services.length == 0) return 'service';
    // catchall
    return 'complete';
  }


  //Modal for Show Ratings, Facebook friends
  $scope.showModal = function (template) {
    if(template == 'facebook') {
      template = 'templates/_facebook-friends.html';
    }
    if(template == 'ratings') {
      template = 'templates/_ratings.html';
    }

    $ionicModal.fromTemplateUrl(template, {
      scope: $scope,
      animation: 'slide-in-up'
    })
    .then(function (modal) {
      $scope.modal = modal;
      $scope.modal.show();
    });
  };
  $scope.closeModal = function() {
    $scope.modal.hide();
    $scope.modal.remove();
  };

  //Share
  $scope.shareContent = function(channel) {
    $ionicLoading.show({templateUrl : 'templates/loading-animation.html', hideOnStateChange: true, duration: 10000});
    var urlParams = {
      referringUser: {
          uuid: $rootScope.currentUser.uuid,
          name: $rootScope.currentUser.name,
          picture: $rootScope.currentUser.bigImagePath()
      },
      $desktop_url : shareObject.shareLink,
      $android_url : shareObject.shareLink,
      $ios_url : shareObject.shareLink
    };
    googleAnalytics.event({
      action: 'share my profile',
      category: 'social buttons',
      label: '',
      mixpanel: {
        'social network':     channel,
        'url shared':         $rootScope.currentUser.getFullUrl(),
        'user id':            $rootScope.currentUser.id,
        'aplication':         'app'
      }
    });
//     BranchIo.getShortUrl(urlParams, "app", "jobsharing").then(function(url) {
//       shareObject.shareLink = url;
//       if(channel == 'facebook'){
//         //Sharing.shareFacebook(shareObject);
//         Sharing.shareActionFb(shareObject);
//       }
//       if(channel == 'sharing'){
//         Sharing.shareOthers(shareObject);
//       }
//       if(channel == 'twitter'){
// //        Sharing.shareOthers(shareObject);
//       }
//       if(channel == 'whatsapp'){
//         Sharing.shareWhatsapp(shareObject);
//       }

//     });
  }

  //Share Profile
  $scope.shareProfile = function(channel) {
    $ionicLoading.show({templateUrl : 'templates/loading-animation.html', hideOnStateChange: true, duration: 10000});

    //build shareObject
    var shareObject = {};
    if ($rootScope.currentUser.id == $scope.user.id) {
      shareObject.shareMessage  = gettextCatalog.getString("Este es mi perfil en jobMapp!");
    }
    else {
      shareObject.shareMessage  = gettextCatalog.getString("Mira este perfil de jobMapp!");
    }

    shareObject.shareSubject  = "jobMapp";
    shareObject.shareImage    = $scope.user.bigImagePath();
    shareObject.shareLink     = $scope.user.getFullUrl();

    //build urlParams
    var urlParams = {
      $desktop_url : shareObject.shareLink,
      $android_url : 'jobmapp://jobbers/' + $scope.user.id,
      $ios_url : 'jobmapp://jobbers/' + $scope.user.id,
      jobber_id : $scope.user.id
    }
    if ($rootScope.currentUser) {
      urlParams.referringUser = {
        uuid: $rootScope.currentUser.uuid,
        name: $rootScope.currentUser.name,
        picture: $rootScope.currentUser.bigImagePath()
      }
    }
    googleAnalytics.event({
      action: 'share profile',
      category: 'social buttons',
      label: '',
      mixpanel: {
        'social network': channel,
        'url shared':     $scope.user.getFullUrl(),
        'user id':        $scope.user.id,
        'aplication':     'app'
      }
    });

//     BranchIo.getShortUrl(urlParams, "app", "jobbersharing").then(function(url) {
//       shareObject.shareLink = url;
//       if(channel == 'facebook'){
//         Sharing.shareFacebook(shareObject);
//       }
//       if(channel == 'sharing'){
//         Sharing.shareOthers(shareObject);
//       }
//       if(channel == 'twitter'){
// //        Sharing.shareOthers(shareObject);
//       }
//       if(channel == 'whatsapp'){
//         Sharing.shareWhatsapp(shareObject);
//       }

//     });
  }


});
