angular.module('starter.controllers')
.controller('ChatCtrl', function($scope, $rootScope, $timeout, $state, Message, MessageService, env, $ionicScrollDelegate, Job, gettextCatalog) {  
  $scope.state = $state.current.name;
  $scope.chatMessageText = null;
  $scope.chatMessagePlaceholder = '';

  // var unregisterJobMsgListener = null;

  $scope.doRefresh = function(){
    $scope.goBottomChat();
    Job.get({id: $scope.chat.job.id}).$promise.then(function(job){
      $scope.chat.job = job;
      $scope.goBottomChat();
    })
  }

  $scope.goBottomChat = function () {
    $timeout(function() {
      window.delg = $ionicScrollDelegate;
      // This is a hack as $getByHandle seems to be broken.
      var scrollDelegateInstances = $ionicScrollDelegate.$getByHandle('chat')._instances.filter(function(instance){
        return instance.$$delegateHandle == "chat"});
      if (scrollDelegateInstances.length > 0) { 
        scrollDelegateInstances[0].scrollBottom(true);
      }
    }, 1);
  }

  var init = function(){
    $rootScope.$on("new-chat-message", function() {
      // $scope.doRefresh();
    });

    $scope.chatMessageText = $scope.chatMessageText || null;
    $scope.messagePlaceholder = gettextCatalog.getString('¡Manda tu mensaje privado aquí!');
    $scope.goBottomChat();
  }
  init();

  $scope.send = function(){

    // Do not do anything unless there is some input.
    if(!$scope.chatMessageText || $scope.chatMessageText.length == 0) {
      // console.log("no message");
      return false;
    }

    var messageDraft = {
      body: $scope.chatMessageText,
      job_id: $scope.chat.job.id,
      private: true,
      to_id: null,
      kind: $rootScope.currentUser.id == $scope.chat.job.user_id ? MessageService.kind.from_job_creator : MessageService.kind.from_jobber
    }
    var sentMessageIndex;
    
    if ($scope.chat.toId) {
      messageDraft.to_id = $scope.chat.toId;
    } else if ($rootScope.currentUser.id == $scope.chat.job.user_id) {
      console.log('WARNING: to_user is jobber with id', $scope.chat.job.candidates[0].id);
      messageDraft.to_id = $scope.chat.job.candidates[0].id;
    } else {
      console.log('WARNING: to_user is job creator with id', $scope.chat.job.user_id);
      messageDraft.to_id = $scope.chat.job.user_id;
    }
  
    var message = new Message(messageDraft);
    $scope.goBottomChat();
    message.$save().then(function(responseMessage){
      $scope.chat.job.messages[sentMessageIndex] = responseMessage;
    }, function(){
      console.log("could not send message");
    }).finally(function(){
    });

    $scope.chat.job.messages = $scope.chat.job.messages || [];
    messageDraft.created_at = new Date();
    messageDraft.status = "sending";
    messageDraft.from_user = {
      id: $rootScope.currentUser.id, 
      name: $rootScope.currentUser.name,
      thumbPath: $rootScope.currentUser.thumbPath()
    };

    $scope.chat.job.messages.push(messageDraft);
    sentMessageIndex = $scope.chat.job.messages.length - 1;

    $scope.chatMessageText = ''; 
  };
  
});