angular.module('starter.controllers')

// ============================ Create Job Tab ============================
// For Create Job Tab and all sub pages

.controller('CreateJobCategoryCtrl', function($scope, jobCategories, jobForm, jobFormData) {
  $scope.job = jobFormData;

  $scope.jobCategories = jobCategories.main();
  $scope.jobSubcategories = jobCategories;

  $scope.$on('$ionicView.beforeEnter', function() {
    // Completely reset job when entering jobCategory selection screen
    //for (var member in $scope.job) delete $scope.job[member];
    jobForm.resetDraft();

    // before we just deleted the sub category setting, I leave this here until we are sure the line above works fine:
    // if ($scope.job.specialSubCategory) {
    //   $scope.job.specialSubCategory = null;
    // }
  });

})

.controller('CreateJobCtrl', function($scope, $rootScope, $stateParams, $state, $ionicPopup, $timeout, $cordovaDatePicker, $cordovaActionSheet, jobForm, jobFormData, jobCategories, env, gettextCatalog, Service, popupCheckContact, popupCheckPictures, popupPayment, popupSaveUpdateJob, GeoLocation, partnerServices) {
  $scope.job = jobFormData;
  $scope.job.uploading = $scope.job.uploading || [];
  $scope.enablePublishBtn = true;
  $scope.job.service = null;
  $scope.state = $state.current.name;

  // this is for deep link jobmapp://createjob/4/mensajeria
  // replace id selection when the deep link format has changed to permanent solution
  if ($stateParams.specialSubCategory == 'ecoscooter') {
    $scope.job.specialSubCategory = 'ecoscooter';
    $scope.job.service_id = partnerServices.serviceIdEcoscooting();
  }

  // This is a hack as this information would not be available in template otherwise
  $scope.isAndroid = ionic.Platform.isAndroid();
  var steps = 4;
  // if ($rootScope.currentUser && $rootScope.currentUser.generalConditionsAccepted) $scope.job.generalConditionsAccpeted = true;

  var doRefresh = function() {
    if(!$scope.job.id) {
      $scope.job = jobForm.getDraft();
    }
    if ($scope.job.service_id) {
      Service.get({id: $scope.job.service_id}).$promise
        .then(function(service){
          $scope.job.service = service;
          $scope.service = service;
          $scope.job.price = $scope.job.price || $scope.service.price;
          $scope.job.currency = $scope.job.currency || $scope.service.currency;
        }, function(){
          console.log("Could not load service for job", $scope.job.service_id);
        })
    }

    if(typeof($scope.job.date) != 'undefined' && $scope.job.date && moment($scope.job.date).isValid()) {
      $scope.isValidDate = true;
    } else {
      $scope.isValidDate = false;
    }

    var completedSteps = 1 * Boolean($scope.job.price) + 1 * Boolean($scope.job.description) + 1 * Boolean($scope.isValidDate) + 1 * Boolean($scope.job.position) + 1 * Boolean($scope.job.position2); // + 1 * Boolean($scope.job.generalConditionsAccepted);
    if ($scope.job.specialSubCategory == 'ecoscooter') {
      steps = 3;
      completedSteps = 1 * Boolean($scope.job.position) + 1 * Boolean($scope.job.position_2) + 1 * Boolean($scope.isValidDate) ; // + 1 * Boolean($scope.job.generalConditionsAccepted);
    }
    $scope.missingSteps = steps - completedSteps;
  };

  $scope.$on('$ionicView.beforeEnter', function() {
    doRefresh();
  });

  // This part still is not really elegant. It belongs into the state's resolver:
  if($scope.job.id) {
    $scope.updating = true;
    $scope.jobCategories = jobCategories.main();
    $scope.jobCategory = jobCategories.get($scope.job.category_id);
    // Ugly hack which does two things:
    // - Find out that the date is without time and
    // - when we click to edit the date this controller gets invoked again. But then job.date is already overwritten. So we need to remember this by checking job.time is null. (The same controller gets called in the editing date view, too.)
    if (moment($scope.job.date).seconds() == 59) {
      // The original date encoded that the due date has only the date byt no time specified.
      if (typeof($scope.job.time) == 'undefined') {
        // Initialize job.time property as null so that the date pickers show nothing.
        $scope.job.time = null;
      }
    } else {
      // job.date has no original time component.
      if (typeof($scope.job.time) == 'undefined') {
        // job.time not yet set. Create it from the original job.date.
        $scope.job.time = moment($scope.job.date).toDate();
      }
    }
    $scope.job.date = moment($scope.job.date).toDate();
    $scope.viewTitleText = gettextCatalog.getString('Editar job');
    $scope.viewTitleIcon = 'img/categories/icons_white/' + $scope.jobCategory.icon;
  } else {
    // It is a brand new job
    $scope.jobCategory = jobCategories.get($stateParams["jobCategoryID"]);
    $scope.job.category_id = $scope.jobCategory.id;
    $scope.viewTitleText = gettextCatalog.getString('Crear job');
    $scope.viewTitleIcon = 'img/categories/icons_white/' + $scope.jobCategory.icon;
  }

  var subCategoryAction = function(partnerServices) {
    var homeOptions = {
      title: gettextCatalog.getString('¿Qué tipo de job?'),
      androidEnableCancelButton : false
    };

    // Add otros button and map Button Label array
    partnerServices.push({actionSheetText: gettextCatalog.getString("Otros"), specialForm: 'other'});
    homeOptions.buttonLabels = _.map(partnerServices, function(service) {return service.actionSheetText} );

    if ($scope.onDevice) {
      $cordovaActionSheet.show(homeOptions)
        .then(function(btnIndex) {
          $scope.job.specialSubCategory = partnerServices[btnIndex-1].specialForm
          $scope.job.service_id = partnerServices[btnIndex-1].id;
          console.log("selected", $scope.job.specialSubCategory, $scope.job.service_id);
          doRefresh();
        });
    } else {
      $scope.job.service_id = partnerServices[0].id;
      $scope.job.specialSubCategory = partnerServices[0].specialForm;
    }
  };

  // admins: get all partnerServices in current category, others show depending on distance
  // show action sheet if there are any available partner services (or special form services)

  if ($rootScope.currentUser && $rootScope.currentUser.role == "admin") {
    var ps = partnerServices.allInCat($scope.job.category_id);
  } else {
    var ps = partnerServices.available($scope.job.category_id);
  }
  if (ps.length > 0 && !$scope.job.specialSubCategory && !$scope.updating) {
    subCategoryAction(ps);
  }



  // // this is currently decatived in popupCheckContacts
  // $scope.showGeneralConditions = function() {
  //   var myPopup2 = $ionicPopup.alert({
  //     templateUrl: 'templates/_general-conditions.html',
  //     title: gettextCatalog.getString('Condiciones generales')
  //   });
  // }

  $scope.publishJob = function(job) {
    // Make sure that the publish button can only be clicked once.
    if($scope.enablePublishBtn == false) {
      return
    }
    var _MS_PER_DAY = 1000 * 60 * 60 * 24;
    var now = new Date();
    var jobdate = job.date;
    var dateDifference = Math.floor((jobdate - now) / _MS_PER_DAY);
    if ($rootScope.currentUser == null) {
      // If not logged in call LoginPopup instead of publishing (defined in App Controller, is there also a way to do this in the Login Controller?)
      $scope.showLoginPopup();
    } else if (dateDifference > 90 || dateDifference <-1) {
      // If date to far into future or in the past do not allow publishing
      var alertPopup = $ionicPopup.alert({
        title: gettextCatalog.getString('Corrige fecha'),        // (get strings registered for i18n)
        template: gettextCatalog.getString('Sólo se puede crear un job hasta 90 días en futuro y no en el pasado.')
      });
    } else {
      // OK let's proceed
      // If there are no pictures and it is not an ecocooter job then ask to add pictures to job
      popupCheckPictures.open(job)
        .then(
          // success popupCheckPictures
          function () {
            // Check on correct contact information of boss:
            popupCheckContact.open($scope, $rootScope, job)
              .then(
                //success popupCheckContact
                function () {
                  // get credit card data if ecoscooter
                  if (job.specialSubCategory == 'ecoscooter') {
                    popupPayment.getPaymentInfo($scope, job)
                      .then(
                        // success popupPayment.getPaymentInfo
                        function(paymentData) {
                          // save job
                          popupSaveUpdateJob.saveJob($scope, job)
                            .then(
                              // success popupSaveUpdateJob.saveJob
                              function(savedJob) {
                                // add jobId to payment data
                                paymentData.jobId = savedJob.id;
                                console.log("paymentData", paymentData);
                                //BranchIo.userCompletedAction("create_paid_job", {job_id: savedJob.id, price: savedJob.price, currency: savedJob.currency});
                                // authorise payment
                                popupPayment.authorizeServiceBooking(paymentData)
                                  .then(
                                    // sucess popupPayment.authorizeServiceBooking
                                    function() {
                                      $rootScope.refreshMyJobs = true;
                                      $rootScope.refreshSearchJobs = true;
                                      $timeout(function() {
                                        console.log("saved job id", savedJob.id );
                                        $state.go("tab.myjobs.confirmedjob", {id: savedJob.id});
                                      }, 1);
                                      // delete credit card data from scope
                                      for (var member in $scope.ccdata) delete $scope.ccdata[member];
                                      delete $scope.ccdata;
                                    },
                                    // error popupPayment.authorizeServiceBooking
                                    function(error) {
                                      console.log("payment error", error);
                                    }
                                  );
                              },
                              // error popupSaveUpdateJob.saveJob
                              function (error) {
                                console.log("job save failure", error);
                              }
                            );
                        },
                        // error popupPayment.getPaymentInfo
                        function(err) {
                          console.log("payment data NOT obtained", $scope);
                          $scope.enablePublishBtn = true;
                        }
                      );
                  } else {
                    if ($scope.updating) {
                      // update job
                      popupSaveUpdateJob.updateJob($scope, job)
                        .then(
                          // success
                          function(updatedJob) {
                            console.log("job update successfull", updatedJob);
                            $rootScope.refreshMyJobs = true;
                            $rootScope.refreshSearchJobs = true;
                          },
                          // error
                          function (error) {
                            console.log("job update failure", error);
                          }
                        );
                    } else {
                      // save job
                      popupSaveUpdateJob.saveJob($scope, job)
                        .then(
                          // success
                          function(savedJob) {
                            console.log("job saves successfull", savedJob);
                            $rootScope.refreshMyJobs = true;
                            $rootScope.refreshSearchJobs = true;
                            $timeout(function() {
                              $state.go("tab.myjobs.selectjobber", {id: savedJob.id});
                            }, 1);
                            //BranchIo.userCompletedAction("create_job", {job_id: job.id, price: job.price, currency: job.currency});
                          },
                          // error
                          function (error) {
                            console.log("job save failure", error);
                          }
                        );
                    }
                  }
                },
                //error popupCheckContact - close popup and stay in current state
                function (err) {
                  console.log("contact check not sucessfull: ", err)
                }
              );
          },
          // error popupCheckPictures - close popup and go to add fotos
          function (err) {
            console.log("picture check not sucessfull: ", err)
            $state.go('tab.createjob.details.photos');
          }
        )
    }
  }

  $scope.setJobDateTime = function(whatToSet) {
    var newDate;
    if (whatToSet == 'today' || whatToSet == 'now' || whatToSet == 'soon'){
      newDate = new Date();
    } else if (whatToSet == 'tomorrow') {
      newDate = moment().add(1, 'days').toDate();
    }
    newDate = moment(newDate).seconds(0).milliseconds(0).toDate();
    $scope.job.date = newDate; //.format("YYYY-MM-DD");

    if (whatToSet == 'now') {
      $scope.job.time = newDate;
    } else if (whatToSet == 'soon') {
      $scope.job.time = moment(newDate).add(1, 'hour').toDate();;
    } else {
      $scope.job.time = null;
    }
  }

  $scope.showDatePicker = function() {
    var initDate;
    if (typeof($scope.job.date) == 'undefined' || $scope.job.date == null) {
      initDate = new Date();
    } else {
      initDate = $scope.job.date;
    }
    var options = {
      date: initDate,
      mode: 'date',
      minDate: new Date()
    };
    $cordovaDatePicker.show(options)
    .then(function(date){
      if (date) {
        $scope.job.date = date;
      } else {
        console.log("date not changed");
      }
    });
  }

  $scope.showTimePicker = function() {
    var initDate;
    if (typeof($scope.job.time) == 'undefined' || $scope.job.time == null) {
      initDate = moment().toDate();
    } else {
      // init with a valid date. The day does not matter. The time is important.
      initDate = $scope.job.time;
    }
    var options = {
      date: initDate,
      mode: 'time'
    };
    $cordovaDatePicker.show(options)
    .then(function(date){
      if (date) {
        $scope.job.time = date;
      } else {
        console.log("time not changed");
      }
    });
  }
})

.controller('CreateJobDescriptionCtrl', function($scope, jobCategories, $stateParams, $timeout, jobFormData) {
  $scope.job = jobFormData;
  $scope.jobSubCategories = jobCategories.subCat($stateParams.jobCategoryID);
  $scope.example = jobCategories.get($scope.job.category_id).example;
  if ($scope.job.specialSubCategory == 'ecoscooter') {
    $scope.example="";
  }

  $scope.addSubcategory = function(subcategoryName, subcategoryId) {
    if ($scope.job.description) {
      $scope.job.description = $scope.job.description + " " + subcategoryName;
    } else {
      $scope.job.description = subcategoryName;
    }
    $scope.job.sub_category_id = subcategoryId;
  };

  $timeout(function(){
    angular.element(document.getElementById('description-input').focus());
    if(ionic.Platform.isAndroid()) {
      window.cordova.plugins.Keyboard.show();
    }
  }, 500);

})

.controller('CreateJobPriceCtrl', function($scope, $timeout, jobFormData) {
  $scope.job = jobFormData;
  window.jjj = $scope.job;

  // FacebookStories.fbLoginStatus().then(function (res) {
  //   console.log("FB login", res);
  //   if (res == "connected") $scope.fbConnected = true
  //   else $scope.fbConnected = false;
  // })

  $timeout(function(){
    angular.element(document.getElementById('price-input').focus());
    if(ionic.Platform.isAndroid()) {
      window.cordova.plugins.Keyboard.show();
    }
  }, 500);
})

.controller('CreatejobLocationCtrl', function($scope, $location, $stateParams, $ionicPopup, gettextCatalog, JobMap, jobFormData, partnerServices) {
  console.log("location crtl");
  $scope.job = jobFormData;
  $scope.jobMap = new JobMap();
  $scope.jobMap.initMap($scope, "map_canvas", [35, 2]);
  $scope.jobMap.AddCurrentLocationPoint($scope, true);
  $scope.locationNumber = $stateParams.locationNumber;
  console.log("$scope.locationNumber", $scope.locationNumber);

  $scope.searchBox = $scope.jobMap.linkSearchBox($scope, "map_searchbox");

  $scope.goToCurrent = function() {
    angular.element(document.getElementById('map_searchbox').blur());
    $scope.jobMap.clearMarkers();
    $scope.jobMap.AddCurrentLocationPoint($scope, true);
    $scope.searchLocation = "";
  }

  $scope.getAddress = function(latLng) {
    $scope.jobMap.getAddress(latLng).then(function (res) {
      //$scope.searchLocation=res;
    })
  }
  $scope.clearSearch = function(latLng) {
    $scope.searchLocation = "";
  }
  $scope.selectLocation = function(latLng, adr, address_details) {
    console.log("address det", address_details, latLng);
    // eco scooting postcodes and text for address hints
    var zipCode = _.find(address_details.address_components, function (ac) { return ac.types[0] == 'postal_code' }).short_name;
    // var ps = partnerServices.get($scope.job.service_id);
    var templateText = [];
    var popupTitle = [];
    templateText[1] = gettextCatalog.getString('Piso/Puerta, información adicional') + ':<br><input ng-model=job.address_hint>' + gettextCatalog.getString('Persona de contacto') + ':<br><input ng-model=job.contact_name>' + gettextCatalog.getString('Teléfono de contacto') + ':<br><input ng-model=job.contact_phone>';
    templateText[2] = gettextCatalog.getString('Piso/Puerta, información adicional') + ':<br><input ng-model=job.address_hint_2>' + gettextCatalog.getString('Persona de contacto') + ':<br><input ng-model=job.contact_name_2>' + gettextCatalog.getString('Teléfono de contacto') + ':<br><input ng-model=job.contact_phone_2>';
    popupTitle[1] = gettextCatalog.getString('Detalles recogida');
    popupTitle[2] = gettextCatalog.getString('Detalles entrega');

    if ($scope.job.specialSubCategory == "ecoscooter") {
      var ecoScootingZip = partnerServices.get($scope.job.service_id).postcodes;
      var zipText = ecoScootingZip.join(", ");
      if (ecoScootingZip.indexOf(zipCode) > -1) {
        //In  post code  array, ask for hints
        var myPopup = $ionicPopup.show({
          template: templateText[$scope.locationNumber],
          title: popupTitle[$scope.locationNumber],
          scope: $scope,
          buttons: [
            {
              text: gettextCatalog.getString('OK'),
              type: 'button-positive'
            },
          ]
        });
        myPopup.then(function(res) {
          console.log("res", res);
          window.history.back();
        });
      } else {
        //Not in post code array, cancel
        console.log("service", $scope.job, $scope.job.service.jobber_page.user.name);
        var myPopup = $ionicPopup.show({
          template: $scope.job.service.jobber_page.user.name + ' ' + gettextCatalog.getString('actualmente sólo ofrece sus servicios en las zonas de los siguientes códigos postales:') + '<br>' + zipText,
          title: gettextCatalog.getString('Zona no cubierta'),
          scope: $scope,
          buttons: [
            {
              text: gettextCatalog.getString('OK'),
              type: 'button-positive'
            },
          ]
        });
        myPopup.then(function(res) {
          console.log("res", res);
        });
      }
    } else {
      window.history.back();
    }
    if ($scope.locationNumber == 1) {
      $scope.job.position = latLng;
      $scope.job.address = adr;
      $scope.job.address_details = address_details;
    } else if ($scope.locationNumber == 2) {
      $scope.job.position_2 = latLng;
      $scope.job.address_2 = adr;
      $scope.job.address_details_2 = address_details;
    }
  };

  $scope.editAddress = function(adr) {
    $scope.jobMap.clearMarkers();
    $scope.searchLocation = adr;
    angular.element(document.getElementById('map_searchbox').focus());
  }
})

.controller('CreateJobPhotoCtrl', function($scope, $rootScope, Camera, env, jobFormData) {
  $scope.job = jobFormData;
  var restUrl = "/jobs/photo-upload.json";

  $scope.currentPhoto = {};
  $scope.currentSlideIndex = 0;

  $scope.takePicture = function(sourceId, inputName) {
    if ($rootScope.currentUser == null) {
      $scope.showLoginPopup();
    } else {
      var options = {
        sourceType: sourceId, //Camera.PictureSourceType.CAMERA
      };
      $scope.job.uploading.push(true);
      Camera.uploadPhoto(options, restUrl, inputName)
        .then(function(fileName) {
          // Success! Image data is here
          $scope.job.photo_file_names.push(fileName);
          $scope.job.photoServerPathByName[fileName] = env.apiEndPoint + "/uploads/jobs/staging/" + fileName;
          $scope.job.photoThumbServerPathByName[fileName] = env.apiEndPoint + "/uploads/jobs/staging/thumb_" + fileName;
          $scope.currentSlideIndex = $scope.job.photo_file_names.length - 1;
        }, function(err) {
          console.log("upload Photo Error", err);
        })
        .finally(function(){
          $scope.job.uploading.pop();
        });
    }
  }

  $scope.jumpToSlide = function(index) {
    $scope.currentSlideIndex = index;
  }
  $scope.deleteImage = function(index) {
    _.pullAt($scope.job.photo_file_names, [index]);
    // $ionicSlideBoxDelegate.update();
    var jumpToIndex = index;
    if ($scope.job.photo_file_names.length == index && index != 0) {
      jumpToIndex = index - 1;
    }
    $scope.currentSlideIndex = jumpToIndex;
  }

})


.controller('CreateJobCleaningCtrl', function($scope, $timeout, $filter, jobCategories, jobFormData, gettextCatalog) {
  $scope.job = jobFormData;

  if (!$scope.job.pricePerHour) $scope.job.pricePerHour = 9;
  if (!$scope.job.sub_category_id) $scope.job.sub_category_id = 17;
  $scope.lazyArray = [
    {label: "1:00 h", value: 1.0},
    {label: "1:30 h", value: 1.5},
    {label: "2:00 h", value: 2.0},
    {label: "2:30 h", value: 2.5},
    {label: "3:00 h", value: 3.0},
    {label: "3:30 h", value: 3.5},
    {label: "4:00 h", value: 4.0},
    {label: "4:30 h", value: 4.5},
    {label: "5:00 h", value: 5.0},
    {label: "5:30 h", value: 5.5},
    {label: "6:00 h", value: 6.0},
    {label: "6:30 h", value: 6.5},
    {label: "7:00 h", value: 7.0},
    {label: "7:30 h", value: 7.5},
    {label: "8:00 h", value: 8.0}
  ];

  $scope.slider = {};
  $scope.slider.rangeValue = 2;

  var setDescription = function(){
    $scope.job.description =  [ gettextCatalog.getString('Busco persona para') + ' ',
                                gettextCatalog.getString(jobCategories.get($scope.job.sub_category_id).name).toLowerCase() + ", " ,
                                $scope.job.hoursLabel + ", " ,
                                $scope.job.pricePerHour + ' ' ,
                                $filter('jmCurrencySymbol')($scope.job.currency),
                                gettextCatalog.getString("/hora. El precio incluye desplazamiento. El material de limpieza está disponible.")
                              ].join('');
  }

  var setPrice = function() {
    $scope.job.price = $scope.job.hours * $scope.job.pricePerHour;
  }

  $scope.$watch('slider.rangeValue',function(val,old){
    $scope.job.hours = $scope.lazyArray[val].value;
    $scope.job.hoursLabel = $scope.lazyArray[val].label;
    setPrice();
    setDescription();
  });

  $scope.$watch('job.sub_category_id',function(val,old){
    setDescription();
  });

  $scope.$watch('job.pricePerHour',function(val,old){
    setPrice();
    setDescription();
  });
})


;
