angular.module('starter.controllers')

// ============================ Directory Tab ============================

.controller('DirectoryController', function($scope, $compile, $state, Job, JobMap, $rootScope, $timeout, $ionicLoading, gettextCatalog, jobCategories, JobberPage, User, Search) {
  $scope.categories = jobCategories;
  $scope.categoriesMenuList = jobCategories.asMenuList();

  var search = function(){
    var newSearchParams = $rootScope.lastSearchParams || {};
    if (typeof $rootScope.lastSearchParams == 'undefined' || $rootScope.lastSearchParams == null) {
      var defaultSearchParams = {
        lat: 39.5735,
        lng: 2.6492,
        category: null,
        terms: null
      }
      newSearchParams = defaultSearchParams;
    }
    if ($rootScope.currentUser && $rootScope.currentUser.position) {
      newSearchParams.lat = $rootScope.currentUser.position[0];
      newSearchParams.lng = $rootScope.currentUser.position[1];
    }
    $rootScope.lastSearchParams = newSearchParams;

    Search.search(newSearchParams).$promise.then(
      function(records){
        $scope.records = records;
      },
      function(response){
        console.log("Server responded an error while performing a search", response);
      }
    );
  }

  $scope.$on("$ionicView.beforeEnter", function() {
    search();
  })

})

;
