angular.module('starter.controllers')
.controller('JobMessengerCtrl', function($ionicPlatform, $scope, $rootScope, $ionicPopup, $timeout, Message, MessageService, env, $ionicScrollDelegate, gettextCatalog) {
  console.log("JobMessengerCtrl");
  var wasAdvisedBefore = false;
  
  // $scope.keyup = function($event){
  //   textarea = document.find
  //   console.log("keyup", $event);
  // };
  $scope.messageText = null;
  $scope.messagePlaceholder = gettextCatalog.getString('¡Aclara aquí tus dudas!');
  
  if($rootScope.currentUser) {
    $rootScope.currentUser.wasAdvisedBefore = $rootScope.currentUser.wasAdvisedBefore || false;
    $scope.job.hasWrittenBefore = false;
  }

  var unregisterJobMsgListener = null;

  $scope.isFirstTimeWrite = function () {
    console.log("isFirstTimeWrite enter: ", $scope.job.i_created, $scope.job.i_applied, $rootScope.currentUser.wasAdvisedBefore);
    if (!$scope.job.i_created && !$scope.job.i_applied && !$rootScope.currentUser.wasAdvisedBefore && $rootScope.currentUser) {
      $scope.job.messages.some( function (value) {
        if (value.from_user && value.from_user.id == $rootScope.currentUser.id) {
          $scope.job.hasWrittenBefore = true;
          return $scope.job.hasWrittenBefore;
        }
      });
    }
    return $scope.job.hasWrittenBefore;
  }
  
  var init = function(){
    unregisterJobMsgListener = $rootScope.$on("job-message-received", function() {
      console.log("job-message-received");
      $scope.doRefresh();
    });
    $scope.messageText = $scope.messageText || null;
    if($rootScope.currentUser){
      $scope.isFirstTimeWrite();
    }
    console.log("- job status", $scope.job.status);
  }
  init();

  $scope.viewScope().$on("$ionicView.beforeEnter", function() {
    // beforeEnter, set msglistener
    init();
  });

  $scope.viewScope().$on("$ionicView.beforeLeave", function() {
    unregisterJobMsgListener();
  });

  $scope.$on('job.refreshed', function(){
    $scope.goBottomChat();
  });
  

  //Show popUp when is the first time that a jobber writing on the public chat
  $scope.applyRecommendation = function() {
    if (!$rootScope.currentUser) {
      // You need to be logged in before you can comment or ask questions.
      $scope.showLoginPopup();
      return false;
    } else {
      if(!$rootScope.currentUser.wasAdvisedBefore && !$scope.job.hasWrittenBefore && !$scope.job.i_created) {
        
        var confirmPopup = $ionicPopup.confirm({
          title: '<h2 class="title recommendation">' + gettextCatalog.getString('¡Envia tu solicitud!')+ '</h2>',
          template: '<p class="text recommendation">' + gettextCatalog.getString('Este chat público es solamente para resolver dudas acerca del trabajo. Si lo que realmente quieres es el trabajo, ¡solicítalo! Son todo ventajas :')+'</p><ul class="list recommendation"><li>' + gettextCatalog.getString('Una vez realizado, podrás ser valorado y eso mejorará tu imagen profesional.') + '</li><li>' + gettextCatalog.getString('Estarás cubierto con el seguro de responsabilidad civil a través de AXA.') + '</li><li>'+ gettextCatalog.getString('Podrás además hablar por chat privado con el anunciante.')+'</li></ul>',
          buttons: [
            { text: gettextCatalog.getString('<p class="messenger recommendation">Aclarar dudas</p>'),
              onTap: function (e) {
                return false;
              }
            },
            { text: gettextCatalog.getString('<p class="apply recommendation">Solicitar</p>'),
              type: 'button-assertive',
              onTap: function(e) {
                $scope.jobApply();
                return true;
              }
            }
          ]
        });
        confirmPopup.then(function(wantToApply){
          $rootScope.currentUser.wasAdvisedBefore = true;
          if (!wantToApply) {
            // Set focus
            $timeout(function(){
              document.getElementById('public-chat-input').focus();
              if(ionic.Platform.isAndroid()) window.cordova.plugins.Keyboard.show();
            }, 500);
          }
        });
      };
    }
  }
  
  $scope.send = function(){

    // Do not do anything unless there is some input.
    if(!$scope.messageText || $scope.messageText.length == 0) {
        //      console.log("no message");
      return false;
    }

    var messageDraft = {
      body: $scope.messageText,
      job_id: $scope.job.id,
      private: false,
      to_id: null,
      kind: $rootScope.currentUser.id == $scope.job.user_id ? MessageService.kind.from_job_creator : MessageService.kind.from_jobber
    }
    var sentMessageIndex;

    var message = new Message(messageDraft);
    message.$save().then(function(responseMessage){
      $scope.job.messages[sentMessageIndex] = responseMessage;
      $ionicScrollDelegate.scrollBottom(true);
      if(responseMessage.quality_issue){
        showPopUp(responseMessage.quality_issue);
      }
    }, function(){
      console.log("could not send message");
    }).finally(function(){
    });

    $scope.job.messages = $scope.job.messages || [];
    messageDraft.created_at = new Date();
    messageDraft.status = "sending";
    messageDraft.from_user = {
      id: $rootScope.currentUser.id, 
      name: $rootScope.currentUser.name,
      thumbPath: $rootScope.currentUser.thumbPath()
    };

    $scope.job.messages.push(messageDraft);
    sentMessageIndex = $scope.job.messages.length - 1;

    $scope.messageText = ''; 
  };
  
  var showPopUp = function (issue) {
    $scope.actionPopUp  = function(text) {
      var confirmPopup = $ionicPopup.confirm({
        title: gettextCatalog.getString('¡Envia tu solicitud!'),
        template: text,
        buttons: [
          { text: gettextCatalog.getString('Más tarde')},
          { text: gettextCatalog.getString('Solicitar'),
            type: 'button-positive',
            onTap: function(e) {
              $scope.jobApply();
            }
          }
        ]
      });
    };
    $scope.infoPopUp    = function(text) {
      var alertPopup = $ionicPopup.alert({
        title: gettextCatalog.getString('¡Cuidado!'),
        template: text
      });
      alertPopup.then(function(res) {});
    };
    switch(issue.code) {
      case 1:
        $scope.infoPopUp(issue.message);
        break;
      case 2:
        $scope.actionPopUp(issue.message);
        break;
      default:
        $scope.infoPopUp(issue.message);
        break;
    };
  }
  
  $scope.goBottomChat = function () {
    $ionicScrollDelegate.scrollBottom(true);
  }
});