angular.module('starter.controllers')

// ============================ Search Job Tab ============================
// For Search Job Tab and all sub pages

.controller('LocalCtrl', function($scope, $compile, $state, $ionicSideMenuDelegate, Job ,JobMap, $rootScope, $timeout, $ionicLoading, gettextCatalog, jobCategories, JobberPage, User) {
  $scope.state = $state.current.name;
  $scope.ifjobberPageSelect = false;
  $scope.categories = jobCategories;
  //Disable swipe Menu
  $scope.$on('$ionicView.enter', function(){
    $ionicSideMenuDelegate.canDragContent(false);
  });
  $scope.$on('$ionicView.leave', function(){
    $ionicSideMenuDelegate.canDragContent(true);
  });
    
  $scope.doRefresh = function () {
    closeCards();
    $scope.jobberPinCreate = false;
    $scope.jobPinCreate = false;
    var filterStorage = window.localStorage.getItem('filterdata');
    if (filterStorage && filterStorage != 'undefined') {
      $scope.filterdata = JSON.parse(filterStorage);
    } else {
      $scope.filterdata = {};
      $scope.filterdata.anyCategory = true;
    }
    //markers Jobbers
    $scope.searchMap.clearMarkers();

    $ionicLoading.show({templateUrl : 'templates/loading-animation.html', hideOnStateChange: true, duration: 10000});
    
    JobberPage.query().$promise.then(function (response) {

      var shownCategories = jobCategories.mainShown();
      $scope.jobberPages = response;
      var markerArray = [];

      angular.forEach($scope.jobberPages, function(jobberPage) {

        // !!!!!!!!!!!!!!!!!!!!!!!!!!!
        // I have removed all FILTER function in the map as these were responsable for the map failures
        
        var highlightedCategory = null;
        // var addMarker = false;
        // var addMarker = true;

        // if (!$scope.filterdata || !$scope.filterdata.categories) {
          // addMarker = true;
          if (jobberPage.service_categories && jobberPage.service_categories.length > 0) {
            highlightedCategory = jobberPage.service_categories[0];
          }
        // } else if ((!jobberPage.service_categories || jobberPage.service_categories.length == 0) && (shownCategories.length == $scope.filterdata.categories.length)) {
        //   addMarker = true;
        // } else {
        //   var filteredCategories = jobberPage.service_categories.filter(function(i) {
        //     return $scope.filterdata.categories.indexOf(i) > -1;
        //   });
        //   if(filteredCategories.length > 0) {
        //     highlightedCategory = filteredCategories[0];
        //     addMarker = true;
        //   }
        // }
        // if (addMarker) {
          if (highlightedCategory){
            var iconImageJobbers = $scope.categories.get(highlightedCategory).iconPin;
            // if the category doesn't have an icon pin, try the parent category
            if (typeof iconImageJobbers == 'undefined' && $scope.categories.get(highlightedCategory).parent_id) {
              iconImageJobbers = $scope.categories.get($scope.categories.get(highlightedCategory).parent_id).iconPin;
            } 
          } else {
            var iconImageJobbers = "img/categories/pins/defaultPin.png";
          }

          var onClickHandler = (function (jobberPage) {
            return function () {
              openJobberPageCard(jobberPage);
            }
          })(jobberPage);
          
          $scope.searchMap.addJobberPageMarker(jobberPage, iconImageJobbers, onClickHandler);
          //markerArray.push(mx); 
        // }
      });
      $scope.searchMap.pushMarkerArray();
    }, 
    function () {
      console.log("Autsch");
    }).finally(
      function(){
        $scope.jobberPinCreate = true;
        $ionicLoading.hide();
      } 
    );
    
    //markers Jobs
    var iconImageJob = "img/map_pin_retina.png";
    Job.query().$promise.then(function (response) {
      $scope.jobs = response;
      for (i = 0; i < $scope.jobs.length; i++) {
        if ($scope.filterdata.anyCategory || $scope.jobs[2].status == "open" && ($scope.filterdata.categories.indexOf($scope.jobs[i].category_id) > -1 )){
          var job = $scope.jobs[i] || null;
          var onClickHandlerJob = (function (job) {
            return function () {
              openJobCard(job);
            }
          })(job);
          $scope.searchMap.addJobMarker($scope.jobs[i], iconImageJob, onClickHandlerJob);
        }
      }
    },
    function () {
      console.log("Autsch");
    })
    .finally(function(){
      $scope.jobPinCreate = true; 
    });
    $scope.searchMap.AddCurrentLocationPoint($scope, false, null, null, true);
  }

  $scope.$on("$ionicView.beforeEnter", function() {
    if($rootScope.refreshSearchJobs) {
      $scope.doRefresh();
    }
  });
  $scope.locateMe = function(){
    $scope.searchMap.AddCurrentLocationPoint($scope, false);
  }

  // Build map:
  $scope.refreshMap = function() {
    $scope.searchMap = new JobMap();
    closeCards();
    var map = document.getElementById('search_map_canvas');
    $scope.searchMap.initMapJobberPages($scope, map, [35, 2], closeCards);
    // removed locateMe as this is done during refresh anyway
    //$scope.locateMe();
    $scope.doRefresh();
  }
  $timeout(function() {
    $scope.refreshMap();
  }, 1);

  $scope.$on('filter_changed', function(event) {
    $timeout(function() {
      $scope.doRefresh();
    }, 1);
  });

  $scope.$on('refreshMap', function() {
    $timeout(function() {
      $scope.refreshMap();
    }, 1);
  });

  var openJobberPageCard = function(jobberPageSelect){
    $scope.jobberView = jobberPageSelect;
    $scope.ifJobberPageSelect = true;
    $scope.ifJobSelect = false;
    User.getOther({'id' : jobberPageSelect.user_id}).$promise.then(function(response) {
      $scope.jobberSelect = response;
    }, function(error){}).finally();
    $scope.$apply();
  };
  
  var openJobCard = function(job){
    $scope.jobView = job;
    $scope.ifJobSelect = true;
    $scope.ifJobberPageSelect = false; 
    $scope.$apply();
  };
  
  var closeCards = function(){
    $scope.ifJobberPageSelect = false; 
    $scope.ifJobSelect = false;
    $scope.$apply();
  };
})

;