angular.module('starter.controllers')

// LOGIN ==========================================

.controller('LoginCtrl', function($scope, $rootScope, $ionicLoading, AUTH_EVENTS, AuthService, $http, Session, $timeout, $cordovaFacebook, $ionicPopup, $state, env, $ionicHistory, gettextCatalog, User) {

  $scope.resetPwdPath = env.apiEndPoint + "/users/password/new";
  $scope.credentials = {
    login: '',
    password: ''
  };

  $scope.loginSuccess = function (user) {
    $ionicLoading.hide();
    $rootScope.$broadcast(AUTH_EVENTS.loginSuccess);
    $scope.setCurrentUser(user);
    // Identify user mixpanel
    if (mixpanel) {
      mixpanel.identify(user.id);
    }

    // check on open popoup and close it
    if (!($scope.loginPopup.close === undefined)) {
      $scope.loginPopup.close();
    }

    // workaround:
    if ($state.current.name == 'tab.account') {
      $state.go($state.current, {}, {reload: true});
    }
  }

  $scope.loginFailed = function (user) {
    $ionicLoading.hide();
    $rootScope.$broadcast(AUTH_EVENTS.loginFailed);
  }


  $scope.login = function (credentials) {
    console.log("LoginCtrl's login function called", credentials);
    $ionicLoading.show({template: gettextCatalog.getString("Login"), hideOnStateChange: true, duration: 10000});
    // strangely this timeout function is now required otherwise i can't make it work
    $timeout(function () {
      AuthService.login(credentials).then(
        $scope.loginSuccess, $scope.loginFailed
      );
    }, 100);
  };

  $scope.resetPassword = function (userData) {
    $ionicLoading.show({template: gettextCatalog.getString('Enviar eMail'), hideOnStateChange: true, duration: 10000});
    // strangely this timeout function is now required otherwise i can't make it work
    $timeout(function () {
      AuthService.login(credentials).then(
        $scope.loginSuccess, $scope.loginFailed
      );

    }, 100);
  };

  $scope.fbLogin = function() {
    $ionicLoading.show({template: "Login", hideOnStateChange: true, duration: 10000});
    // use facebook SDK if running on device:
    if ($scope.onDevice) {
      $cordovaFacebook.login(["public_profile", "email", "user_friends", "user_likes"])
      .then(function(response) {
        if (response.status === 'connected') {
          $scope.fbToken = response.authResponse.accessToken;
          $scope.fbUid = response.authResponse.userID;
          AuthService
            .fbLogin($scope.fbToken, $scope.fbUid)
            .then(
              $scope.loginSuccess,
              $scope.loginFailed
            );
        } else {
          var alertPopup = $ionicPopup.alert({
            title: gettextCatalog.getString('Facebook error'),
            template: gettextCatalog.getString('No ha sido posible el login')
          });
        }
      }, function (error) {
          console.log("errohr", JSON.stringify(error));
          var alertPopup = $ionicPopup.alert({
            title: gettextCatalog.getString('Facebook error'),
            template: gettextCatalog.getString('No ha sido posible el login. Error') + ': ' + JSON.stringify(error)
          });
        // error
      });
    } else {
      // use OpenFB if not running in CORDOVA (development)
      openFB.login(
        function(response) {
          if (response.status === 'connected') {
            console.log("fb response", response);
            $scope.fbToken = response.authResponse.token;

            // Fetch Uid of user from Facebook
            openFB.api({
              path: '/me',
              success: function(resp) {
                $scope.fbUid = resp.id;
                AuthService
                  .fbLogin($scope.fbToken, $scope.fbUid)
                  .then(
                    $scope.loginSuccess,
                    $scope.loginFailed
                  );
              },
              error: function(resp) {
                var alertPopup = $ionicPopup.alert({
                  title: gettextCatalog.getString('Facebook error'),
                  template: gettextCatalog.getString('No hemos podido cargar tus datos de facebook')
                });
              }
            });
          } else {
            var alertPopup = $ionicPopup.alert({
              title: gettextCatalog.getString('Facebook error'),
              template: gettextCatalog.getString('No ha sido posible el login')
            });
          }
        },
        {scope: 'email,publish_actions,user_friends,user_likes'}
      );
    }
  }; //fbLogin

  $scope.connectSuccess = function (res){
    $ionicLoading.hide();
    if ($scope.fbConnectSuccess) {
      $scope.fbConnectSuccess();
    }
    if ($scope.initFacebookFriends) {
      // Deactivate facebook friends
      // $scope.initFacebookFriends();
    }
    //BranchIo.userCompletedAction("fb_connect", null);
  }

  $scope.connectFailed = function (res){
    $ionicLoading.hide();
    var alertPopup = $ionicPopup.alert({
      title: gettextCatalog.getString('Facebook error'),
      template: gettextCatalog.getString('No ha sido posible conectar facebook. Error') + ': (' + res.status + ') ' + res.statusText
    });
  }

  $scope.fbConnect = function(){
    $ionicLoading.show({template: "Login", hideOnStateChange: true, duration: 10000});
    // use facebook SDK if running on device:
    if ($scope.onDevice) {
      $cordovaFacebook.login(["public_profile", "email", "user_friends", "user_likes"])
      .then(function(response) {
        if (response.status === 'connected') {
          $scope.fbToken = response.authResponse.accessToken;
          $scope.fbUid = response.authResponse.userID;
          User
            .fbConnect({token: $scope.fbToken, uid: $scope.fbUid})
            .$promise
            .then(
              $scope.connectSuccess,
              $scope.connectFailed
            );
        } else {
          $scope.connectFailed();
        }
      }, function (error) {
        $scope.connectFailed();
      });
    } else {
      // use OpenFB if not running in CORDOVA (development)
      openFB.login(
        function(response) {
          if (response.status === 'connected') {
            console.log("fb response", response);
            $scope.fbToken = response.authResponse.token;

            // Fetch Uid of user from Facebook
            openFB.api({
              path: '/me',
              success: function(resp) {
                $scope.fbUid = resp.id;
                User
                  .fbConnect({token: $scope.fbToken, uid: $scope.fbUid})
                  .$promise
                  .then(
                    $scope.connectSuccess,
                    $scope.connectFailed
                  );
              },
              error: function(resp) {
                var alertPopup = $ionicPopup.alert({
                  title: gettextCatalog.getString('Facebook error'),
                  template: gettextCatalog.getString('No hemos podido cargar tus datos de facebook')
                });
              }
            });
          } else {
            var alertPopup = $ionicPopup.alert({
              title: gettextCatalog.getString('Facebook error'),
              template: gettextCatalog.getString('No ha sido posible el login')
            });
          }
        },
        {scope: 'email,publish_actions,user_friends,user_likes'}
      );
    }
  };


}) //LoginCtrl


// SIGN-UP ==========================================

.controller('SignupCtrl',function($scope, $ionicPopup, $timeout, User, gettextCatalog) {

  $scope.showSignupPopup = function() {
    $scope.signUpData = {};

    // An elaborate, custom popup
    var myPopup = $ionicPopup.show({
      templateUrl: 'templates/_signup.html',
      title: gettextCatalog.getString('Regístrate'),
      //subTitle: '<p>Elige entre 1-5 estrellas y deja un comentario si quieres.</p>',
      scope: $scope,
      buttons: [
        { text: gettextCatalog.getString('Cancelar') },
        {
          text: gettextCatalog.getString('Registrarme'),
          type: 'button-positive',
          onTap: function(e) {
            if (!$scope.signUpData.email || !$scope.signUpData.password || !$scope.signUpData.name)  {
              //don't allow the user to close unless he enters a star rating
              e.preventDefault(gettextCatalog.getString("Por favor pon los datos obligatorios"));
            } else {
              return $scope.signUpData;
            }
          }
        },
      ]
    });
    myPopup.then(function(answer) {
      if (answer) {
        User
          .save({user: $scope.signUpData})
          .$promise
            .then(
              function(response){
                // Identify with alias the new user
                if (mixpanel) {
                  mixpanel.alias(response.id);
                  mixpanel.people.set({
                    "UUID":             response.uuid,
                    "$name":            response.name,
                    "$created":         response.created_at,
                    "$email":           response.email,
                    "register channel": 'app'
                  });
                }
                console.log("before login after sign_up");
                $scope.login({login: $scope.signUpData.email, password: $scope.signUpData.password})
              },
              function(response) {
                console.log("New user could not be created");
              }
            )
            .finally(function() {
              //BranchIo.userCompletedAction("sign_up", null);
            });
      }
    });
  };
})

// RESET-PWD ==========================================

.controller('ResetPasswordCtrl',function($scope, $ionicPopup, $timeout, User, gettextCatalog) {

  $scope.showResetPasswordPopup = function() {
    $scope.resetPasswordData = {};
    // An elaborate, custom popup
    var myPopup = $ionicPopup.show({
      templateUrl: 'templates/_reset-password.html',
      title: gettextCatalog.getString('Recuperar contraseña'),
      scope: $scope,
      buttons: [
        { text: gettextCatalog.getString('Cancelar') },
        {
          text: gettextCatalog.getString('Enviar'),
          type: 'button-positive',
          onTap: function(e) {
            if (!$scope.resetPasswordData.email)  {
              //don't allow the user to close unless he enters a star rating
              e.preventDefault(gettextCatalog.getString("Por favor pon tu email."));
            } else {
              return $scope.resetPasswordData;
            }
          }
        },
      ]
    });
    myPopup.then(function(answer) {
      if (answer) {
        User
          .resetPassword({user: $scope.resetPasswordData})
          .$promise.then(
            function(response){
              $ionicPopup.alert({
                title: gettextCatalog.getString('Instrucciones enviado'),
                template: gettextCatalog.getString('Por favor mira en tus eMails. Dentro de un rato debes que recibir un eMail con un enlace. Dale a este enlace y sigue las instrucciones. Luego vuelva aquí y intenta hacer el login con la nueva contraseña. Gracias.')
              });
            },
            function(response) {
              $ionicPopup.alert({
                title: gettextCatalog.getString('eMail desconocido'),
                template: gettextCatalog.getString("No hay nadie registrado con el email") + ': ' + $scope.resetPasswordData.email
              }).then(function(){
                $scope.showResetPasswordPopup();
              })
            }
          );
      }
    });
  };
})

// CHANGE PWD ==========================================

.controller('ChangePasswordCtrl',function($scope, $ionicPopup, $timeout, User, gettextCatalog) {

  $scope.showChangePasswordPopup = function() {
    $scope.passwordData = {
      password: '',
      password_confirmation: '',
      current_password: ''
    };
    console.log("showChangePasswordPopup", $scope.passwordData.password);

    // An elaborate, custom popup
    var myPopup = $ionicPopup.show({
      templateUrl: 'templates/_change-password.html',
      title: gettextCatalog.getString('Cambiar contraseña'),
      scope: $scope,
      buttons: [
        { text: gettextCatalog.getString('Cancelar') },
        {
          text: gettextCatalog.getString('Cambiar'),
          type: 'button-positive',
          onTap: function(e) {
            if (!$scope.passwordData.password || !$scope.passwordData.password_confirmation || !$scope.passwordData.current_password)  {
              //don't allow the user to close unless he enters a star rating
              e.preventDefault(gettextCatalog.getString("Por favor pon todos los datos."));
            } else {
              if ($scope.passwordData.password != $scope.passwordData.password_confirmation) {
                $scope.errorMessage = gettextCatalog.getString("La repetición no es igual.");
                e.preventDefault(gettextCatalog.getString("La repetición no es igual."));
              } else {
                $scope.errorMessage = '';
                return $scope.passwordData;
              }
            }
          }
        },
      ]
    });
    myPopup.then(function(answer) {
      if (answer) {
        User
          .changePassword({user: $scope.passwordData})
          .$promise.then(
            function(response){
              $ionicPopup.alert({
                title: gettextCatalog.getString('Contraseña actualizada'),
                template: ''
              });
            },
            function(response) {
              $ionicPopup.alert({
                title: gettextCatalog.getString('Error'),
                template: gettextCatalog.getString("Por favor inténtalo de nuevo, gracias.")
              }).then(function(){
                $scope.showChangePasswordPopup();
              })
            }
          );
      }
    });
  };
})


;
