// My Job Tab (and sub pages)
angular.module('starter.controllers')
.controller('MyJobsCtrl', function($rootScope, $scope, Job, User, $stateParams, Sharing) {

  $scope.$on("$ionicView.beforeEnter", function() {
    if($rootScope.refreshMyJobs) {
      $scope.$broadcast("refresh-my-jobs")
    }
  });
  //$scope.user = User.getOther({id: $stateParams.candidateId});
})

.controller('MyJobsCreatedCtrl', function($scope, $ionicLoading, $timeout, $ionicPopup, Job, $rootScope, AUTH_EVENTS) {
  $scope.viewScope = function(){
    return $scope;
  };

  $scope.doRefresh = function() {
    $scope.jobs = Job.myJobsCreated();
    $scope.jobs.$promise.then(function() {
      $ionicLoading.hide();
      if (_.find($scope.jobs, {status: "done", jobber_rating: null})) {
        $scope.rate = true;
      }else{
        $scope.rate = false;
        };
      if (_.find($scope.jobs, {status: "open"})) {
        $scope.select = true;
      }else{
        $scope.select = false;
        };
      if (_.find($scope.jobs, {status: "assigned"})) {
        $scope.confirmed = true;
      }else{
        $scope.confirmed = false;
      };
      if (_.find($scope.jobs, {status: "closed"})) {
        $scope.history = true;
      }else{
        $scope.history = false;
      };
    })
    .finally(function() {
     // Stop the ion-refresher from spinning
     $scope.$broadcast('scroll.refreshComplete');
    });

    $rootScope.refreshMyJobs = false;
  }

  $scope.$on("refresh-my-jobs", function(){
    $scope.doRefresh();
  })

  $scope.deleteJob = function(item, idx) {
     item.$remove(function() {$scope.jobs.splice(idx, 1);});
  }

  if ($rootScope.currentUser) {
    $ionicLoading.show({template: "Cargando jobs", hideOnStateChange: true, duration: 20000});
    $scope.doRefresh();
  };

  $rootScope.$on(AUTH_EVENTS.loginSuccess , function(event, data) {
    $ionicLoading.show({template: "Cargando jobs", hideOnStateChange: true, duration: 20000});
    $scope.doRefresh();
  });

})

.controller('MyJobsAppliedCtrl', function($scope, $ionicLoading, Job, $rootScope, AUTH_EVENTS) {

  $scope.doRefresh = function() {
    $scope.jobs = Job.myJobsApplied();
    $scope.jobs.$promise.then(function() {
      $ionicLoading.hide();
    })
    .finally(function() {
     // Stop the ion-refresher from spinning
     $scope.$broadcast('scroll.refreshComplete');
    });
  }

  if ($rootScope.currentUser) {
    $ionicLoading.show({template: "Cargando jobs", hideOnStateChange: true, duration: 20000});
    $scope.doRefresh();
  };

  $rootScope.$on(AUTH_EVENTS.loginSuccess , function(event, data) {
    $ionicLoading.show({template: "Cargando jobs", hideOnStateChange: true, duration: 20000});
    $scope.doRefresh();
  });

})

.controller('MyJobsAppliedDetailsCtrl', function(job, $scope, $rootScope, $stateParams, $state, $ionicLoading, Job, jobCategories, $ionicSlideBoxDelegate, $ionicModal, Sharing, $ionicPopup, $ionicScrollDelegate, Service) {
  $scope.state = $state.current.name;
  $scope.moment = window.moment;
  $scope.categories = jobCategories;
  var shareObject = {};

  $scope.job = job;
  $scope.moment = window.moment;
  $scope.categories = jobCategories;
  $scope.viewScope = function(){
    return $scope;
  };


  $scope.freshController = true;
  $scope.doRefresh = function(){
    Job.get({id: $stateParams.id})
      .$promise
      .then(function(job){
        $scope.job = job;
        $scope.$broadcast('job.refreshed');
      })
  }
  $scope.$on("$ionicView.beforeEnter", function() {
    if(!$scope.freshController) {
      $scope.doRefresh();
    }
    $scope.freshController = false;
  });

  $ionicSlideBoxDelegate.update();

  $scope.compartirJob = function(channel) {
    $ionicLoading.show({templateUrl: 'templates/loading-animation.html', hideOnStateChange: true, duration: 20000});
    var urlParams = {
      referringUser: {
        uuid: $rootScope.currentUser.uuid,
        name: $rootScope.currentUser.name,
        picture: $rootScope.currentUser.bigImagePath()
      },
      job_id : job.id,
      $desktop_url : shareObject.shareLink,
      $android_url : shareObject.shareLink,
      $ios_url : shareObject.shareLink
    };
//     BranchIo.getShortUrl(urlParams, "app", "jobsharing").then(function(url) {
//       shareObject.shareLink = url;
//       if(channel == 'facebook'){
//         Sharing.shareFacebook(shareObject);
//       }
//       if(channel == 'sharing'){
//         Sharing.shareOthers(shareObject);
//       }
//       if(channel == 'twitter'){
// //        Sharing.shareshare(shareObject);
//       }
//       if(channel == 'whatsapp'){
//         Sharing.shareWhatsapp(shareObject);
//       }
// //      Sharing.shareAction(shareObject, gettextCatalog.getString("Compartir con..."));
//     });
  }

  //Slider Box
  $scope.showSliderBox = function(templateUrl) {
    $ionicModal.fromTemplateUrl(templateUrl, {
      scope: $scope,
      animation: 'slide-in-up'
    }).then(function(modal) {
      $scope.modal = modal;
      $scope.modal.show();
    });
  }
  $scope.showImages = function(index) {
    $scope.activeSlide = index;
    $scope.showSliderBox('templates/_job-photo-slider.html');
  }
  $scope.closeModal = function() {
    $scope.modal.hide();
    $scope.modal.remove()
  };
})


.controller('SelectJobberCtrl', function(job, $scope, $rootScope, $stateParams, $state, $filter, Job, jobForm, $location, $ionicPopup, $ionicModal, Braintree, $ionicLoading, $ionicSlideBoxDelegate, jobCategories, $ionicHistory, $timeout, FacebookStories, env, Sharing, gettextCatalog) {
  var fbText = "";
  var fbImage = "";
  var shareObject = {};
  $scope.categories = jobCategories;
  $scope.moment =   window.moment;
  $scope.viewScope = function(){
    return $scope;
  };

  $scope.freshController = true;
  $scope.doRefresh = function(){
    Job.get({id: $stateParams.id})
      .$promise
      .then(function(job){
        $scope.job = job;
        $ionicSlideBoxDelegate.update();
        $scope.$broadcast('job.refreshed');
        // directly open assign popup if jobber selected via state params
        if ($stateParams.selectJobberId) {
          $scope.jobAssignPopup($stateParams.SelectJobberId);
        }

      })
  }
  $scope.$on("$ionicView.beforeEnter", function() {
    if(!$scope.freshController) {
      $scope.doRefresh();
    }
    $scope.freshController = false;
  });

  $scope.state = $state.current.name;
  $scope.job = job;

  $ionicSlideBoxDelegate.update();
  shareObject.shareMessage = job.jobCategory + ": " + $filter('jmPriceCurrency')(job.price, job.currency) + ", " + job.description;
  shareObject.shareSubject = gettextCatalog.getString("Te interesa este job?");
  if (job.photo_file_names.length == 0) {
    shareObject.shareImage = jobCategories.get(job.category_id).fbImage;
  } else {
    shareObject.shareImage = job.imagePath;
  }
  shareObject.shareLink = "https://jobmapp.com/jobs/" + job.id;

  if (job.candidates) {
    for (var i=0; i<job.candidates.length; i++) {
      job.candidates[i].jobberSince = moment(job.candidates[i].created_at).format('DD.MM.YYYY');
    }
  }

  $scope.compartirJob = function(channel) {
    $ionicLoading.show({templateUrl: 'templates/loading-animation.html', hideOnStateChange: true, duration: 20000});
    var urlParams = {
      referringUser: {
          uuid: $rootScope.currentUser.uuid,
          name: $rootScope.currentUser.name,
          picture: $rootScope.currentUser.bigImagePath()
      },
      job_id : job.id,
      $desktop_url : shareObject.shareLink,
      $android_url : shareObject.shareLink,
      $ios_url : shareObject.shareLink
    };
//     BranchIo.getShortUrl(urlParams, "app", "jobsharing").then(function(url) {
//       shareObject.shareLink = url;
//       if(channel == 'facebook'){
//         Sharing.shareFacebook(shareObject);
//       }
//       if(channel == 'sharing'){
//         Sharing.shareOthers(shareObject);
//       }
//       if(channel == 'twitter'){
// //        Sharing.shareshare(shareObject);
//       }
//       if(channel == 'whatsapp'){
//         Sharing.shareWhatsapp(shareObject);
//       }
// //      Sharing.shareAction(shareObject, gettextCatalog.getString("Compartir con..."));
//     });
  }


  $scope.makePayment = function() {
    Braintree.checkout (number, expirationDate);
  }

  var jobAssign = function(candidateId) {
//    $ionicLoading.show({template: gettextCatalog.getString("Asignando jobber"), hideOnStateChange: true, duration: 10000});
    $ionicLoading.show({templateUrl: 'templates/loading-animation.html', hideOnStateChange: true, duration: 20000});
    Job
      .assign({id: $stateParams.id, candidateId: candidateId })
      .$promise.then(
        function(job){
          $ionicLoading.hide();
          $ionicHistory.goBack();
          $rootScope.refreshMyJobs = true;
          $timeout(function() {
            var alertPopup = $ionicPopup.alert({
              title: gettextCatalog.getString('Jobber asignado'),
              template: gettextCatalog.getString('Genial! Tu jobber ya ha sido asignado. Ponte en contacto con él.')
            });
            alertPopup.then(function(res) {
              $state.go("tab.myjobs.confirmedjob", {id: $stateParams.id});
            });
          }, 100);
        },
        function(job){
          $ionicLoading.hide();
          var alertPopup = $ionicPopup.alert({
            title: gettextCatalog.getString('Error!'),
            template: gettextCatalog.getString('La elección del jobber no ha sido posible. Ponte en contacto con nosotros a través de <a href="mailto:info@jobmapp.com">info@jobmapp.com</a>')
          });
        }
      );
  }


  $scope.jobAssignPopup = function(candidateId) {
    $scope.data = {};
    $scope.data.jobId = $scope.job.id;

    $scope.fbConnectSuccess = function(){
      $scope.fbLoginStatus = "connected";
      $scope.data.fbpost = true;
    }

    $scope.fbLoginStatus = false;
    $scope.data.fbpost = false;
    FacebookStories.fbLoginStatus()
      .then(
        function(res) {
          if (res == 'connected') {
            $scope.fbLoginStatus = res;
            $scope.data.fbpost = true;
            fbText = jobCategories.getFbText($scope.job.category_id, $rootScope.currentUser.name);
            fbImage = jobCategories.getFbImage($scope.job.category_id);
          }
        }
      )

    if ($scope.job.settled) {
      // job is already "payed" in some way
      var assignPopup = $ionicPopup.confirm({
        title: gettextCatalog.getString('¿Quieres elegir a este jobber?'),
        scope: $scope,
        buttons: [
          { text: gettextCatalog.getString('Cancelar') },
          {
           text: gettextCatalog.getString('Contratar'),
           type: 'button-positive',
           onTap: function(e) {return $scope.data;}
          },
        ]
      });
      assignPopup.then(function(confirmed) {
        if (confirmed) {
          jobAssign(candidateId);
        }
      })
      // END: Jobber had already payed.
    } else {
      // Job not yet "payed" (settled)
      $scope.data.braintreeClientToken = "";
      Braintree.getClientToken()
        .then(
          function (res) {
            console.log("Braintree client token sucessfully obtained", res.data);
            $scope.data.braintreeClientToken = res.data.client_token;
          },
          function() {console.log("error obtaining braintree client token");}
        )

      if (env.name != 'production') $scope.data.number = "4111111111111111";
      if (env.name != 'production') $scope.data.expiration_month = "10";
      if (env.name != 'production') $scope.data.expiration_year = "20";

      var assignPopup = $ionicPopup.confirm({
       templateUrl: 'templates/_assign.html',
       title: gettextCatalog.getString('Contratar Jobber'),
       subTitle: gettextCatalog.getString('¿Quieres contratar el jobber? Paga los gastos de gestión con tarjeta de crédito o aprovecha la oferta "publicidad en facebook".'),
       scope: $scope,
       buttons: [
         { text: gettextCatalog.getString('Cancelar') },
         {
           text: gettextCatalog.getString('Contratar'),
           type: 'button-positive',
           onTap: function(e) {return $scope.data;}
         },
       ]
      });
      assignPopup.then(function(res) {
        if (res && $scope.fbLoginStatus == 'connected' && res.fbpost) {
//          $ionicLoading.show({template: gettextCatalog.getString("Publicando en facebook"), hideOnStateChange: true, duration: 10000});
          $ionicLoading.show({templateUrl: 'templates/loading-animation.html', hideOnStateChange: true, duration: 20000});
          FacebookStories.fbFeed(fbText, fbImage)
            .then(function() {
              $ionicLoading.hide();
              jobAssign(candidateId);
            }, function() {
              $ionicLoading.hide();
              var alertPopup = $ionicPopup.alert({
                title: gettextCatalog.getString('Error Facebook'),
                template: gettextCatalog.getString('Publicación en tu muro de facebook no ha sido posible. El trabajo no fue asignado. Por favor conectate de nuevo (logout/login con facebook) o elige el pago con tarjeta de credito.')
              });
            });
        } else if (res && res.braintreeClientToken && res.number && res.expiration_month && res.expiration_year) {
          console.log("Braintree checkout");
          $ionicLoading.show({template: gettextCatalog.getString("Procesando pago"), hideOnStateChange: true, duration: 10000});
          Braintree.checkout(res.braintreeClientToken, res.number, res.expiration_month, res.expiration_year, res.jobId)
          .then(
            function () {
              // show "pago realizado" instead of "procesando checkout" for 1000ms then proceed with assign jobber
              $timeout(function() {
                $ionicLoading.show({template: gettextCatalog.getString("Pago realizado"), hideOnStateChange: true, duration: 10000});
              }, 1);
              $timeout(function() {
                jobAssign(candidateId);
              }, 1000);
            },
            function () {
              $ionicLoading.hide();
              var alertPopup = $ionicPopup.alert({
                title: gettextCatalog.getString('Pago no ha sido realizado'),
                template: gettextCatalog.getString('Vuelve a intentarlo o usa otra tarjeta de crédito.')
              });
            }
          )
          .finally(function () {$ionicLoading.hide();});
        } else {
          console.log("cancel");
        }
      });
      // END else: Jobber had not "payed" yet.
    }
  }

  $scope.showFbPost = function() {
    var fbPostPopup = $ionicPopup.confirm({
     title: gettextCatalog.getString('Facebook Post'),
     template: fbText + '<img style="max-width:100%" src="' + fbImage +'" />',
     buttons: [
       {
         text: gettextCatalog.getString('Cerrar'),
         type: 'button-positive'
       },
     ]
    });
  }

  $scope.cancelAssignment = function() {
    var confirmPopup = $ionicPopup.confirm({
      title: gettextCatalog.getString('Cancelar el jobber?'),
      // template: template,
      buttons: [
        { text: gettextCatalog.getString('No') },
        {
          text: gettextCatalog.getString('Sí'),
          type: 'button-positive',
            onTap: function(e) {
              return true;
            }
        }
      ]
    });
    confirmPopup.then(function(answer) {
      if(answer) {
        console.log('You are sure');
        Job.cancelAssignment({id: $scope.job.id}).$promise.then(function (response) {
          $rootScope.refreshMyJobs = true;
          $state.go("tab.myjobs.selectjobber", {id: $scope.job.id});
        })
      } else {
        console.log('You are not sure');
      }
    });
  };

  //Slider Box
  $scope.showSliderBox = function(templateUrl) {
    $ionicModal.fromTemplateUrl(templateUrl, {
      scope: $scope,
      animation: 'slide-in-up'
    }).then(function(modal) {
      $scope.modal = modal;
      $scope.modal.show();
    });
  }

  $scope.showImages = function(index) {
    $scope.activeSlide = index;
    $scope.showSliderBox('templates/_job-photo-slider.html');
  }
  $scope.closeModal = function() {
    $scope.modal.hide();
    $scope.modal.remove();
  };

  $scope.showRatingPopup = function(jobId, whoToRate, idx) {
    $scope.data = {};
    $scope.data.rate = 0;
    $scope.data.max = 5;

    // An elaborate, custom popup
    var myPopup = $ionicPopup.show({
      template: '<rating ng-model="data.rate" max="data.max" class="rating-stars"></rating><br><textarea rows="4" class="rating-comment" type="text" ng-model="data.comment" placeholder="' + gettextCatalog.getString('Comentario (opcional)') + '"></textarea>',
      title: '<p class="title">'+gettextCatalog.getString('Valora al jobber')+'</p>',
      subTitle: '<p class="sub-title">' + gettextCatalog.getString('Elige entre 1-5 estrellas') + '</p>',
      scope: $scope,
      buttons: [
        { text: gettextCatalog.getString('Cancelar') },
        {
          text: gettextCatalog.getString('Guardar'),
          type: 'button-positive',
          onTap: function(e) {
            if (!$scope.data.rate > 0) {
              //don't allow the user to close unless he enters a star rating
              e.preventDefault("Minimum Rating 1 Star");
            } else {
              return $scope.data;
            }
          }
        },
      ]
    });

    myPopup.then(function(answer) {
      if (answer) {
        $ionicLoading.show({templateUrl : 'templates/loading-animation.html', hideOnStateChange: true, duration: 10000});
        var response;
        if (whoToRate == 'jobber') {
          response = Job.rateJobber({
            id: jobId,
            jobber_rating: answer.rate,
            comment_on_jobber: answer.comment
          });
        }
        // if (whoToRate == 'creator') {
        //   var response = Job.rateJobber({
        //     id: jobId, creator_rating: answer.rate,
        //     comment_on_creator: answer.comment});
        // }
        response.$promise.finally(function (res) {
          // _.remove($scope.$parent.jobs, { 'id': jobId });
          $scope.doRefresh();
          $rootScope.refreshMyJobs = true;
          $ionicLoading.hide();
        })
      }
    });

  };

  // directly open assign popup if jobber selected via state params
  if ($stateParams.selectJobberId) {
    $scope.jobAssignPopup($stateParams.selectJobberId);
  }


})

.controller('MyJobModificationCtrl', function($scope, $rootScope, $stateParams, $state, jobForm, Job, $ionicPopup, $ionicHistory, gettextCatalog){
  $scope.editJob = function(job) {
    Job.get({id: $stateParams['id']})
      .$promise
      .then(function(loadedJob){
        jobForm.setToUpdate(loadedJob);
        $state.go("tab.myjobs.selectjobber.edit", {id: job.id});
      });
  };

  $scope.cancelJob = function() {
    var confirmPopup = $ionicPopup.confirm({
      title: gettextCatalog.getString('Cancelar job'),
      template: gettextCatalog.getString('¿Estás seguro?'),
      buttons: [
        { text: gettextCatalog.getString('No') },
        {
          text: gettextCatalog.getString('Sí'),
          type: 'button-positive',
          onTap: function(e) {
            return true;
          }
        }
      ]
    });
    confirmPopup.then(function(answer) {
     if(answer) {
      console.log('You are sure');
      Job.cancelJob({id: $stateParams.id}).$promise.then(function (response) {
        var alertPopup = $ionicPopup.show({
          title: gettextCatalog.getString('Job ha sido cancelado'),
          template: '<p>' + gettextCatalog.getString('Notificaremos a todos que se interesaron por este job.') + '</p>',
          buttons: [
            { text: gettextCatalog.getString('OK') }
          ]
        });
        $scope.doRefresh();
        $rootScope.refreshMyJobs = true;
        // $ionicHistory.goBack();
      })
     } else {
       console.log('You are not sure');
     }
    });
  };

  $scope.cancelApplication = function() {
    if ($scope.job.i_am_assigned) {
      template = gettextCatalog.getString('Cancelar un job asignado <b>va a afectar tu valoración</b> - Estas seguro?');
    } else {
      template = gettextCatalog.getString('¿Estás seguro?');
    }
    var confirmPopup = $ionicPopup.confirm({
      title: gettextCatalog.getString('Cancelar tu solicitud'),
      template: template,
      buttons: [
        { text: gettextCatalog.getString('No') },
        {
          text: gettextCatalog.getString('Sí'),
          type: 'button-positive',
            onTap: function(e) {
              return true;
            }
        }
      ]
    });
    confirmPopup.then(function(answer) {
      if(answer) {
        console.log('You are sure');
        Job.cancelApplication({id: $stateParams.id}).$promise.then(function (response) {
          console.log("application canceled");
          $rootScope.refreshMyJobs = true;
          $ionicHistory.goBack();
        })
      } else {
        console.log('You are not sure');
      }
    });
  };
})

.controller('MyJobsJobberdetailsCtrl', function(user, $scope, $rootScope, $state, $timeout, $ionicModal, $ionicLoading, Job , JobMap, User, $stateParams, jobCategories, gettextCatalog, Sharing) {
  $scope.user = user;
  $scope.jobCategories = jobCategories;
  $scope.state = $state.current.name;
  $scope.business_position = [];
  $scope.jobCategories = jobCategories;
    var shareObject = {};

  if ($scope.user.jobber_page && $scope.user.jobber_page.fixed_position) {
    $scope.user.jobberPageFixLocationStyle = {
      'background-image': 'url(\'https://maps.googleapis.com/maps/api/staticmap?center=' + user.jobber_page.fixed_position[0] + ',' + user.jobber_page.fixed_position[1] + '&zoom=17&size=640x640&maptype=roadmap\')'
    };
  }

  //Modal for Show Ratings, Facebook friends
  $scope.showModal = function (template) {
    if (template == 'facebook') {
      template = 'templates/_facebook-friends.html';
    }
    if (template == 'ratings') {
      template = 'templates/_ratings.html';
    }

    $ionicModal.fromTemplateUrl(template, {
      scope: $scope,
      animation: 'slide-in-up'
    })
      .then(function (modal) {
      $scope.modal = modal;
      $scope.modal.show();
    });
  };
  $scope.closeModal = function () {
    $scope.modal.hide();
    $scope.modal.remove();
  };

  //Share Profile
  $scope.shareProfile = function(channel) {
    $ionicLoading.show({templateUrl : 'templates/loading-animation.html', hideOnStateChange: true, duration: 10000});

    //build shareObject
    var shareObject = {};
    if ($rootScope.currentUser.id == $scope.user.id) {
      shareObject.shareMessage  = gettextCatalog.getString("Este es mi perfil en jobMapp!");
    }
    else {
      shareObject.shareMessage  = gettextCatalog.getString("Mira este perfil de jobMapp!");
    }

    shareObject.shareSubject  = "jobMapp";
    shareObject.shareImage    = $scope.user.bigImagePath();
    shareObject.shareLink     = $scope.user.getFullUrl();

    //build urlParams
    var urlParams = {
      $desktop_url : shareObject.shareLink,
      $android_url : 'jobmapp://jobbers/' + $scope.user.id,
      $ios_url : 'jobmapp://jobbers/' + $scope.user.id,
      jobber_id : $scope.user.id
    }
    if ($rootScope.currentUser) {
      urlParams.referringUser = {
        uuid: $rootScope.currentUser.uuid,
        name: $rootScope.currentUser.name,
        picture: $rootScope.currentUser.bigImagePath()
      }
    }

//     BranchIo.getShortUrl(urlParams, "app", "jobbersharing").then(function(url) {
//       shareObject.shareLink = url;
//       if(channel == 'facebook'){
//         Sharing.shareFacebook(shareObject);
//       }
//       if(channel == 'sharing'){
//         Sharing.shareOthers(shareObject);
//       }
//       if(channel == 'twitter'){
// //        Sharing.shareOthers(shareObject);
//       }
//       if(channel == 'whatsapp'){
//         Sharing.shareWhatsapp(shareObject);
//       }

//     });
  }

})
;
