angular.module('starter.controllers')

.controller('NotificationsController', function($scope, $rootScope, $ionicSideMenuDelegate, $state, $window, $ionicLoading,$cordovaInAppBrowser, Notification, Job) {

  $scope.newNotifications = false;

  $scope.notificationWidth = function() {
    return Math.min(Math.min(window.innerHeight, window.innerWidth) * 0.8, 600);
  }



  $scope.doRefresh = function(){
    $scope.$broadcast('scroll.refresh');
    Notification.query().$promise
      .then(function(response){
        $scope.notifications = response
      }, function(){
        console.log("Could not load notifications.")
      })
      .finally(function() {$scope.$broadcast('scroll.refreshComplete');
        }
      );
  };
  $rootScope.$on('opening-notification-center', $scope.doRefresh);

  // Jump to right state depending on relation with job
  $scope.goToState = function(options) {
    console.log("goToState", options);
    $ionicSideMenuDelegate.toggleRight();

    if (options.state) {
      $state.go(options.state);
    } else if (options.job_id) {
      if (options.private && (options.kind == "from_job_creator" || options.kind == 'from_jobber' || options.kind == 'from_admin')) {
        $scope.$emit('open-private-job-chat', {jobId: options.job_id, toId: options.toId});
      } else {
        $ionicLoading.show();
        Job.get({id: options.job_id}).$promise.then(function(job){
          // successfully job loaded

          // TODO: This is still bad
          if (job.i_created) {
            if (job.status == 'open' || job.status == 'in_review') {
              // Job still not assigned or in review
              $state.go('tab.myjobs.selectjobber', {id: options.job_id});
            } else if (job.status == 'assigned' || job.status == 'done' || job.status == 'closed') {
              // Job already assigned, done, or complete
              $state.go('tab.myjobs.confirmedjob', {id: options.job_id});
            }
          } else if (job.i_am_assigned || job.i_applied) {
            $state.go('tab.myjobs.applieddetails', {id: options.job_id});
          } else {
            $state.go('tab.searchjob.showjob', {id: options.job_id});
          }
        }).finally(function(){
          $ionicLoading.hide();
        })
      }
    }
    else if (options.url) {
      if (!options.target) options.target = '_system';
      $cordovaInAppBrowser.open(options.url, options.target)
        .then(function(event) {
          console.log("browser success");
        })
        .catch(function(event) {
          console.log("browser error");
        });
    }
  }

  var setNotificationBadge = function() {
    $scope.newNotifications = true;
  }

  $rootScope.$on('new-notification', setNotificationBadge);

  // Bind loading of notification ratio to open menu event
  // due to right menu it is open when ratio = -1

  $scope.$watch(function () {
    return $ionicSideMenuDelegate.getOpenRatio();
  },
  function (ratio) {
    if (ratio == -1){
      $scope.newNotifications = false;
      if ($rootScope.currentUser) {
        $rootScope.$broadcast('opening-notification-center');
      } else {
        $scope.notifications = [];
      }
    }
  });
})
;
