angular.module('starter.controllers')
.controller('ServiceCtrl', function($scope, $timeout, $ionicPopup, $state, $stateParams, $rootScope, gettextCatalog, User, JobberPage, Service, jobCategories, service, Camera, env) {
  $scope.service = service;
  $scope.jobCategories = jobCategories;
  $scope.service.uploadingImg = $scope.service.uploadingImg || [];
  window.ser = service;
  $scope.selectedLanguage = 'es';
  $scope.descriptionPlaceholder = "¿Qué servicio quieres ofrecer?";
  $scope.apiEndPoint = env.apiEndPoint;

  $scope.priceType = "none";

  $scope.init = function() {
    $scope.enablePublishBtn = true;

    // No Spanish description AND an English version available?
    if (service.description && !(service.description['es'] && service.description['es'].length > 0) && (service.description['en'] && service.description['en'].length > 0 )) {
      $scope.selectedLanguage = 'en';
    }
    if ($scope.service.hourly_rate) {
      $scope.priceType = "hourly";
    } else if ($scope.service.price) {
      $scope.priceType = "fixed";
    }
  }

  $scope.priceTypeClick = function (priceType) {
    if (priceType == "hourly") {
      $scope.service.price = null;
    } else if (priceType == "fixed") {
      $scope.service.hourly_rate = null;
    } else if (priceType == "none") {
      $scope.service.price = null;
      $scope.service.hourly_rate = null;
    }
    $scope.service.call_out_price = null;
  }

  $scope.setCategory = function (categoryId) {
    // $scope.service.category_id = categoryId;
    $scope.goBack();
  }

  $scope.$on("$ionicView.beforeEnter", $scope.init);


  $scope.getCategoryName = function (id) {
    return jobCategories.get(id).name;
  }

  $scope.getCategoryIcon = function (id) {
    return jobCategories.get(id).name;
  }

  var restUrl = "/services/photo-upload.json";

  $scope.currentPhoto = {};
  $scope.currentSlideIndex = 0;

  $scope.takePicture = function(sourceId, inputName) {
    var options = {
      sourceType: sourceId, //Camera.PictureSourceType.CAMERA
    };
    $scope.service.uploadingImg.push(true);
    Camera.uploadPhoto(options, restUrl, inputName)
      .then(function(fileName) {
        // Success! Image data is here
        $scope.service.photo_file_names.push(fileName);
        $scope.service.photoServerPathByName[fileName] = env.apiEndPoint + "/uploads/services/staging/" + fileName;
        $scope.service.photoThumbServerPathByName[fileName] = env.apiEndPoint + "/uploads/services/staging/thumb_" + fileName;
        $scope.currentSlideIndex = $scope.service.photo_file_names.length - 1;
      }, function(err) {
        console.log("upload Photo Error", err);
      })
      .finally(function(){
        $scope.service.uploadingImg.pop();
      });
  }

  $scope.jumpToSlide = function(index) {
    $scope.currentSlideIndex = index;
  }
  $scope.deleteImage = function(index) {
    _.pullAt($scope.service.photo_file_names, [index]);
    // $ionicSlideBoxDelegate.update();
    var jumpToIndex = index;
    if ($scope.service.photo_file_names.length == index && index != 0) {
      jumpToIndex = index - 1;
    }
    $scope.currentSlideIndex = jumpToIndex;
  }

  $scope.publish = function () {
    $scope.enablePublishBtn = false;
    if ($stateParams.id == 'new') {
      Service.save({service: $scope.service}).$promise.then(function (response) {
        // Service was nicely created
        $scope.goBack();
      }, function (response) {
        // Creating Service failed.
        console.log("Error creating service:", response);
      })
      .finally(function(){$scope.enablePublishBtn = true});

    } else {
      Service.update({service: $scope.service}).$promise.then(function (response) {
        // Service was nicely created
        $scope.goBack();
      }, function (response) {
        // Creating Service failed.
        console.log("Error updating service:", response);
      })
      .finally(function(){$scope.enablePublishBtn = true});
    };
    $rootScope.refreshCurrentUser = true;
  }

  $scope.deleteService  = function  () {
    var confirmPopup = $ionicPopup.confirm({
      title: gettextCatalog.getString('¿Estas seguro?'),
      template: 'Tus posibilidades de encotrar trabajo disminuiran. <br>¿Todavia quieres borrar tu servicio?',
      buttons: [
        { text: gettextCatalog.getString('Cancelar') },
        {
          text: gettextCatalog.getString('Sí, eliminar'),
          type: 'button-assertive',
          onTap: function(e) {
            //delete a service
            Service.delete({id: $stateParams.id}).$promise.then(function (response) {
                  // Service was nicely created
                  $rootScope.refreshCurrentUser = true;
                  $scope.goBack();
                }, function (response) {
              // Creating Service failed.
              console.log("Error deleting service:", response);
            })
            .finally(function(){});
              return true;
          }
        }
      ]
    });
  };
})

.controller('ServicePriceCtrl', function($scope) {
  $scope.$watch('service.price', function(newValue, oldValue) {
    if (newValue == null && typeof(oldVAlue) == "number") $scope.service.call_out_price = null;
  });
  $scope.$watch('service.hourly_rate', function(newValue, oldValue) {
    if (newValue == null && typeof(oldVAlue) == "number") $scope.service.call_out_price = null;
  });
})
.controller('ServiceViewCtrl', function($scope, $state, jobForm, service, jobCategories) {
  $scope.jobCategories = jobCategories;
  $scope.service = service;
})

.controller('CreateJobFromServiceCtrl', function($scope, $state, jobForm) {
  $scope.createJob = function(service) {
    jobForm.resetDraft();
    var job = jobForm.getDraft();
    console.log("fresh draft", job);
    job.service_id = service.id;
    console.log("modified draft", job);
    // $scope.job.category_id = service.category_id;
    $state.go('^.details', {jobCategoryID: service.category_id});
  }
})
;
