angular.module('starter.controllers')

.controller('SettingsCtrl', function($scope, $rootScope, $timeout, $state, $ionicHistory, $cordovaFacebook, $cordovaActionSheet, User, jobCategories, AuthService) {

  console.log("init settings ctrl");

  // $scope.$on("$ionicView.afterEnter", function () {
  //   console.log("scroll to right position");
  //   console.log("state params", $stateParams);
  //   $location.hash('push-msg-config');
  //   var delegate = $ionicScrollDelegate.$getByHandle('content');
  //   $timeout(function () {
  //     delegate.anchorScroll();
  //   }, 1);
  // });


  $scope.jobCategories = jobCategories.main();

  // AUTO-SAVE FUNCTION
  // http://adamalbrecht.com/2013/10/30/auto-save-your-model-in-angular-js-with-watch-and-debounce/

  var timeout = null;
  var saveInProgress = false;

  var saveFinished = function() { saveInProgress = false; };

  var updateUser = function() {
    if (saveInProgress==false && $rootScope.currentUser) {
      saveInProgress = true;
      var userData = {
        notify_new_jobs:  $rootScope.currentUser.notify_new_jobs,
        notify_cat_1:     $rootScope.currentUser.notify_cat_1,
        notify_cat_2:     $rootScope.currentUser.notify_cat_2,
        notify_cat_3:     $rootScope.currentUser.notify_cat_3,
        notify_cat_4:     $rootScope.currentUser.notify_cat_4,
        notify_cat_5:     $rootScope.currentUser.notify_cat_5,
        notify_cat_6:     $rootScope.currentUser.notify_cat_6,
        notify_cat_7:     $rootScope.currentUser.notify_cat_7,
        notify_cat_9:     $rootScope.currentUser.notify_cat_9,
        notification_radius:  $rootScope.currentUser.notification_radius,
        language:         $rootScope.currentUser.language,
      };
      $scope.setLanguage($rootScope.currentUser.language, false);
      console.log(JSON.stringify(userData));
      User.update(userData).$promise.finally(saveFinished);
    }
  }

  var debounceSaveUpdatesUser = function(newVal, oldVal) {
    console.log("debounce", newVal, oldVal);
    if (newVal != oldVal) {
      if (timeout) {
        $timeout.cancel(timeout)
      }
      timeout = $timeout(updateUser, 500);  // 500 = 0.5 seconds
    }
  };

  $scope.$watch('currentUser.notify_new_jobs', debounceSaveUpdatesUser)
  $scope.$watch('currentUser.notify_cat_1', debounceSaveUpdatesUser)
  $scope.$watch('currentUser.notify_cat_2', debounceSaveUpdatesUser)
  $scope.$watch('currentUser.notify_cat_3', debounceSaveUpdatesUser)
  $scope.$watch('currentUser.notify_cat_4', debounceSaveUpdatesUser)
  $scope.$watch('currentUser.notify_cat_5', debounceSaveUpdatesUser)
  $scope.$watch('currentUser.notify_cat_6', debounceSaveUpdatesUser)
  $scope.$watch('currentUser.notify_cat_7', debounceSaveUpdatesUser)
  $scope.$watch('currentUser.notify_cat_9', debounceSaveUpdatesUser)
  $scope.$watch('currentUser.notification_radius', debounceSaveUpdatesUser)
  $scope.$watch('currentUser.language', debounceSaveUpdatesUser)

  $scope.logout = function () {
    if ($scope.onDevice) {
      $cordovaFacebook.logout().then(
        function(success) {
          console.log("logout facebook success");
        // success
      }, function (error) {
        console.log("logout error", error);
        // error
      });
    }
    console.log("auth service logout");
    AuthService.logout().then(function () {
      $scope.setCurrentUser(null);
      $scope.$on("$ionicView.afterLeave", function () {
        $timeout(function () {
          $ionicHistory.clearCache();
          $ionicHistory.clearHistory();
        }, 0);
      });
      $state.go("tab.account");
    });
  };

    //ionicActionSheet for a choose lenguages
  $scope.chooseLanguage = function () {
    var lenguagesOptions = {
      title: 'Language / Idioma',
      buttonLabels: ['Español', 'English'],
      addCancelButtonWithLabel: 'Cancel',
      androidEnableCancelButton : true
    };
    // Show the action sheet
    document.addEventListener("deviceready", function () {
      $cordovaActionSheet.show(lenguagesOptions)
      .then(function(btnIndex) {
        if (btnIndex == 1) $rootScope.currentUser.language = "es";
        else if (btnIndex == 2) $rootScope.currentUser.language = "en";
      });
    }, false);
  };



});
