angular.module('starter.services')
.factory('Braintree', function($http, env, $q){

  var checkoutPath = env.apiEndPoint + "/braintree/checkout.json";
  var authorizeServiceBookingPath = env.apiEndPoint + "/braintree/authorize-service-booking.json";
  var clientTokenPath = env.apiEndPoint + "/braintree/client-token.json";
  var braintreeClientToken = "";

  return {

    getClientToken: function() {
      //var q = $q.defer();
      return $http.get(clientTokenPath, {});
      /*  .success(function(res){
          console.log("Braintree Client Token successfully obtained", res);
          braintreeClientToken = res.clientToken;
          return q.resolve(braintreeClientToken);
        })
        .error(function(){
          console.log("error obtaining braintree client token");
          return q.reject("");
        });
        return q.promise;*/
    },

    checkout: function(braintreeClientToken, number, expirationMonth, expirationYear, jobId) {
      var braintreeClient = new braintree.api.Client({clientToken: braintreeClientToken});
      var q = $q.defer();

      braintreeClient.tokenizeCard({number: number, expirationMonth: expirationMonth, expirationYear: expirationYear}, function (err, nonce) {
        $http.post(checkoutPath, {payment_method_nonce: nonce, job_id: jobId})
          .success(function() {
            console.log("checkout successfull");
            return q.resolve();
          })
          .error(function() {
            console.log("checkout error");
            return q.reject();
          });
      })
      return q.promise;
    },

    authorizeServiceBooking: function(braintreeClientToken, number, expirationMonth, expirationYear, jobId) {
      var braintreeClient = new braintree.api.Client({clientToken: braintreeClientToken});
      var q = $q.defer();

      braintreeClient.tokenizeCard({number: number, expirationMonth: expirationMonth, expirationYear: expirationYear}, function (err, nonce) {
        $http.post(authorizeServiceBookingPath, {payment_method_nonce: nonce, job_id: jobId})
          .success(function() {
            console.log("checkout successfull");
            return q.resolve();
          })
          .error(function() {
            console.log("checkout error");
            return q.reject();
          });
      })
      return q.promise;
    }

  }
});
