angular.module('starter.services')

.service('Camera', function($cordovaCamera, $http, $q, $cordovaFileTransfer, $ionicPlatform, env, Session) {
  console.log("Camera Init");
  var q = {};
  var options = {};

  $ionicPlatform.ready(function() {
    if (ionic.Platform.isAndroid() || ionic.Platform.isIOS()) {
     options = {
        quality: 75,
        destinationType : Camera.DestinationType.FILE_URI,
        sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
        allowEdit: false,
        encodingType: Camera.EncodingType.JPEG,
        targetWidth: 1080,
        targetHeight: 1080,
        popoverOptions: CameraPopoverOptions,
        saveToPhotoAlbum: true,
        correctOrientation: true
      };
    }
  });

  var uploadSuccess = function(successResponse){
    console.log("successResponse", successResponse);
    fileName = ''
    if (typeof(successResponse) == "string") {
      fileName = JSON.parse(successResponse).name;
    } else {
      fileName = successResponse.name
    }
    q.resolve(fileName);
  }

  var uploadError = function(errorResponse){
    console.log("upload Error", errorResponse);
    q.reject(errorResponse);
  }

  var uploadFileOnDevice = function(fileUrl, uploadUrl) {
    console.log("uploadFileOnDevice", fileUrl);
    var options = {
      fileKey: "file",
      fileName: "image.jpg",
      mimeType: "image/jpg",
      headers: {
        'X-User-Uuid': Session.uuid,
        'X-User-Token': Session.authentication_token,
        'Accept': 'application/x-jobmapp-api-v1+json'
      }
    }

    $cordovaFileTransfer
      .upload(uploadUrl, encodeURI(fileUrl), options)
      .then(
        function(resp){uploadSuccess(resp.response)},
        function(resp){uploadError(resp.response)},
        function(progr){
          console.log(progr)
        })
  }

  var uploadFileToUrl = function(file, uploadUrl, successCallback, errorCallback){
      var fd = new FormData();
      fd.append('file', file);
      // console.log('identity ', angular.identity());
      $http.post(uploadUrl, fd, {
          transformRequest: angular.identity,
          headers: {'Content-Type': undefined}
      })
      .success(successCallback)
      .error(errorCallback);
  }

  this.uploadPhoto = function(params, restUrl, inputName) {
    var ops = _.merge(options, params);
    console.log("uploadPhoto started", ops);
    var uploadUrl = encodeURI(env.apiEndPoint + restUrl);
    q = $q.defer();
    if (ionic.Platform.isAndroid() || ionic.Platform.isIOS()) {
      $cordovaCamera.getPicture(ops).then(function(imageData) {
          // Success! Image data is here
        console.log("success");
        uploadFileOnDevice(imageData, uploadUrl);
      }, function(err) {
        console.log("upload Photo Error", err); 
        q.reject(err);       
      });
    } else {
      console.log("in browser");
      var file = document.getElementsByName(inputName)[0].files[0];
      uploadFileToUrl(
        file,
        uploadUrl,
        uploadSuccess,
        uploadError
      );
      //$scope.showFileUpload = true;
    }
    return q.promise;
  }

 
});
