angular.module('starter.services')
.service('FacebookFriends', function($cordovaFacebook, $q, $timeout){

  var self = this;
  var onDevice = (ionic.Platform.isAndroid() || ionic.Platform.isIOS());

  this.list = [];
  this.totalCount = null;
  this.onJobMapp = null;

  this.init = function() {
    var q = $q.defer();
    var friendsSuccess = function(response) {
      var result = {};
      var picCounter = 0;
      self.list = response.data;
      if (response.summary && response.summary.total_count) {
        self.totalCount = response.summary.total_count;
      }
      self.onJobMapp = response.data.length;
      for (i = 0; i < self.list.length; i++) {
        self.list[i].pictureUrl = "https://graph.facebook.com/" + self.list[i].id + "/picture";
      }
      return q.resolve();
    };

    var friendsError = function(result) {
      console.log("friends error", result);
      return q.reject(result);
    };
               
    if (onDevice) {
      console.log("trying plugin request");
      facebookConnectPlugin.api("me/friends?limit=500", ["user_friends"], friendsSuccess, friendsError);
    } else {
      openFB.api({
        path: '/me/friends',
        success: friendsSuccess, 
        error: friendsError
      });
    }
    return q.promise;
  }
  return this;

});
