angular.module('starter.services')
.factory('FacebookStories', function($cordovaFacebook, $q){

  var self = this;
  var onDevice = (ionic.Platform.isAndroid() || ionic.Platform.isIOS());

  var link = "https://jobmapp.com";
  var name = "jobMapp";
  var appPageId = "395671277260201";

  return {

    fbFeed: function(fbText, fbImage) {
      var q = $q.defer();
      var fbPostSuccess = function() {
        return q.resolve();
      }
      var fbPostError = function() {
        return q.reject();
      }      
      if (onDevice) {
        var options = {
            method: "feed",
            link: link,
            caption: fbText,
            name: name,
            picture: fbImage
        };
        $cordovaFacebook.showDialog(options).then(fbPostSuccess, fbPostError);
      } else {
        openFB.api(
        {
            method: 'POST',
            path: '/me/feed',
            params: {
                message: fbText,
                link: link,
                name: name,
                picture: fbImage
            },
            success: function() {
              return q.resolve();
            },
            error: function() {
              return q.reject();
            }
        });   
      }       
      return q.promise;
    },

    fbShare: function(fbText, fbImage) {
      var q = $q.defer();
      var fbPostSuccess = function() {
        return q.resolve();
      }
      var fbPostError = function() {
        return q.reject();
      }      
      if (onDevice) {
        var options = {
            method: "share_open_graph",
            href: link,
            caption: fbText,
            name: name,
            picture: fbImage,
            action_type: 'og.likes',
            // action_properties: JSON.stringify({
            //       object:'https://jobmapp.com'
            // })
        };
        $cordovaFacebook.showDialog(options).then(fbPostSuccess, fbPostError);
      } else {
        openFB.api(
        {
            method: 'POST',
            path: '/me/feed',
            params: {
                message: fbText,
                link: link,
                name: name,
                picture: fbImage
            },
            success: function() {
              return q.resolve();
            },
            error: function() {
              return q.reject();
            }
        });   
      }       
      return q.promise;
    },

    fbSend: function(fbText, fbImage) {
      var q = $q.defer();
      var fbPostSuccess = function() {
        return q.resolve();
      }
      var fbPostError = function() {
        return q.reject();
      }      
      if (onDevice) {
        var options = {
            method: "send",
            link: link,
            caption: fbText,
            name: name,
            picture: fbImage,
        };
        $cordovaFacebook.showDialog(options).then(fbPostSuccess, fbPostError);
      } else {
        openFB.api(
        {
            method: 'POST',
            path: '/me/send',
            params: {
                message: fbText,
                link: link,
                name: name,
                picture: fbImage
            },
            success: function() {
              return q.resolve();
            },
            error: function() {
              return q.reject();
            }
        });   
      }       
      return q.promise;
    },

    fbLoginStatus: function() {
      var q = $q.defer();
      var loginStatusSuccess = function(result) {
        var fbLoginStatus = result.status;
        return q.resolve(fbLoginStatus);
      }
      var loginStatusError = function(result) {
        console.log("get facebook login status error", result);
        return q.reject(result);
      }            
      if (onDevice) {
        $cordovaFacebook.getLoginStatus().then(loginStatusSuccess, loginStatusError);
      } else {
        openFB.getLoginStatus(loginStatusSuccess, loginStatusError);
      }
      return q.promise;
    },

    likesAppPage: function() {
      var q = $q.defer();
      var success = function(result) {
        if (result.data.length > 0) var likes = true;
        else var likes = false;
        return q.resolve(likes);
      }
      var error = function(result) {
        console.log("get facebook login status error", result);
        return q.reject(result);
      }            
      if (onDevice) {
        $cordovaFacebook.api('/me/likes/' + appPageId).then(success, error);
      } else {
        openFB.api({
          path: '/me/likes/' + appPageId,
          success: success, 
          error: error
        });
      }
      return q.promise;
    },

    likeAppPage: function() {
      var q = $q.defer();
      var success = function(result) {
        console.log("success", result);
        // if (result.data.length > 0) var likes = true;
        // else var likes = false;
        return q.resolve(result);
      }
      var error = function(result) {
        console.log("facebook like status error", result);
        return q.reject(result);
      }            
      if (onDevice) {
        $cordovaFacebook.api('/me/og.likes?object=https://www.facebook.com/' + appPageId).then(success, error);
      } else {
        openFB.api({
          path: '/me/og.likes',
          params: {
            object: 'https://www.facebook.com/' + appPageId
          },
          success: success, 
          error: error
        });
      }
      return q.promise;
    }
  }
});
