angular.module('starter.services')

.factory('MessageRouter', function ($ionicTabsDelegate, $injector, $timeout, $rootScope, $ionicSideMenuDelegate, gettext) {

  var jobToaster = function (stateName, message) {
    // As we use the injector, we need to be creative, how to tell gettext about Strings.
    gettext('Nueva notificación');
    gettext('Abrir');

    var messageText = "";
    if (ionic.Platform.isAndroid()) {
      messageText = message.title + " " + message.message;
    } else {
      messageText = message.alert;
    }

    var hideSheet = $injector.get('$ionicActionSheet').show({
      buttons: [
        { text: $injector.get('gettextCatalog').getString('Abrir') },
      ],
      titleText: $injector.get('gettextCatalog').getString('Nueva notificación') + ': ' + messageText,
      //cancelText: 'Cancel',
      // cancel: function() {
      //      // add cancel code..
      //    },
      buttonClicked: function(index) {
        $timeout(function() {
          if (message.private_job_chat) {
            $rootScope.$broadcast('open-private-job-chat', {message: message, jobId: message.job_id, toId: message.from_id})
          } else if (message.notification_center) {
            $ionicSideMenuDelegate.toggleRight(true);
          } else {
            $injector.get('$state').go(stateName, {id: message.job_id});
          }
        }, 1);
        return true;
      }
    });

     // For example's sake, hide the sheet after two seconds
     $timeout(function() {
       hideSheet();
     }, 10000);

  }

  return {

    // This is platform independent` 
    resolve: function(message, foreground) {
      var currentState = $injector.get('$state').current.name;
      switch (message.notification_type){
        case "new_job":  // new job offer'
          if (message.job_id){
            if (currentState != "tab.searchjob.showjob") {
              if (foreground) {
                jobToaster("tab.searchjob.showjob", message);
              } else {
                $timeout(function() {
                  $injector.get('$state').go("tab.searchjob.showjob", {id: message.job_id, call: 'pushMsg'});      
                }, 1);
              }
            }
          }
          break;
        case "new_application": // new application for job
          $rootScope.$broadcast("new-notification");
          $rootScope.$broadcast("job-message-received");
          if (message.job_id){
            if (currentState != "tab.myjobs.selectjobber") {
              if (foreground) {
                jobToaster("tab.myjobs.selectjobber", message);
              } else {
                $timeout(function() {
                  $injector.get('$state').go("tab.myjobs.selectjobber", {id: message.job_id});
                }, 1);
              }
            }
          } 
          break;
        case "job_assignment": //job assignment
          $rootScope.$broadcast("new-notification");
          $rootScope.$broadcast("job-message-received");
          if (message.job_id){
            if (currentState != "tab.myjobs.applieddetails") {
              if (foreground) {
                jobToaster("tab.myjobs.applieddetails", message);
              } else {
                $timeout(function() {
                  $injector.get('$state').go("tab.myjobs.applieddetails", {id: message.job_id});
                }, 1);
              }
            }
          }
          break;
        case "message_at_created_job": //job assignment
          $rootScope.$broadcast("new-notification");
          $rootScope.$broadcast("job-message-received");
          if (message.job_id){
            if (message.private_job_chat) {
              if (foreground) {
                // Open a toast.
                $rootScope.$broadcast('open-private-job-chat', {message: message, jobId: message.job_id, jobToasterFn: jobToaster, toId: message.from_id});
              } else {
                // Open directly.
                $rootScope.$broadcast('open-private-job-chat', {jobId: message.job_id, toId: message.from_id});
              }
            } else if (currentState != "tab.myjobs.selectjobber") {
              if (foreground) {
                // Show the action sheet
                jobToaster("tab.myjobs.selectjobber", message);
              } else { 
                // directly jump to job
                $timeout(function() {
                  $injector.get('$state').go("tab.myjobs.selectjobber", {id: message.job_id});
                }, 1);
              }
            }
          }
          break;
        case "message_at_applied_job": //job assignment
          $rootScope.$broadcast("new-notification");
          $rootScope.$broadcast("job-message-received");
          if (message.job_id){
            if (message.private_job_chat) {
              if (foreground) {
                // Open a toast.
                $rootScope.$broadcast('open-private-job-chat', {message: message, jobId: message.job_id, jobToasterFn: jobToaster, toId: message.from_id});
              } else {
                // Open directly.
                $rootScope.$broadcast('open-private-job-chat', {jobId: message.job_id, toId: message.from_id});
              }
            } else if (currentState != "tab.myjobs.applieddetails") {
              if (foreground) {
                jobToaster("tab.myjobs.applieddetails", message);
              } else {
                $timeout(function() {
                  $injector.get('$state').go("tab.myjobs.applieddetails", {id: message.job_id});
                }, 1);            
              }
            }
          }
          break;
        case "message_at_confirmed_job":
          $rootScope.$broadcast("new-notification");
          if (message.job_id){
            // There can only be private job messages in "message_at_confirmed_job"
            if (message.private_job_chat) {
              if (foreground) {
                // Open a toast.
                $rootScope.$broadcast('open-private-job-chat', {message: message, jobId: message.job_id, jobToasterFn: jobToaster, toId: message.from_id});
              } else {
                // Open directly.
                $rootScope.$broadcast('open-private-job-chat', {jobId: message.job_id, toId: message.from_id});
              }
            } else if (currentState != "tab.myjobs.confirmedjob") {
              if (foreground) {
                jobToaster("tab.myjobs.confirmedjob", message);
              } else {
                $timeout(function() {
                  $injector.get('$state').go("tab.myjobs.confirmedjob", {id: message.job_id});
                }, 1);
              }
            } else {
              $rootScope.$broadcast("job-message-received");
            }
          }
          break;
        case "message_at_interested_job":
          $rootScope.$broadcast("new-notification");
          $rootScope.$broadcast("job-message-received");
          if (message.job_id){
            if (currentState != "tab.searchjob.showjob"){
              if (foreground) {
                jobToaster("tab.searchjob.showjob", message);
              } else {
                $timeout(function() {
                  $injector.get('$state').go("tab.searchjob.showjob", {id: message.job_id});
                }, 1);
              }
            }
          }
          break;
        default:
          $rootScope.$broadcast("new-notification");
          if (foreground) {
            message.notification_center = true;
            jobToaster("tab.myjobs.confirmedjob", message);
          } else {
            $timeout(function() {
              $ionicSideMenuDelegate.toggleRight(true);
            }, 1);
          }

      }
    }
  }
})
;