 angular.module('mlz.openurl', ['ionic'])
  .factory('OpenUrlService', function ($log, $location, $rootScope, $ionicHistory, $timeout, $state, $ionicLoading) {


    var setNextViewOptions = function() {
      $ionicHistory.nextViewOptions({
        historyRoot: true,
        disableBack: true,
        disableAnimation: true
      });
    }

    var openUrl = function (url) {

      // Stop it from caching the first view as one to return when the app opens

      if (url) {

        console.log("url subs", url.substr(10,4), url);
        var message = {};
        if (url.substr(10,5) == 'jobs/') {
          message.notification_type = 'new_job';
          message.job_id = parseInt(url.substr(15));
          $timeout(function() {
            setNextViewOptions();
            $state.go("tab.searchjob.showjob", {id: message.job_id, call: 'deepLink'});
          }, 1);
        } else if (url.substr(10,8) == 'jobbers/') {
          jobberId = parseInt(url.substr(18));
          console.log("jobber page deeplink", jobberId);
          $timeout(function() {
            setNextViewOptions();
            $state.go("tab.directory.jobberdetails", {candidateId: jobberId, call: 'deepLink'});
          }, 1);
        } else if (url.substr(10,10) == 'createjob/') {
          var jobCategoryID = parseInt(url.substr(20,1));
          var specialSubCategory = url.substr(22, 10);
          console.log("mensajeria deeplink", url, jobCategoryID, specialSubCategory);
          if (specialSubCategory == 'mensajeria') {
            specialSubCategory = 'ecoscooter';
            console.log("set ecoscooter job");
          }
          $timeout(function() {
            setNextViewOptions();
            $state.go("tab.createjob.details", {jobCategoryID: jobCategoryID, specialSubCategory: specialSubCategory});
          }, 1);
        }
        // } else if (url.substr(10,4) == 'open') {
        //   $ionicLoading.show({template: "Cargando parametros", hideOnStateChange: true, duration: 5000});
        //   var initParams = BranchIo.initParams();
        //   if (initParams.initSuccess) {
        //     if (initParams.job_id) {
        //       setNextViewOptions();
        //       console.log("state search job");
        //       $state.go("tab.searchjob.showjob", {id: initParams.job_id});
        //     } else if (initParams.jobber_id) {
        //       setNextViewOptions();
        //       console.log("state tab.directory.jobberdetails", initParams.jobber_id);
        //       $state.go("tab.directory.jobberdetails", {candidateId: initParams.jobber_id});
        //     } else if (initParams.referringUser) {
        //       setNextViewOptions();
        //       console.log("state account");
        //       $state.go("tab.account", {referringUser: initParams.referringUser});
        //     }
        //   } else {
        //     console.log("call init from OpenUrlService");
        //     BranchIo.init().then( function(res) {
        //       $ionicLoading.hide();
        //       console.log("res", res);
        //       if (res && res.job_id) {
        //         setNextViewOptions();
        //         console.log("state search job");
        //         $state.go("tab.searchjob.showjob", {id: res.job_id});
        //       } else if (res && res.jobber_id) {
        //         setNextViewOptions();
        //         console.log("state tab.directory.jobberdetails");
        //         $state.go("tab.directory.jobberdetails", {candidateId: res.jobber_id});
        //       } else if (res && res.referringUser) {
        //         setNextViewOptions();
        //         console.log("state account");
        //         $state.go("tab.account", {referringUser: res.referringUser});
        //       } else {
        //         console.log("get latest first params");
        //         BranchIo.getReferringParams();
        //       }
        //     });
        //   }
        // }

        window.cordova.removeDocumentEventHandler('handleurl');
        window.cordova.addStickyDocumentEventHandler('handleurl');
        document.removeEventListener('handleurl', handleOpenUrl);
      }

    };

    var handleOpenUrl = function (e) {
      // Check for the CustomEvent detail field for testing.
      // Difficult to trigger cordova events under test
      var url = e.url || e.detail.url;
      console.log("handleOpenUrl, event", e);
      openUrl(url);
    };

    var onResume = function () {
      console.log("onResume");
      document.addEventListener('handleurl', handleOpenUrl, false);
    };

    return {
      handleOpenUrl: handleOpenUrl,
      onResume: onResume
    };

  }).run(function (OpenUrlService) {
    if (OpenUrlService) {
      document.addEventListener('handleurl', OpenUrlService.handleOpenUrl, false);
      document.addEventListener('resume', OpenUrlService.onResume, false);
    }
  });
