angular.module('starter.services')
.factory('popupCheckPictures', function($ionicPopup, $q, gettextCatalog){

  return {

    open: function (job) {
      var q = $q.defer();

      // if there are no fotos with job and if job is not ecoscooter, open popup:

      if (!(job.photo_file_names && job.photo_file_names.length > 0 || job.specialSubCategory == 'ecoscooter')) {
        var myPopup = $ionicPopup.show(
          {
            template: '<p>' + gettextCatalog.getString('Fotos ayudan a explicar la tarea. Conseguirás un 50 % más solicitudes de jobbers.') + '</p>',
            title: gettextCatalog.getString('Publicar sin fotos?'),
            //scope: $scope,
            buttons: [
              { 
                text: gettextCatalog.getString('Sin fotos'),
                onTap: function(e) {
                  return true;
                }
              },
              {
                text: gettextCatalog.getString('Añadir fotos'),
                type: 'button-positive',
                onTap: function(e) {
                  return false;
                }
              }
            ]
          }
        );

        myPopup.then(function(publishAnyways) {
          if (publishAnyways) {
            q.resolve();
          } else {
            console.log("cancel publish")
            q.reject("Cancel publish and add pictures");
          }
        });

      // otherwise do not ask for fotos to add
      } else {
        q.resolve();
      }

      return q.promise;
    }
  }
});