angular.module('starter.services')

.factory('PushNotify', function ($rootScope, $cordovaMedia, $ionicTabsDelegate, MessageRouter, $timeout) {
  return {
    init: function() {
      var self = this;
      if (ionic.Platform.isAndroid() || ionic.Platform.isIOS()){
        console.log("init PushNotification", PushNotification, PushNotification.init);
        self.push = PushNotification.init({
          android: {
            senderID: "252538067553",
            icon: "icon_white_transparent",
            iconColor: "#5AB7B2"
          },
          ios: {
            alert: true,
            badge: true,
            sound: true
          }
        });

        // alert("start registering for push notifications.");
        self.push.on('registration', function(data) {
          console.log("on register", data);
          var token = data.registrationId;
          if ( token.length > 0 ) {
            if (ionic.Platform.isIOS()){
              window.localStorage.setItem("apns_device_token", token);
              $rootScope.$broadcast('apns_device_token-received');
            } else if (ionic.Platform.isAndroid()) {
              window.localStorage.setItem("gcm_device_token", token);
              $rootScope.$broadcast('gcm_device_token-received');
            }
          }
        });

        self.push.on("notification", function(data){
          console.log('push message', data);
          MessageRouter.resolve(data.additionalData, data.additionalData.foreground);
        })
      }
    }
    // ,

    // notificationEventHandler: function(notification) {
    //   // if this flag is set, this notification happened while we were in the foreground.
    //   // you might want to play a sound to get the user's attention, throw up a dialog, etc.

    //   // on Android soundname is outside the payload.
    //   // On Amazon FireOS all custom attributes are contained within payload
    //   // var soundfile = notification.soundname || notification.payload.sound;
    //   // if the notification contains a soundname, play it.
    //   // playing a sound also requires the org.apache.cordova.media plugin

    //   if (notification.foreground) {
    //     console.log('--INLINE NOTIFICATION--', notification);
    //     var my_media = $cordovaMedia.newMedia("/android_asset/www/sounds/blop.wav");
    //     my_media.play();
    //   } else { // otherwise we were launched because the user touched a notification in the notification tray.
    //     if (notification.coldstart)
    //       console.log('--COLDSTART NOTIFICATION--');
    //     else
    //       console.log('--BACKGROUND NOTIFICATION--');
    //   }
    // }
  }
});
