angular.module('starter.services')


.factory('Sharing', function ($cordovaActionSheet, $cordovaSocialSharing, $ionicLoading, Session) {

  var self = this;

  var shareOptions = {
      title: 'Invita tus amigos con...',
      buttonLabels: ['Facebook', 'WhatsApp', 'Otro (email, sms, ...)'],
      addCancelButtonWithLabel: 'Cancel',
      androidEnableCancelButton : true
//      winphoneEnableCancelButton : true,
//      addDestructiveButtonWithLabel : 'Delete it'
    };

  var shareOptionsFb = {
      title: 'Compartir jobMapp...',
      buttonLabels: ['Via mensaje a amigos', 'En tu muro'],
      addCancelButtonWithLabel: 'Cancel',
      androidEnableCancelButton : true
    };

  var loadingTemplate = "Compartir";

  this.shareAction = function(shareObject, optionsTitle) {
    if (optionsTitle) shareOptions.title = optionsTitle;
    console.log("shareOptions", shareOptions);
    $cordovaActionSheet.show(shareOptionsFb)
          .then(function(btnIndex) {
            console.log("share with ", btnIndex);
            if (btnIndex == 1) self.shareFacebook(shareObject);
            else if (btnIndex == 2) self.shareWhatsapp(shareObject);
            else if (btnIndex == 3) self.shareOthers(shareObject);
            else $ionicLoading.hide();
            console.log("Index", btnIndex);
          }, function(res) {console.log("Error:", res);});
  };

  this.shareActionFb = function(shareObject, optionsTitle) {
    if (optionsTitle) shareOptionsFb.title = optionsTitle;
    console.log("shareOptions", shareOptionsFb);
    $cordovaActionSheet.show(shareOptionsFb)
          .then(function(btnIndex) {
            console.log("share with ", btnIndex);
            if (btnIndex == 1) self.shareFacebookAppInvite();
            else if (btnIndex == 2) self.shareFacebook(shareObject);
            else $ionicLoading.hide();
            console.log("Index", btnIndex);
          }, function(res) {console.log("Error:", res);});
  };


  this.shareWhatsapp = function(shareObject) {
    if (ionic.Platform.isIOS()) {tempImage = null} else {tempImage = shareObject.shareImage;}
    console.log("goin to share: ", shareObject);
    $cordovaSocialSharing
        .shareViaWhatsApp(shareObject.shareSubject + " " + shareObject.shareMessage, tempImage, shareObject.shareLink) // Share via native share sheet
        .finally(function(result) {
          $ionicLoading.hide();
        });
  };

  this.shareFacebook = function(shareObject) {
    if (ionic.Platform.isAndroid()) {
      tempImage = null
    } else {
      tempImage = shareObject.shareImage;
    }
    console.log("shareObject", shareObject, tempImage);
    $cordovaSocialSharing
      .shareViaFacebook(shareObject.shareMessage, tempImage, shareObject.shareLink) // Share via native share sheet
      .finally(function(result) {
        $ionicLoading.hide();
      });
  };

  this.shareFacebookAppInvite = function(shareObject) {
    if (ionic.Platform.isAndroid()) {
      tempImage = null
    } else {
      tempImage = shareObject.shareImage;
    }
    var shareObject = {};
    shareObject.url = "https://jobmapp.com";
    shareObject.picture = "https://jobmapp.com/assets/jobmapp_fb_sillin_calle-746cafaf626531effc36099346b1b997.jpg";
    console.log("shareObject", shareObject, tempImage);
    
    facebookConnectPlugin.appInvite(shareObject, 
      function(res) {console.log("Success", res);}, 
      function(res) {console.log("Error", res);}
      );

    console.log("plugin called");

    // $cordovaSocialSharing
    //   .shareViaFacebook(shareObject.shareMessage, tempImage, shareObject.shareLink) // Share via native share sheet
    //   .finally(function(result) {
    //     $ionicLoading.hide();
    //   });
  };

  this.shareOthers = function(shareObject) {
    $cordovaSocialSharing
        .share(shareObject.shareMessage, shareObject.shareSubject, null, shareObject.shareLink) // Share via native share sheet
        .finally(function(result) {
          $ionicLoading.hide();
        });
  };

  return this;
})
;
